<?php
/**
*
* @package arcade
* @version $Id: common.php 2022 2012-03-20 16:20:21Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (!class_exists('arcade'))
{
	if (defined('ADMIN_START'))
	{
		arcade_default_set();
	}
	else if (!defined('USE_ARCADE_MENU'))
	{
		arcade_display_data('menu');
	}

	include($phpbb_root_path . 'arcade/includes/class.' . $phpEx);
	include($phpbb_root_path . 'arcade/includes/arcade.' . $phpEx);
}

if ((!class_exists('arcade_admin')) && (defined('IN_ADMIN') || defined('USE_ARCADE_ADMIN')))
{
	include($phpbb_root_path . 'arcade/includes/auth_admin.' . $phpEx);
	include($phpbb_root_path . 'arcade/includes/class_admin.' . $phpEx);
}

if (defined('IN_PHPBB_ARCADE'))
{
	if (!defined('IN_ADMIN') && !defined('USE_ARCADE_ADMIN'))
	{
		include($phpbb_root_path . 'arcade/includes/session.' . $phpEx);
		$arcade_session = new arcade_session();
		set_error_handler('arcade_msg_handler');
	}

	include($phpbb_root_path . 'arcade/includes/functions_files.' . $phpEx);
	$file_functions = new file_functions();

	if (!function_exists('get_user_avatar') || !function_exists('get_user_rank'))
	{
		include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
	}
}
else
{
	$arcade = (!defined('IN_ADMIN') && !defined('USE_ARCADE_ADMIN')) ? new arcade(false, false) : new arcade_admin();
}

?>