<?php
/**
*
* @package arcade
* @version $Id: games.php 1953 2012-03-10 13:03:18Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB') || !defined('IN_PHPBB_ARCADE'))
{
	exit;
}

make_arcade_jumpbox($arcade->url(), $cat_id);

$sort_key	= request_var('sk', (!empty($user->data['games_sort_order']) && !$arcade_config['override_user_sort']) ? $user->data['games_sort_order'] : $arcade_config['games_sort_order']);
$sort_dir	= request_var('sd', (!empty($user->data['games_sort_dir']) && !$arcade_config['override_user_sort']) ? $user->data['games_sort_dir'] : $arcade_config['games_sort_dir']);

$limit_days = array();
$sort_by_text = array('f' => $user->lang['ARCADE_GAMES_SORT_FIXED'], 'd' => $user->lang['ARCADE_GAMES_SORT_INSTALLDATE'], 'n' => $user->lang['ARCADE_GAMES_SORT_NAME'], 'p' => $user->lang['ARCADE_GAMES_SORT_PLAYS'], 'r' => $user->lang['ARCADE_GAMES_SORT_RATING']);
$sort_by_sql = array('f' => 'game_order', 'd' => 'game_installdate', 'n' => 'game_name_clean', 'p' => 'game_plays', 'r' => 'game_votesum / game_votetotal');

$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

$sql_array = array(
	'SELECT'	=> 'g.game_id, g.game_image, g.game_highscore, g.game_highdate, g.game_highuser, g.game_name, g.game_name_clean, g.game_swf,
					g.game_type, g.game_width, g.game_height, g.game_filesize, g.game_plays, g.game_download_total, g.game_download, g.game_installdate,
					g.game_cost, g.game_reward, g.game_use_jackpot, g.game_jackpot, g.cat_id, g.game_desc, g.game_votesum, g.game_votetotal, g.game_download_cost,
					c.cat_name, c.cat_download, c.cat_cost, c.cat_reward, c.cat_use_jackpot, c.cat_status, c.cat_download_cost,
					u.username, u.user_colour, u.user_id,
					s.score, s.score_date,
					r.game_rating',
	'FROM'		=> array(
		ARCADE_GAMES_TABLE	=> 'g',
	),
	'LEFT_JOIN'	=> array(
		array(
			'FROM'	=> array(USERS_TABLE => 'u'),
			'ON'	=> 'g.game_highuser = u.user_id'
		),
		array(
			'FROM'	=> array(ARCADE_SCORES_TABLE => 's'),
			'ON'	=> 's.game_id = g.game_id AND s.user_id = ' . (int) $user->data['user_id']
		),
		array(
			'FROM'	=> array(ARCADE_RATING_TABLE => 'r'),
			'ON'	=> 'r.game_id = g.game_id AND r.user_id = ' . (int) $user->data['user_id']
		),
		array(
			'FROM'	=> array(ARCADE_CATS_TABLE => 'c'),
			'ON'	=> 'g.cat_id = c.cat_id'
		),
	),
	'ORDER_BY'	=> $sql_sort,
);
// END building the query need for this page
$games_per_page = (!empty($user->data['games_per_page'])) ? $user->data['games_per_page'] : $arcade_config['games_per_page'];

switch($mode)
{
	// Setup to display all the users favorite games
	case 'fav':
		// Set the link to the main statistics page in the nav
		$template->assign_var('S_IN_FAV', true);

		$template->assign_block_vars('navlinks', array(
			'FORUM_NAME'		=> $user->lang['ARCADE_FAV'],
			'U_VIEW_FORUM'		=> $arcade->url("mode=fav")));

		$total_games = $arcade->get_total('fav', $user->data['user_id']);
		if (!$total_games)
		{
			trigger_error($user->lang['ARCADE_NO_GAME_FAVS'] . $arcade->back_link());
		}

		$cat_id = ARCADE_FAV_ID;
		$sql_array['LEFT_JOIN'][] = array('FROM' => array(ARCADE_FAVS_TABLE => 'f'),	'ON' => 'f.game_id = g.game_id AND f.user_id = ' . $user->data['user_id']);
		$sql_array['WHERE'] = 'f.game_id = g.game_id
			AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true);
		$pagination_mode = 'mode=fav';
		$page_title = $user->lang['ARCADE_FAV'];
	break;

	// Setup to display search results
	case 'search':
		if (!$auth_arcade->acl_get('u_arcade_search'))
		{
			trigger_error($user->lang['ARCADE_NO_PERMISSION_SEARCH'] . $arcade->back_link());
		}
		// Set the link to the main statistics page in the nav
		$template->assign_var('S_IN_SEARCH', true);

		$template->assign_block_vars('navlinks', array(
			'FORUM_NAME'	=> $user->lang['ARCADE_SEARCH'],
			'U_VIEW_FORUM'	=> $arcade->url()));

		$cat_id = ARCADE_SEARCH_ID;

		if ($search_id == 'newgames')
		{
			$template->assign_var('S_IN_SEARCH_NEW_GAMES', true);
			$new_games_delay = (time() - ($arcade_config['new_games_delay'] * 86400));
			$total_games = $arcade->get_total('search_newgames', $new_games_delay);
			if (!$total_games)
			{
				trigger_error($user->lang['ARCADE_SEARCH_NO_MATCHES'] . $arcade->back_link());
			}

			$user->add_lang('search');

			$sql_array['WHERE'] = 'g.game_installdate >= ' . (int) $new_games_delay . '
									AND ' . $db->sql_in_set('g.cat_id', $arcade->games_search_protection(), true, true) . '
									AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true);
			$pagination_mode = 'mode=search&amp;search_id=newgames';
			$page_title =  sprintf($user->lang['ARCADE_SEARCH_RESULTS_FOR'], strtolower($user->lang['ARCADE_SEARCH_NEW_GAMES']));
			$search_matches = ( $total_games == 1 ) ? sprintf($user->lang['FOUND_SEARCH_MATCH'], $arcade->number_format($total_games)) : sprintf($user->lang['FOUND_SEARCH_MATCHES'], $arcade->number_format($total_games));

		}
		else
		{
			$user->add_lang('search');

			// Check search flood control
			$interval = ($user->data['user_id'] == ANONYMOUS) ? $arcade_config['search_anonymous_interval'] : $arcade_config['search_interval'];
			if ($interval && !$auth_arcade->acl_get('u_arcade_ignoreflood_search') && $user->data['user_arcade_last_search_term'] != $term)
			{
				$time = intval(time() - $interval);
				if ($user->data['user_arcade_last_search'] > $time)
				{
					trigger_error(sprintf($user->lang['ARCADE_NO_SEARCH_TIME'], $arcade->time_format($interval, true), $arcade->time_format($user->data['user_arcade_last_search'] - $time, true)) . $arcade->back_link());
				}

				$sql_ary = array(
					'user_arcade_last_search'		=> time(),
					'user_arcade_last_search_term'	=> $term,
				);

				$sql = 'UPDATE ' . ARCADE_USERS_TABLE . '
					SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
					WHERE user_id = ' . (int) $user->data['user_id'];
				$db->sql_query($sql);
			}

			$searchterm = "*". strtolower($term) . "*";
			if ($searchterm != "**")
			{
				// replace wildcards
				$searchterm = str_replace("*", $db->any_char , $searchterm);
				$searchterm = str_replace("?", $db->one_char , $searchterm);
			}

			$total_games = $arcade->get_total('search', $searchterm);
			if (!$total_games)
			{
				trigger_error($user->lang['ARCADE_SEARCH_NO_MATCHES'] . $arcade->back_link());
			}

			$sql_array['WHERE'] = '(g.game_name_clean ' . $db->sql_like_expression($searchterm) . '
				OR LOWER(g.game_desc) ' . $db->sql_like_expression($searchterm) . ')
				AND ' . $db->sql_in_set('g.cat_id', $arcade->games_search_protection(), true, true) . '
				AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true);
			$pagination_mode = 'mode=search&amp;term=' . $term;
			$page_title =  sprintf($user->lang['ARCADE_SEARCH_RESULTS_FOR'], $term);
			$search_matches = ($total_games == 1) ? sprintf($user->lang['FOUND_SEARCH_MATCH'], $arcade->number_format($total_games)) : sprintf($user->lang['FOUND_SEARCH_MATCHES'], $arcade->number_format($total_games));
		}

		$template->assign_vars(array(
			'S_FOUND_RESULTS'	=> true,
			'SEARCH_TERM'		=> ($search_id == 'newgames') ? $user->lang['ARCADE_SEARCH_NEW_GAMES'] : $term,
			'SEARCH_MATCHES'	=> $search_matches)
		);
	break;

	// Setup to display games inside specific category
	case 'cat':
	case 'view_cat_stats':
		$cat_data = $arcade->cats[$cat_id];

		if (!$cat_data)
		{
			trigger_error($user->lang['NO_CAT_ID'] . $arcade->back_link());
		}

		// Permissions check
		if (!$auth_arcade->acl_gets('c_list', 'c_view', $cat_id) || ($cat_data['cat_type'] == ARCADE_LINK && $cat_data['cat_link'] && !$auth_arcade->acl_get('c_view', $cat_id)))
		{
			if ($user->data['user_id'] != ANONYMOUS)
			{
				trigger_error($user->lang['NO_PERMISSION_ARCADE_VIEW'] . $arcade->back_link());
			}

			login_box('', $user->lang['LOGIN_VIEWARCADE']);
		}

		if (!empty($cat_data['cat_games_per_page']) && empty($user->data['games_per_page']))
		{
			$games_per_page = $cat_data['cat_games_per_page'];
		}

		// Change category style if needed
		if ($cat_data['cat_style'])
		{
			$user_style = (!$config['override_user_style']) ? $user->data['user_style'] : $config['default_style'];
			if ($user_style != $cat_data['cat_style'])
			{
				$user->setup('', $cat_data['cat_style']);
			}
		}

		// Is this forum a link? ... User got here either because the
		// number of clicks is being tracked or they guessed the id
		if ($cat_data['cat_type'] == ARCADE_LINK && $cat_data['cat_link'])
		{
			// Does it have click tracking enabled?
			if ($cat_data['cat_flags'] & ARCADE_FLAG_LINK_TRACK)
			{
				$sql = 'UPDATE ' . ARCADE_CATS_TABLE . '
						SET cat_plays = cat_plays + 1
						WHERE cat_id = ' . (int) $cat_id;
				$db->sql_query($sql);
			}
			$arcade_cache->destroy('sql', ARCADE_CATS_TABLE);

			redirect($cat_data['cat_link']);
		}

		if ($mode == 'view_cat_stats')
		{
			$cat_data['view_stats'] = 1;
		}

		// Build navigation links
		generate_arcade_nav($cat_data);
		if ($auth_arcade->acl_get('c_view', $cat_id))
		{
			generate_cat_rules($cat_data);
		}

		// age verify
		if ($cat_data['cat_age'])
		{
			$arcade->verify_age('cat', $cat_data['cat_age']);
		}

		// Category is passworded ... check whether access has been granted to this
		// user this session, if not show login box
		if ($cat_data['cat_password'])
		{
			login_arcade_box($cat_data);
		}

		$pag_mode = "mode=view_cat_stats&amp;c=$cat_id" . (($u_sort_param != '') ? "&amp;$u_sort_param" : '') . (($start) ? "&amp;start=$start" : '');
		$template->assign_var('U_CATEGORY_STATS', ($auth_arcade->acl_get('u_arcade_viewstats')) ? $arcade->url($pag_mode) . '#cats_top' : false);

		display_arcade($cat_data);
		gen_arcade_auth_level($cat_id, $cat_data['cat_status']);

		if ($cat_data['cat_test'])
		{
			$template->assign_var('S_ARCADE_CAT_TEST_MODE', true);
		}

		$sql_array['WHERE'] = 'g.cat_id = ' . (int) $cat_id;
		$pagination_mode = 'mode=cat&amp;c=' . (int) $cat_id;
		$page_title = ($mode == 'view_cat_stats') ? sprintf($user->lang['ARCADE_CAT_STATS'], $cat_data['cat_name']) : $cat_data['cat_name'];

		// This is needed to determine where we are
		// when we are done playing a game and want
		// to return the same category page we were on
		$found_game = false;
		if ($game_id)
		{
			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrowset($result);
			$db->sql_freeresult($result);

			$total_games = sizeof($row);
			$prev_games = 0;
			foreach ($row as $game)
			{
				if ($game['game_id'] == $game_id)
				{
					$found_game = true;
					break;
				}
				$prev_games++;
			}

			if ($found_game)
			{
				$start = floor(($prev_games) / $games_per_page) * $games_per_page;
			}
		}

		if (!$game_id || !$found_game)
		{
			$total_games = $arcade->get_total('games', $cat_id);
		}

	break;

	default:
	break;
}

// Get the favorite games data for the current user...
$game_fav_data = $arcade->get_fav_data();

if ($start >= $total_games)
{
	$start = $total_games - $games_per_page;
}
$start = ($start < 0) ? 0 : $start;

display_arcade_header('arcade', $arcade_config['welcome_cats'], $arcade_config['search_cats'], $arcade_config['links_cats']);

if ($auth_arcade->acl_get('u_arcade_view_whoisplaying'))
{
	display_arcade_online();
}

// Output page
page_header($user->lang['ARCADE'] . ' - ' . $page_title, false);

$template->set_filenames(array(
	'body' => 'arcade/index_body.html')
);

$template->assign_vars(array(
	'CAT_IMG'				=> $user->img('forum_read', 'NO_NEW_GAMES'),
	'CAT_NEW_IMG'			=> $user->img('forum_unread', 'NEW_GAMES'),
	'CAT_LOCKED_IMG'		=> $user->img('forum_read_locked', 'NEW_GAMES_LOCKED'),
	'CAT_NEW_LOCKED_IMG'	=> $user->img('forum_unread_locked', 'NO_NEW_GAMES_LOCKED'),
));

// Not category with games
if (isset($cat_data) && $cat_data['cat_type'] != ARCADE_CAT_GAMES)
{
	page_footer();
}

// Ok, if someone has only list-access, we only display the category list.
// We also make this circumstance available to the template in case we want to display a notice. ;)
if (!$auth_arcade->acl_get('c_view', $cat_id) && $cat_id != ARCADE_FAV_ID && $cat_id != ARCADE_SEARCH_ID)
{
	$template->assign_vars(array(
		'S_NO_VIEW_ACCESS' => true,
	));

	page_footer();
}

$template->assign_vars(array(
	'S_IN_GAMES'			=> (isset($cat_data['cat_type']) && $cat_data['cat_type'] == ARCADE_CAT_GAMES) ? true : false,
	'S_SELECT_SORT_DIR'		=> $s_sort_dir,
	'S_SELECT_SORT_KEY'		=> $s_sort_key,
	'S_ARCADE_ACTION'		=> $arcade->url("$pagination_mode&amp;start=$start")
));

if ($total_games)
{
	$time = time();
	$sql = $db->sql_build_query('SELECT', $sql_array);
	$result = $db->sql_query_limit($sql, $games_per_page, $start);

	// Display the need games...
	if ($row = $db->sql_fetchrow($result))
	{
		do
		{
			$game_width = $game_height = 0;
			$arcade->set_game_size($game_width, $game_height, $row['game_width'], $row['game_height'], $row['game_swf']);
			$row['game_width']	= $game_width;
			$row['game_height']	= $game_height;
			$image_title = $row['game_name'] . ' (' . (($row['game_filesize'] > 0 ) ? get_formatted_filesize($row['game_filesize']) : get_formatted_filesize($arcade->set_filesize($row['game_id']))) . ')';

			$gamesrow = array(
				'S_CAN_REPORT'			=> ($auth_arcade->acl_get('c_report', $row['cat_id'])) ? true : false,
				'S_CAN_DOWNLOAD'		=> ($row['cat_download'] && $row['game_download'] && $auth_arcade->acl_get('u_arcade_download') && $auth_arcade->acl_get('c_download', $row['cat_id'])) ? true : false,
				'S_GAME_PLAY'			=> ($row['cat_status'] == ITEM_UNLOCKED && $auth_arcade->acl_get('c_play', $row['cat_id'])) ? true : false,
				'S_GAME_HIGHSCORE'		=> ($row['game_highdate'] > 0) ? true : false,
				'S_GAME_SCORE'			=> ($row['score'] != '') ? true : false,
				'S_USE_HIGHSCORES'		=> ($row['game_type'] != NOSCORE_GAME) ? true : false,
				'S_HIDDEN_HIGHSCORE'	=> ($row['game_highdate'] > 0 && $arcade->hidden_score($row['game_id'], $row['game_highuser'])) ? true : false,
				'S_NEW_GAME'			=> ($search_id != 'newgames' && intval($time - $row['game_installdate']) <= intval($arcade_config['new_games_delay'] * 86400)) ? true : false,

				'CAT_ID'				=> $row['cat_id'],
				'CAT_NAME'				=> $row['cat_name'],
				'U_CAT'					=> $arcade->url("mode=cat&amp;c={$row['cat_id']}"),

				'GAME_ID'				=> $row['game_id'],
				'GAME_NAME'				=> get_arcade_game_name($row['game_name'], true, 'play', $row['cat_id'], $row['game_id'], '', censor_text(nl2br($row['game_desc']))),
				'GAME_IMAGE'			=> ($arcade->optionget('view_game_image')) ? get_arcade_game_image($row['game_image'], 50, 50, $image_title, 'play', $row['cat_id'], $row['game_id']) : false,
				'GAME_PLAYS'			=> ($row['game_plays']) ? sprintf($user->lang['ARCADE_TIMES_PLAYED'], $arcade->number_format($row['game_plays'])) : false,
				'GAME_DOWNLOAD'			=> ($row['game_download_total']) ? sprintf($user->lang['ARCADE_TIMES_DOWNLOADED'], $arcade->number_format($row['game_download_total'])) : false,
				'GAME_PLAY_POPUP'		=> get_arcade_game_popup('link', $row['cat_id'], $row['game_id'], $row['game_width'], $row['game_height']),

				'U_GAME_PLAY'			=> $arcade->url("mode=play&amp;g={$row['game_id']}"),
				'U_GAME_DOWNLOAD'		=> $arcade->url("mode=download&amp;g={$row['game_id']}"),
				'U_GAME_HIGHSCORES'		=> $arcade->url("mode=stats&amp;g={$row['game_id']}"),
				'U_GAME_REPORT'			=> $arcade->url("mode=report&amp;g={$row['game_id']}"),
				'U_GAME_EDIT'			=> ($auth->acl_get('a_arcade_game') && !empty($user->data['is_registered'])) ? $arcade->url("i=arcade_manage&amp;mode=games&amp;action=edit&amp;g={$row['game_id']}", "adm/index", $user->session_id) : '',
				'U_SCORE_EDIT'			=> ($auth->acl_get('a_arcade_user') && $row['game_plays'] && !empty($user->data['is_registered'])) ? $arcade->url("i=arcade_manage&amp;mode=users&amp;action=show_scores&amp;g={$row['game_id']}", "adm/index", $user->session_id) : '',

				'GAME_RATING_IMG'		=> $arcade->set_rating_image($row, $mode),
				'GAME_FAV_IMG'			=> (is_array($game_fav_data) && $auth_arcade->acl_get('c_play', $row['cat_id'])) ? $arcade->set_fav_image($game_fav_data, $row['game_id'], $mode) : '',

				'GAME_HIGHSCORE'		=> $arcade->number_format($row['game_highscore']),
				'GAME_HIGHUSER'			=> ($row['game_highuser']) ? get_arcade_user_name('full', $row['game_highuser'], $row['username'], $row['user_colour'], 'arcade', 'x') : '',
				'GAME_HIGHDATE'			=> $user->format_date($row['game_highdate']),

				'PERSONAL_HIGHSCORE'	=> $arcade->number_format($row['score']),
				'PERSONAL_HIGHDATE'		=> $user->format_date($row['score_date']),
				'GAME_IMAGE_FIRST'		=> ($row['game_highuser'] == $user->data['user_id'] ) ? $arcade->get_image('full', 'img', '1st.gif', $user->lang['ARCADE_FIRST'], false, 'vertical-align: middle;') : '' ,
			);

			if ($arcade->points['show'])
			{
				$game_cost = $arcade->get_cost($row);
				$game_reward = $arcade->get_reward($row);
				$game_download_cost = $arcade->get_download_cost($row);

				$gamesrow = array_merge($gamesrow, array(
					'S_SHOW_POINTS'	=> ($arcade->points['show']) ? true : false,
					'S_USE_JACKPOT'	=> ($arcade->use_jackpot($row)) ? true : false,

					'GAME_COST'		=> ($game_cost == ARCADE_FREE || $auth_arcade->acl_get('c_playfree', $row['cat_id'])) ? $user->lang['ARCADE_FREE'] : $arcade->number_format($game_cost) . ' ' . $arcade->points['name'],
					'GAME_REWARD'	=> ($game_reward == ARCADE_FREE) ? $user->lang['ARCADE_NONE'] : $arcade->number_format($game_reward) . ' ' . $arcade->points['name'],
					'DOWNLOAD_COST'	=> ($game_download_cost != ARCADE_FREE && !$auth_arcade->acl_get('c_downloadfree', $row['cat_id'])) ? $arcade->number_format($game_download_cost) . ' ' . $arcade->points['name'] : ''
				));
			}

			$template->assign_block_vars('games', $gamesrow);
		}
		while ($row = $db->sql_fetchrow($result));
	}
	$db->sql_freeresult($result);

	$pagination_mode = $pagination_mode . (($u_sort_param != '') ? "&amp;$u_sort_param" : '');

	$template->assign_vars(array(
		'PAGE_NUMBER'	=> ($games_per_page > 0) ? on_page($total_games, $games_per_page, $start) : on_page($total_games, $total_games, $start),
		'TOTAL_GAMES'	=> ($total_games > 0) ? $total_games . ' ' . $user->lang['ARCADE_GAME' . (($total_games > 1) ? 'S' : '')] : false,
		'PAGINATION'	=> ($games_per_page > 0) ? generate_pagination($arcade->url($pagination_mode), $total_games, $games_per_page, $start) : false,
		'NEW_GAME_IMG'	=> ($total_games) ? $arcade->get_image('full', 'img', 'new_game.gif', $user->lang['NEW_GAME']) : ''
	));
}

// Assign index specific vars
$template->assign_var('S_DISPLAY_AUTH_INFO', ($mode == 'cat' && $cat_data['cat_type'] == ARCADE_CAT_GAMES && ($auth_arcade->acl_get('c_play', $cat_id) || $user->data['user_id'] == ANONYMOUS)) ? true : false);

page_footer();

?>