<?php
/**
*
* @package arcade
* @version $Id: reports.php 1918 2012-03-04 00:37:21Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB') || !defined('IN_PHPBB_ARCADE'))
{
	exit;
}

$row = $arcade->get_game_cat_data($game_id);

if (empty($row['game_id']))
{
	trigger_error($user->lang['NO_GAME_ID'] . $arcade->back_link());
}

$back_link = ($type == 'challenge' && $challenge_id) ? $arcade->back_link('mode=challenge', 'challenge') : $arcade->return_links($row);

if (!$auth_arcade->acl_get('c_report', $row['cat_id']))
{
	trigger_error($user->lang['NO_PERMISSION_ARCADE_REPORT'] . $back_link);
}

if (in_array($row['game_id'], $arcade->obtain_report_games()))
{
	$message = $user->lang['ARCADE_GAME_ALREADY_REPORTED'];

	if ($type == 'challenge' && $challenge_id)
	{
		$message .= '<br /><br />' . $user->lang['ARCADE_DELETE_ALREADY_REPORTED_CHALLENGE'] . '<br />' . implode('<br />', $challenge->report($challenge_id)) . $back_link;
	}
	else
	{
		$message .= $back_link;
	}

	trigger_error($message);
}

	$form_key = 'arcade_report';
	add_form_key($form_key);
	generate_arcade_nav($row, true);

	$template->assign_block_vars('navlinks', array(
		'FORUM_NAME'	=> $user->lang['ARCADE_REPORT'],
		'U_VIEW_FORUM'	=> $arcade->url("mode=report&amp;g=$game_id")
	));

	$user->add_lang('posting');

	$submit = (isset($_POST['submit']))  ? true : false;

	if ($submit)
	{
		if (!check_form_key($form_key))
		{
			trigger_error($user->lang['FORM_INVALID'] . $back_link);
		}

		$enable_bbcode	= ($arcade_config['parse_bbcode']) ? ((request_var('disable_bbcode', false)) ? false : true) : false;
		$enable_smilies	= ($arcade_config['parse_smilies']) ? ((request_var('disable_smilies', false)) ? false : true) : false;
		$enable_urls	= ($arcade_config['parse_links']) ? ((request_var('disable_magic_url', false)) ? false : true) : false;

		$report_data = array(
			'report_type'		=> request_var('report_type', 0),
			'report_desc'		=> utf8_normalize_nfc(request_var('message', '', true)),
			'report_desc_bitfield'	=> '',
			'report_desc_options'	=> 0,
			'report_desc_uid'		=> '',
			'report_time'			=> time(),
			'game_id'				=> (int) $row['game_id'],
			'user_id'				=> (int) $user->data['user_id'],
			'report_ip'				=> $user->ip
		);

		generate_text_for_storage($report_data['report_desc'], $report_data['report_desc_uid'], $report_data['report_desc_bitfield'], $report_data['report_desc_options'], $enable_bbcode, $enable_urls, $enable_smilies);

		$message = sprintf($user->lang['ARCADE_REPORT_ADDED'], $row['game_name']);

		if ($type == 'challenge' && $challenge_id)
		{
			$message .= '<br /><br />' . $user->lang['ARCADE_DELETE_REPORTED_CHALLENGE'] . '<br />' . implode('<br />', $challenge->report($challenge_id));
		}

		$db->sql_query('INSERT INTO ' . ARCADE_REPORTS_TABLE . ' ' . $db->sql_build_array('INSERT', $report_data));

		$arcade->set_config('reports_open', ($arcade_config['reports_open'] + 1));
		$arcade_cache->destroy('sql', ARCADE_REPORTS_TABLE);

		$template->assign_vars(array(
			'S_ARCADE_REPORT_ADD'	=> true,
			'MESSAGE_TITLE'			=> $user->lang['ARCADE_REPORT_SUCCESS'],
			'MESSAGE_TEXT'			=> $message,
			'ARCADE_RETURN_LINKS'	=> ($type == 'challenge' && $challenge_id) ? $back_link : $arcade->return_links($row, false)
		));
	}
	else
	{
		$enable_bbcode	= ($arcade_config['parse_bbcode']) ? (bool) $arcade->optionget('bbcode') : false;
		$enable_smilies	= ($arcade_config['parse_smilies']) ? (bool) $arcade->optionget('smilies') : false;
		$enable_urls	= ($arcade_config['parse_links']) ? true : false;
		$enable_img		= false;
		$enable_flash	= false;
		$enable_qoute	= false;

		if ($enable_smilies)
		{
			// Generate smiley listing
			if (!function_exists('generate_smilies'))
			{
				include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
			}

			generate_smilies('inline', false);
		}

		if ($enable_bbcode)
		{
			// Build custom bbcodes array
			if (!function_exists('display_custom_bbcodes'))
			{
				include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
			}

			display_custom_bbcodes();
		}

		$s_hidden_fields = build_hidden_fields(array(
			'mode'	=> 'report',
			'type'	=> $type,
			'cid'	=> $challenge_id,
			'g'		=> $row['game_id'],
		));

		$arcade_report_type_select = '
			<select id="report_type" name="report_type">
				<option value="' . ARCADE_REPORT_SCORING . '" selected="selected">' . $user->lang['ARCADE_REPORT_SCORING'] . '</option>
				<option value="' . ARCADE_REPORT_PLAYING . '">' . $user->lang['ARCADE_REPORT_PLAYING'] . '</option>
				<option value="' . ARCADE_REPORT_DOWNLOADING . '">' . $user->lang['ARCADE_REPORT_DOWNLOADING'] . '</option>
				<option value="' . ARCADE_REPORT_OTHER . '">' . $user->lang['ARCADE_REPORT_OTHER'] . '</option>
			</select>';

		$template->assign_vars(array(
			'S_ACTION'					=> $arcade->url(),
			'S_HIDDEN_FIELDS'			=> $s_hidden_fields,

			'S_BBCODE_ALLOWED'			=> $enable_bbcode,
			'S_SMILIES_ALLOWED'			=> ($enable_smilies) ? true : false,
			'S_LINKS_ALLOWED'			=> $enable_urls,

			'S_BBCODE_QUOTE'			=> $enable_qoute,
			'S_BBCODE_FLASH'			=> $enable_flash,
			'S_BBCODE_IMG'				=> $enable_img,

			'BBCODE_STATUS'				=> sprintf($user->lang['BBCODE_IS_' . (($enable_bbcode) ? 'ON' : 'OFF')], '<a href="' . append_sid("{$phpbb_root_path}faq.$phpEx", 'mode=bbcode') . '">', '</a>'),
			'IMG_STATUS'				=> $user->lang['IMAGES_ARE_' . (($enable_img) ? 'ON' : 'OFF')],
			'FLASH_STATUS'				=> $user->lang['FLASH_IS_' . (($enable_flash) ? 'ON' : 'OFF')],
			'SMILIES_STATUS'			=> $user->lang['SMILIES_ARE_' . (($enable_smilies) ? 'ON' : 'OFF')],
			'URL_STATUS'				=> $user->lang['URL_IS_' . (($enable_urls) ? 'ON' : 'OFF')],

			'ARCADE_REPORT_TYPE_SELECT'	=> $arcade_report_type_select,
			'GAME_DESC'					=> ($row['game_desc'] !== '') ? censor_text(nl2br($row['game_desc'])) : '',
			'GAME_NAME'					=> $row['game_name'],
			'GAME_IMAGE'				=> get_arcade_game_image($row['game_image']),
			'GAME_FILESIZE'				=> ($row['game_filesize'] > 0 ) ? sprintf($user->lang['ARCADE_GAMES_FILESIZE'], get_formatted_filesize($row['game_filesize'])) : sprintf($user->lang['ARCADE_GAMES_FILESIZE'], get_formatted_filesize($arcade->set_filesize($row['game_id']))),
			'POPUP_HEIGHT'				=> $arcade_config['smilies_popup_height'],
			'POPUP_WIDTH'				=> $arcade_config['smilies_popup_width']
		));
	}

page_header($user->lang['ARCADE_REPORT'], false);

$template->set_filenames(array(
	'body' => 'arcade/reports_body.html')
);

page_footer();

?>