<?php
/**
*
* @package arcade
* @version $Id: scoretype.php 2022 2012-03-20 16:20:21Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

if (!defined('IN_PHPBB') || !defined('IN_PHPBB_ARCADE'))
{
	exit;
}

if (!isset($config['arcade_install']))
{
	continue;
}

// Start session management here so that we can set update session page to false
// This is done so that the view online from phpBB will show the correct location
$user->session_begin(false);
$auth->acl($user->data);
$user->setup();

include($phpbb_root_path . 'arcade/includes/common.' . $phpEx);
// Initialize arcade class
$arcade = new arcade();

if (($arcade_config['arcade_disable'] && !$auth->acl_get('a_')) || !$auth_arcade->acl_get('u_arcade'))
{
	$scoretype = false;
}

$error = $prepare_score = false;

if (!empty($scoretype))
{
	$arcade_session->begin();
	$popup = $use_simple_header = $arcade_session->game_popup;

	switch ($scoretype)
	{
		case AMOD_GAME:
			$game_scorevar = (isset($_POST['game_name'])) ? request_var('game_name', '') : '';
			$score = (isset($_POST['score'])) ? request_var('score', 0.000) : 0;
			$prepare_score = true;
		break;

		case IBPRO_GAME:
		case ARCADELIB_GAME:
			$game_scorevar = (isset($_POST['gname'])) ? request_var('gname', '') : '';
			$score = (isset($_POST['gscore'])) ? request_var('gscore', 0.000) : 0;
			$prepare_score = true;
		break;

		case V3ARCADE_GAME:
			$game_scorevar = (isset($_POST['gamename'])) ? request_var('gamename', '') : '';
			$micro_one = (isset($_POST['microone'])) ? request_var('microone', '') : '';
			$score = (isset($_POST['score'])) ? request_var('score', 0.000) : 0;
			$fake_key = (isset($_POST['fakekey'])) ? request_var('fakekey', '') : '';

			switch ($v3arcade)
			{
				case 'sessionstart':
					$session_id = '';

					if ($game_scorevar != '')
					{
						$sql = 'SELECT s.session_id
								FROM ' . ARCADE_SESSIONS_TABLE . ' s, ' . ARCADE_GAMES_TABLE . " g
								WHERE s.phpbb_session_id = '" . $db->sql_escape($user->session_id) . "'
								AND s.user_id = " . (int) $user->data['user_id'] . "
								AND s.game_id = g.game_id
								AND g.game_scorevar = '" . $db->sql_escape($game_scorevar) . "'";
						$result = $db->sql_query($sql);
						$session_id = $db->sql_fetchfield('s.session_id');
						$db->sql_freeresult($result);
					}

					$initbar = $game_scorevar . '|' . $session_id;
					$arcade->set_header_no_cache();
					echo '&connStatus=1&initbar='. $initbar .'&val=x';
					garbage_collection();
					exit_handler();
				break;

				case 'permrequest':
					$arcade->set_header_no_cache();
					echo '&validate=1&microone='. $score .'|'. $fake_key .'&val=x';
					garbage_collection();
					exit_handler();
				break;

				case 'burn':
					$data			= explode('|', $micro_one);
					$score			= (float) $data[0];
					$game_scorevar	= str_replace("\'", "''", htmlspecialchars(trim($data[1])));
					$session_id		= (isset($data[2])) ? $data[2] : true;
					$prepare_score	= true;
				break;
			}
		break;

		case IBPROV3_GAME:
			if ($arcade_do == 'verifyscore')
			{
				$randchar = $arcade_session->add_game_randchar();
				$arcade->set_header_no_cache();
				echo '&randchar=' . $randchar['randchar1'] . '&randchar2=' . $randchar['randchar2'] . '&savescore=1&blah=OK';
				garbage_collection();
				exit_handler();
			}
			else if ($arcade_do == 'savescore' || $arcade_do == 'newscore')
			{
				$game_scorevar	= (isset($_POST['gname']))		? request_var('gname', '')		: '';
				$score			= (isset($_POST['gscore']))		? request_var('gscore',  0.000) : 0;
				$enscore		= (isset($_POST['enscore']))	? request_var('enscore', 0.000) : 0;
				$gidencoded		= (isset($_POST['arcadegid']))	? request_var('arcadegid',   0) : 0;
				$prepare_score	= true;
			}
		break;

		case AR_GAME:
			$game_scorevar = (isset($_POST['g'])) ? request_var('g', 0) : 0;
			$score = (isset($_POST['score'])) ? request_var('score', 0.000) : 0;
			$prepare_score = true;
		break;

		case PHPBBARCADE_GAME:
			if ($arcade_scorevar == 'verify')
			{
				$session_id	= (isset($_POST['arcade_gsid'])) ? request_var('arcade_gsid', 'error') : 'error';
				$randchar	= $arcade_session->add_game_randchar($session_id);
				unset($session_id);
				$arcade->set_header_no_cache();
				echo 'randchar1=' . $randchar['randchar1'] . '&randchar2=' . $randchar['randchar2'] . '&savescore=ok';

				garbage_collection();
				exit_handler();
			}
			else if ($arcade_scorevar == 'save')
			{
				$game_scorevar	= (isset($_POST['arcade_gsvar']))	? request_var('arcade_gsvar'	, '')		: '';
				$session_id		= (isset($_POST['arcade_gsid']))	? request_var('arcade_gsid'		, '')		: '';
				$score			= (isset($_POST['arcade_gscore']))	? request_var('arcade_gscore'	, 0.000)	: 0;
				$game_gkey		= (isset($_POST['arcade_gkey']))	? request_var('arcade_gkey'		, 0)		: 0;
				$game_skey		= (isset($_POST['arcade_skey']))	? request_var('arcade_skey'		, 0)		: 0;
				$prepare_score	= true;
			}
			else if ($arcade_scorevar == 'banned' && $user->data['is_registered'] && $arcade_config['corrupt_score_banned'] && $user->data['user_type'] != USER_FOUNDER)
			{
				$arcade->banned(ARCADE_BANNED_SCORE);
			}
		break;

		default:
			$error = 'GAME_TYPE_NOT_IDENTIFIED';
		break;
	}
}

if ($error)
{
	trigger_error($user->lang['ARCADE_' . $error] . ((!$popup) ? $arcade->back_link() : $arcade->close_win()));
}
else if ($prepare_score)
{
	/**
	* This function checks to make sure the game type is the expected type
	* and that the user and game ids exist in the sessions table.
	* It then returns the needed information in an array.
	*/
	if (!empty($game_scorevar))
	{
		if ($arcade_session->game_sid == '')
		{
			$error = 'COOKIE_ERROR';
		}
		else
		{
			$sql_array = array(
				'SELECT'		=> 's.start_time, s.session_id, s.randchar1, s.randchar2, s.randgid1, s.randgid2, s.game_popup, s.microtime,
									g.game_id, g.game_name, g.game_image, g.game_width, g.game_height, g.game_scorevar, g.game_highscore, g.game_highuser, g.game_highdate, g.game_scoretype, g.game_type, g.game_votetotal, g.game_votesum, g.game_cost, g.game_reward, g.game_jackpot, g.game_use_jackpot, g.cat_id,
									c.cat_name, c.cat_desc, c.cat_desc_uid, c.cat_desc_bitfield, c.cat_desc_options, c.parent_id, c.left_id, c.right_id, c.cat_parents, c.cat_test, c.cat_cost, c.cat_reward, c.cat_use_jackpot,
									r.game_rating',
				'FROM'			=> array(ARCADE_SESSIONS_TABLE	=> 's',
				),
				'LEFT_JOIN'	=> array(
					array(
						'FROM'	=> array(ARCADE_GAMES_TABLE		=> 'g'),
						'ON'	=> 's.game_id = g.game_id'
					),
					array(
						'FROM'	=> array(ARCADE_CATS_TABLE		=> 'c'),
						'ON'	=> 'g.cat_id = c.cat_id'
					),
					array(
						'FROM'	=> array(ARCADE_RATING_TABLE => 'r'),
						'ON'	=> 'g.game_id = r.game_id AND r.user_id = ' . (int) $user->data['user_id']
					),
				),
				'WHERE' 		=> "s.phpbb_session_id = '" . $db->sql_escape($user->session_id) . "'
					AND s.user_id = " . (int) $user->data['user_id'] . '
					AND s.game_id = g.game_id',
			);

			if ($scoretype == PHPBBARCADE_GAME)
			{
				$sql_array['WHERE'] .= " AND s.session_id = '" . $db->sql_escape($session_id) . "'";
			}
			else if (is_int($game_scorevar))
			{
				$sql_array['WHERE'] .= ' AND g.game_id = ' . (int) $game_scorevar;
			}
			else
			{
				$sql_array['WHERE'] .= " AND g.game_scorevar = '" . $db->sql_escape($game_scorevar) . "'";
			}

			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query_limit($sql, 1);
			$game_data = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			if (!$game_data)
			{
				$error = 'BACK_BUTTON_ERROR';
			}
			else
			{
				$game_data['current_time']	= time();
				$total_time					= intval($game_data['current_time'] - $game_data['start_time']);
				$game_data['total_time']	= ($total_time <= 0) ? false : $total_time;

				if (($scoretype != PHPBBARCADE_GAME && $arcade_session->game_sid !== $game_data['session_id']) || (!empty($session_id) && $session_id !== $game_data['session_id']))
				{
					$error = 'BACK_BUTTON_ERROR';
				}
				else
				{
					$delete_cookie = true;

					if ($scoretype == PHPBBARCADE_GAME || $scoretype == IBPROV3_GAME)
					{
						// score verify and save action max 10 sec.
						$microtime			= ($game_data['microtime'] > 0) ? intval(($game_data['microtime'] + 10) - time()) : 0;
						$error_microtime	= ($microtime <= 0) ? true : false;
						$error_randchar		= (!$game_data['randgid1'] || !$game_data['randchar1']) ? true : false;
					}

					if ($scoretype == PHPBBARCADE_GAME)
					{
						$use_simple_header	= $popup = ($game_data['game_popup']) ? true : false;

						$decodegame_key		= (int) $game_data['game_id'] * $game_data['randgid1'] ^ $game_data['randgid2'];
						$decodescore_key	= (float) $score * $game_data['randchar1'] ^ $game_data['randchar2'];
						$error_pch			= (!phpbb_check_hash($game_data['game_scorevar'], $game_scorevar)) ? true : false;
					}

					if ($scoretype == IBPROV3_GAME)
					{
						$decodescore = (float) $score * $game_data['randchar1'] ^ $game_data['randchar2'];
						$encoded_gid = (int) $game_data['game_id'] * $game_data['randgid1'] ^ $game_data['randgid2'];
					}

					if ($game_data['game_type'] != $scoretype)
					{
						$arcade->update_game_type($game_data['game_id'], $scoretype);
						$error = 'TYPE_ERROR';
					}
					else if (($scoretype == IBPROV3_GAME) && ($error_microtime || $error_randchar || $enscore != $decodescore || $encoded_gid != $gidencoded))
					{
						$banned_level3 = ($arcade_config['score_security_level'] == SCORE_SECURITY_HIGH && $error_microtime) ? true : false;

						if ($arcade_config['corrupt_score_banned'] && $user->data['is_registered'] && $user->data['user_type'] != USER_FOUNDER && $banned_level3)
						{
							$arcade->banned(ARCADE_BANNED_SCORE, false, $game_data['game_id'], $score);
							redirect($arcade->url());
						}
						else
						{
							$error = 'IBPROV3_ERROR';
						}
					}
					else if ($scoretype == PHPBBARCADE_GAME && ($error_microtime || $error_pch || $error_randchar || $decodegame_key != $game_gkey || $decodescore_key != $game_skey))
					{
						$banned_level2 = ($arcade_config['score_security_level'] == SCORE_SECURITY_MEDIUM && $error_pch) ? true : false;
						$banned_level3 = ($arcade_config['score_security_level'] == SCORE_SECURITY_HIGH && ($error_pch || $error_microtime)) ? true : false;

						if ($arcade_config['corrupt_score_banned'] && $user->data['is_registered'] && $user->data['user_type'] != USER_FOUNDER && ($banned_level2 || $banned_level3))
						{
							$arcade->banned(ARCADE_BANNED_SCORE, false, $game_data['game_id'], $score);
							redirect($arcade->url());
						}
						else
						{
							$error = 'IBPROV3_ERROR';
						}
					}
					else if (!$game_data['total_time'])
					{
						$arcade->add_log(array(
							'user_id'				=> (int) $user->data['user_id'],
							'game_id'				=> (int) $game_data['game_id'],
							'score'					=> (float) $score,
							'error_date'			=> time(),
							'error_type'			=> ARCADE_ERROR_TIME,
							'error_ip'				=> $user->ip,
						));

						$error = 'TIME_ERROR';
					}
				}
			}
		}
	}
	else
	{
		if ($scoretype == IBPROV3_GAME && !$gidencoded)
		{
			$error = 'IBPROV3_TYPE_NOT_SUPPORTED';
		}
		else
		{
			$error = 'SCOREVAR_ERROR';
		}
	}

	if (!empty($game_data))
	{
		$arcade_session->delete('gid', $game_data['game_id']);
	}

	if ($error)
	{
		if (!empty($delete_cookie))
		{
			$arcade_session->set_cookie();
		}

		trigger_error($user->lang['ARCADE_' . $error] . ((!empty($game_data)) ? $arcade->return_links($game_data, true, $popup) : ((!$popup) ? $arcade->back_link() : $arcade->close_win())));
	}

	include($phpbb_root_path . 'arcade/includes/score.'.$phpEx);
}

// Something went wrong lets send them to the arcade index.
redirect($arcade->url());

?>