<?php
/**
*
* @package arcade
* @version $Id: stats.php 1969 2012-03-12 20:04:01Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB') || !defined('IN_PHPBB_ARCADE'))
{
	exit;
}

// Set the link to the main statistics page in the nav
$template->assign_var('S_IN_STATS', true);

switch ($mode)
{
	case 'view_challenge_stats':
		$template->assign_block_vars('navlinks', array(
			'FORUM_NAME'	=> $user->lang['ARCADE_STATS'],
			'U_VIEW_FORUM'	=> $arcade->url("mode=view_challenge_stats")
		));

		if (($game_id && $user_id) || ($user_id))
		{
			$winner = request_var('w', false);
			$profile = (!$game_id) ? true : false;
			$userdata = $arcade->user_info('stats', 'challenge', $user_id, $profile);

			$template->assign_block_vars('navlinks', array(
				'FORUM_NAME'	=> $userdata['username'],
				'U_VIEW_FORUM'	=> get_username_string('profile', $userdata['user_id'], $userdata['username']),
			));

			$winner_sql		= ($winner) ? ' AND cc.champ_winner = ' . (int) $user_id : '';
			$game_sql		= ($game_id) ? ' AND cc.game_id = ' . (int) $game_id : '';
			$sql_cat_limit	= '';

			$sort_cat	= request_var('st', 0);
			$sort_key	= request_var('sk', 't');
			$sort_dir	= request_var('sd', 'd');

			$limit_cat = $arcade->get_user_categories($user_id);
			$sort_by_text = array('g' => $user->lang['ARCADE_GAME_NAME'], 'u' => $user->lang['CHALLENGE_OPPONENT'], 't' => $user->lang['CHALLENGE_END_DATE']);
			$sort_by_sql = array('g' => 'g.game_name_clean', 'u' => 'u.username_clean', 't' => 'cc.champ_end_time');

			if ($game_id)
			{
				unset($sort_by_text['g'], $sort_by_sql['g']);
			}

			$s_limit_cat = $s_sort_key = $s_sort_dir = $u_sort_param = '';
			gen_sort_selects($limit_cat, $sort_by_text, $sort_cat, $sort_key, $sort_dir, $s_limit_cat, $s_sort_key, $s_sort_dir, $u_sort_param);

			$sql_cat_limit = ($sort_cat) ? ' AND g.cat_id = ' . (int) $sort_cat : '';
			$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

			$sql_array = array(
				'SELECT'	=> 'COUNT(cc.champ_id) as total_challenge',
				'FROM'		=> array(
					ARCADE_GAMES_TABLE	=> 'g',
				),
				'LEFT_JOIN'	=> array(
					array(
						'FROM'	=> array(ARCADE_CHALLENGE_CHAMP_TABLE => 'cc'),
						'ON'	=> 'g.game_id = cc.game_id'
					),
				),
				'WHERE'		=> 'g.game_id = cc.game_id
					AND cc.champ_close = ' . CHALLENGE_CLOSE . '
					AND (cc.champ_challenger_id = ' . (int) $user_id . ' OR cc.champ_opponent_id = ' . (int) $user_id . ')' . $sql_cat_limit . $game_sql . $winner_sql . '
					AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true),
			);

			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query($sql);
			$total_challenge = (int) $db->sql_fetchfield('total_challenge');
			$db->sql_freeresult($result);

			if (!$total_challenge)
			{
				if (!$game_id)
				{
					$msgkey = ($winner) ? 'CHELLENGE_NO_WINNER' : 'CHALLENGE_USER_NO_PLAYED';
				}
				else
				{
					$msgkey = 'CHALLENGE_PLAYED_NO_GAME';
				}

				trigger_error($user->lang[$msgkey] . $arcade->back_link('mode=view_challenge_stats', 'challenge_stats'));
			}

			$sql_array = array(
				'SELECT'	=> 'g.game_id, g.game_name, g.game_name_clean, g.game_image, g.cat_id,
								cc.*,
								u.username, u.username_clean, u.user_id, u.user_colour,
								c.cat_name, c.parent_id, c.cat_parents, c.left_id, c.right_id, c.cat_desc, c.cat_desc_options, c.cat_desc_uid, c.cat_desc_bitfield',
				'FROM'		=> array(
					ARCADE_GAMES_TABLE	=> 'g',
				),
				'LEFT_JOIN'	=> array(
					array(
						'FROM'	=> array(ARCADE_CHALLENGE_CHAMP_TABLE => 'cc'),
						'ON'	=> 'g.game_id = cc.game_id'
					),
					array(
						'FROM' => array(USERS_TABLE => 'u'),
						'ON'	=> (int) $user_id .' <> u.user_id AND ((cc.champ_challenger_id = u.user_id) OR (cc.champ_opponent_id = u.user_id))'
					),
					array(
						'FROM' => array(ARCADE_CATS_TABLE => 'c'),
						'ON'	=> 'g.cat_id = c.cat_id'
					),
				),
				'WHERE'		=> 'g.game_id = cc.game_id
					AND cc.champ_close = ' . CHALLENGE_CLOSE . '
					AND (cc.champ_challenger_id = ' . (int) $user_id . ' OR cc.champ_opponent_id = ' . (int) $user_id . ')' . $sql_cat_limit . $game_sql . $winner_sql . '
					AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true),
				'ORDER_BY'	=> $sql_sort,
			);

			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query_limit($sql, $arcade_config['stat_items_per_page'], $start);
			$game_count	= 0;
			$uid		= (!$game_id) ? $user_id : false;
			while ($row = $db->sql_fetchrow($result))
			{
				// Generate the nav for the challenge if viewing a users game stats...
				if (!$game_count && $game_id && $user_id)
				{
					generate_arcade_nav($row, true, 'view_challenge_stats');
					$template->assign_var('GAME_NAME', $row['game_name']);
				}

				$game_count++;
				$game_name	= $row['game_name'];
				$scorea		= ($user_id == $row['champ_challenger_id']) ? $row['champ_challenger_score'] : $row['champ_opponent_score'];
				$scoreb		= ($user_id == $row['champ_challenger_id']) ? $row['champ_opponent_score'] : $row['champ_challenger_score'];
				$play_timea	= ($user_id == $row['champ_challenger_id']) ? $row['champ_challenger_time'] : $row['champ_opponent_time'];
				$play_timeb	= ($user_id == $row['champ_challenger_id']) ? $row['champ_opponent_time'] : $row['champ_challenger_time'];
				$game_title	= ($uid) ? sprintf($user->lang['ARCADE_STATS_USER_GAME_CHALLENGE'], $userdata['username'], $row['game_name']) : 'x';

				$template->assign_block_vars('challengerow', array(
					'GAME_IMAGE'		=> ($arcade->optionget('view_game_image')) ? get_arcade_game_image($row['game_image'], 20, 20, $game_title, 'challenge', $row['cat_id'], $row['game_id'], $uid) : false,
					'GAME_NAME'			=> get_arcade_game_name($row['game_name'], false, 'challenge', $row['cat_id'], $row['game_id'], $game_title, false, false, $uid),
					'GAME_IMAGE_FIRST'	=> ($row['champ_winner'] == $user_id) ? $arcade->get_image('src', 'img', '1st.gif', '') : '',

					'SCOREA'			=> $arcade->number_format($scorea),
					'PLAY_TIMEA'		=> $arcade->time_format($play_timea),
					'OPPONENT_USERNAME'	=> get_arcade_user_name('full', $row['user_id'], $row['username'], $row['user_colour'], 'challenge', 'x'),
					'SCOREB'			=> $arcade->number_format($scoreb),
					'PLAY_TIMEB'		=> $arcade->time_format($play_timeb),
					'END_TIME'			=> $user->format_date($row['champ_end_time'])
				));
			}
			$db->sql_freeresult($result);

			$arcade->user_online($user_id);

			$template->assign_vars(array(
				'S_ARCADE_ACTION'			=> $arcade->url("mode=view_challenge_stats" . ((!$uid) ? "&amp;g=$game_id" : '') . "&amp;u={$user_id}" . ($winner ? '&amp;w=1' : '')),
				'S_USER_STATS'				=> true,

				'S_SELECT_SORT_CAT'			=> (!$game_id) ? $s_limit_cat : false,
				'S_SELECT_SORT_DIR'			=> $s_sort_dir,
				'S_SELECT_SORT_KEY'			=> $s_sort_key,

				'L_ARCADE_USER_STATS_TYPE'	=> $user->lang['ARCADE_USER_' . (($winner) ? 'ALL' : 'WINNING') . '_CHALLENGES'],
				'U_ARCADE_USER_STATS_TYPE'	=> $arcade->url("mode=view_challenge_stats" . ((!$uid) ? "&amp;g=$game_id" : '') . "&amp;u={$user_id}" . ($winner ? '' : '&amp;w=1'))
			));

			if (!$game_id)
			{
				$page_title = sprintf($user->lang['ARCADE_STATS_USER_CHALLENGE'], $userdata['username']);
			}
			else
			{
				$page_title = sprintf($user->lang['ARCADE_STATS_USER_GAME_CHALLENGE'], $userdata['username'], $game_name);
			}

			$template->assign_vars(array(
				'PAGE_NUMBER'	=> on_page($total_challenge, $arcade_config['stat_items_per_page'], $start),
				'TOTAL_DATA'	=> ($total_challenge) ? sprintf($user->lang['CHALLENGE_ALL_CHALLENGE' . (($total_challenge > 1) ? 'S' : '')], $total_challenge) : false,
				'PAGINATION'	=> generate_pagination($arcade->url("mode=view_challenge_stats" . ((!$uid) ? "&amp;g=$game_id" : '') . "&amp;u=$user_id" . (($winner) ? '&amp;w=1' : '') . "&amp;$u_sort_param"), $total_challenge, $arcade_config['stat_items_per_page'], $start),
			));
		}
		else if ($game_id)
		{
			$sql = 'SELECT COUNT(c.champ_id) AS total_plays, SUM(c.champ_challenger_time + c.champ_opponent_time) AS total_time
					FROM ' . ARCADE_GAMES_TABLE . ' g
					LEFT JOIN ' . ARCADE_CHALLENGE_CHAMP_TABLE . ' c ON g.game_id = c.game_id
					WHERE g.game_id = c.game_id
					AND c.champ_close = ' . CHALLENGE_CLOSE . '
					AND g.game_id = ' . (int) $game_id . '
					AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true);
			$result = $db->sql_query($sql);
			$total = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			$sql_array = array(
				'SELECT'	=> 'g.game_id, g.game_name, g.game_name_clean, g.game_image, g.cat_id,
								c.cat_name, c.parent_id, c.cat_parents, c.left_id, c.right_id, c.cat_desc, c.cat_desc_options, c.cat_desc_uid, c.cat_desc_bitfield,
								cc.champ_challenger_id, cc.champ_challenger_score, cc.champ_challenger_time, cc.champ_opponent_score, cc.champ_opponent_time, cc.champ_end_time,
								u1.user_id, u1.username, u1.user_colour,
								u2.user_id AS o_user_id, u2.username AS o_username, u2.user_colour AS o_user_colour',
				'FROM'		=> array(
					ARCADE_GAMES_TABLE	=> 'g',
				),
				'LEFT_JOIN'	=> array(
					array(
						'FROM'	=> array(ARCADE_CATS_TABLE => 'c'),
						'ON'	=> 'g.cat_id = c.cat_id'
					),
					array(
						'FROM'	=> array(ARCADE_CHALLENGE_CHAMP_TABLE => 'cc'),
						'ON'	=> 'g.game_id = cc.game_id'
					),
					array(
						'FROM' => array(USERS_TABLE => 'u1'),
						'ON'	=> 'cc.champ_challenger_id = u1.user_id'
					),
					array(
						'FROM' => array(USERS_TABLE => 'u2'),
						'ON'	=> 'cc.champ_opponent_id = u2.user_id'
					),
				),
				'WHERE'		=> 'g.game_id = cc.game_id
					AND cc.champ_close = ' . CHALLENGE_CLOSE . '
					AND g.game_id = ' . (int) $game_id . '
					AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true),
				'ORDER_BY'	=> 'cc.champ_end_time ASC',
			);

			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query_limit($sql, $arcade_config['stat_items_per_page'], $start);
			$row_count = 0;
			while ($row = $db->sql_fetchrow($result))
			{
				if (!$row_count)
				{
					$page_title = sprintf($user->lang['CHALLENGE_STATS_USER_GAME_PAGE_TITLE'], $row['game_name']);
					generate_arcade_nav($row, true, 'view_challenge_stats');
					$template->assign_vars(array(
						'S_GAME_STATS'		=> true,

						'GAME_TOTAL_PLAYS'	=> $arcade->number_format($total['total_plays']),
						'GAME_TOTAL_TIME'	=> $arcade->time_format($total['total_time']),
						'GAME_NAME'			=> get_arcade_game_name($row['game_name'], true, 'play', $row['cat_id'], $row['game_id'], 'x'),
						'GAME_IMAGE'		=> ($arcade->optionget('view_game_image')) ? get_arcade_game_image($row['game_image'], 60, 60, 'x', 'play', $row['cat_id'], $row['game_id']) : false,

						'PAGE_NUMBER'		=> on_page($total['total_plays'], $arcade_config['stat_items_per_page'], $start),
						'TOTAL_SCORES'		=> $user->lang['ARCADE_SCORE' . (($total['total_plays'] > 1) ? 'S' : '')],
						'PAGINATION'		=> generate_pagination($arcade->url("mode=view_challenge_stats&amp;g=$game_id"), $total['total_plays'], $arcade_config['stat_items_per_page'], $start),
					));
				}

				$row_count++;
				$c_score		= ($row['user_id'] == $row['champ_challenger_id']) ? $row['champ_challenger_score'] : $row['champ_opponent_score'];
				$o_score		= ($row['user_id'] == $row['champ_challenger_id']) ? $row['champ_opponent_score'] : $row['champ_challenger_score'];
				$c_play_time	= ($row['user_id'] == $row['champ_challenger_id']) ? $row['champ_challenger_time'] : $row['champ_opponent_time'];
				$o_play_time	= ($row['user_id'] == $row['champ_challenger_id']) ? $row['champ_opponent_time'] : $row['champ_challenger_time'];

				$template->assign_block_vars('scorerow', array(
					'CHALLENGER'	=> get_arcade_user_name('full', $row['user_id'], $row['username'], $row['user_colour'], 'challenge', 'x'),
					'C_SCORE'		=> $arcade->number_format($c_score),
					'C_TIME'		=> $arcade->time_format($c_play_time),
					'OPPONENT'		=> get_arcade_user_name('full', $row['o_user_id'], $row['o_username'], $row['o_user_colour'], 'challenge', 'x'),
					'O_SCORE'		=> $arcade->number_format($o_score),
					'O_TIME'		=> $arcade->time_format($o_play_time),
					'DATE'			=> $user->format_date($row['champ_end_time'])
				));
			}
			$db->sql_freeresult($result);

			if (!$row_count)
			{
				trigger_error(sprintf($user->lang['ARCADE_GAME_NO_SCORES_CHALLENGE'], $arcade->get_game_field($game_id, 'game_name', true)) . $arcade->back_link('mode=view_challenge_stats', 'challenge_stats'));
			}
		}
		else
		{
			$page_title = $user->lang['CHALLENGE_STATS'];

			$arcade->obtain_data('challenge_leaders', $arcade_config['challenge_leaders']);
			$arcade->obtain_data('challenge_popular_games', $arcade_config['challenge_most_popular'], 'most');
			$arcade->obtain_data('challenge_popular_games', $arcade_config['challenge_least_popular'], 'least');
			$arcade->obtain_data('challenge_played_users', $arcade_config['challenge_most_played_users'], 'most');
			$arcade->obtain_data('challenge_played_users', $arcade_config['challenge_least_played_users'], 'least');

			$challenge->games_list();
			$challenge->users_list();

			$s_hidden_fields = array('mode' => 'view_challenge_stats');

			if ($_SID)
			{
				$s_hidden_fields['sid'] = $_SID;
			}

			$template->assign_vars(array(
				'S_ACTION'			=> $arcade->url(),
				'S_HIDDEN_FIELDS'	=> build_hidden_fields($s_hidden_fields),

				'L_ARCADE_STATS_TITLE'	=> $user->lang['CHALLENGE_STATS'],
				'L_ARCADE_LEADERS'		=> $user->lang['CHALLENGE_LEADERS']
			));
		}

		display_arcade_header('challenge', $arcade_config['challenge_welcome_stats'], false, $arcade_config['challenge_links_stats']);
	break;

	case 'stats':
		$template->assign_block_vars('navlinks', array(
			'FORUM_NAME'	=> $user->lang['ARCADE_STATS'],
			'U_VIEW_FORUM'	=> $arcade->url("mode=stats")
		));

			$template->assign_var('S_GAME_COMMENT', ($arcade_config['game_comment']) ? true : false);

		if (($game_id && $user_id) || ($user_id))
		{
			$highscores = request_var('hs', 0);

			$highscores_sql	= ($highscores && !$game_id) ? ' AND g.game_highuser = ' . (int) $user_id : '';
			$game_sql		= ($game_id) ? ' AND s.game_id = ' . (int) $game_id : '';

			$sql_sort = 'g.game_name_clean ASC';
			$sql_cat_limit = '';
			if (!$game_id)
			{
				$sort_cat = request_var('st', 0);
				$sort_key = request_var('sk', 'g');
				$sort_dir = request_var('sd', 'a');

				$limit_cat = $arcade->get_user_categories($user_id);
				$sort_by_text = array('g' => $user->lang['ARCADE_GAME_NAME'], 's' => $user->lang['ARCADE_SCORE'], 'd' => $user->lang['ARCADE_DATE'], 'p' => $user->lang['ARCADE_CHAMPION_PLAYED'], 'm' => $user->lang['ARCADE_STATS_TOTAL_TIME'], 't' => $user->lang['ARCADE_STATS_AVG']);
				$sort_by_sql = array('g' => 'g.game_name_clean', 's' => 's.score', 'd' => 's.score_date', 'p' => 'p.total_plays', 'm' => 'p.total_time', 't' => 'p.total_time / p.total_plays');

				$s_limit_cat = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_cat, $sort_by_text, $sort_cat, $sort_key, $sort_dir, $s_limit_cat, $s_sort_key, $s_sort_dir, $u_sort_param);

				$sql_cat_limit = ($sort_cat) ? ' AND g.cat_id = ' . (int) $sort_cat : '';
				$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');
			}

			$sql_array = array(
				'SELECT'	=> 'COUNT(s.game_id) as total_games',
				'FROM'		=> array(
					ARCADE_GAMES_TABLE	=> 'g',
				),
				'LEFT_JOIN'	=> array(
					array(
						'FROM'	=> array(ARCADE_SCORES_TABLE => 's'),
						'ON'	=> 'g.game_id = s.game_id'
					),
				),
				'WHERE'		=> 'g.game_id = s.game_id
					AND s.user_id = ' . (int) $user_id . $sql_cat_limit . $game_sql . $highscores_sql . '
					AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true),
			);

			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query($sql);
			$total_games = (int) $db->sql_fetchfield('total_games');
			$db->sql_freeresult($result);

			if (!$total_games)
			{
				if (!$game_id)
				{
					$msgkey = ($highscores) ? 'ARCADE_NO_HIGHSCORES' : 'ARCADE_PLAYED_NO_GAMES';
				}
				else
				{
					$msgkey = 'ARCADE_PLAYED_NO_GAME';
				}

				trigger_error($user->lang[$msgkey] . $arcade->back_link('mode=stats', 'arcade_stats'));
			}

			// Quick jump of users favorite games...
			$user_fav_data = $arcade->get_fav_data($user_id);

			if (is_array($user_fav_data))
			{
				foreach ($user_fav_data as $gid => $game)
				{
					$template->assign_block_vars('userfav', array(
						'GAME_ID'	=> $gid,
						'GAME_NAME'	=> $game['game_name']
					));
				}
			}

			$score_columns = ($arcade_config['game_comment']) ? 's.*' : 's.score, s.score_date';
			$sql_array = array(
				'SELECT'	=> $score_columns . ', g.game_id, g.game_name, g.game_name_clean, g.game_highuser, g.game_image, g.cat_id,
								p.total_time, p.total_plays,
								c.cat_name, c.parent_id, c.cat_parents, c.left_id, c.right_id, c.cat_desc, c.cat_desc_options, c.cat_desc_uid, c.cat_desc_bitfield',
				'FROM'		=> array(
					ARCADE_GAMES_TABLE	=> 'g',
				),
				'LEFT_JOIN'	=> array(
					array(
						'FROM'	=> array(ARCADE_SCORES_TABLE => 's'),
						'ON'	=> 'g.game_id = s.game_id'
					),
					array(
						'FROM'	=> array(ARCADE_PLAYS_TABLE => 'p'),
						'ON'	=> 's.game_id = p.game_id AND s.user_id = p.user_id'
					),
					array(
						'FROM' => array(ARCADE_CATS_TABLE => 'c'),
						'ON'	=> 'g.cat_id = c.cat_id'
					),
				),
				'WHERE'		=> 's.game_id = g.game_id
					AND s.user_id = ' . (int) $user_id . $sql_cat_limit . $game_sql . $highscores_sql . '
					AND ' . $db->sql_in_set('g.cat_id', $arcade->get_permissions('c_view'), false, true),
				'ORDER_BY'	=> $sql_sort,
			);

			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query_limit($sql, $arcade_config['stat_items_per_page'], $start);
			while ($row = $db->sql_fetchrow($result))
			{
				// Generate the nav for the arcade if viewing a users game stats...
				if($game_id && $user_id)
				{
					generate_arcade_nav($row, true, 'stats');
					$template->assign_var('GAME_NAME', $row['game_name']);
				}

				$game_name = $row['game_name'];
				$comment_display = ($arcade_config['game_comment'] && $row['comment_text'] !== '') ? generate_text_for_display($row['comment_text'], $row['comment_uid'], $row['comment_bitfield'], $row['comment_options']) : '';

				$template->assign_block_vars('gamerow', array(
					'GAME_IMAGE'		=> ($arcade->optionget('view_game_image')) ? get_arcade_game_image($row['game_image'], 20, 20, 'x', 'stats', $row['cat_id'], $row['game_id']) : false,
					'GAME_NAME'			=> get_arcade_game_name($row['game_name'], true, 'stats', $row['cat_id'], $row['game_id'], 'x'),
					'GAME_IMAGE_FIRST'	=> ($row['game_highuser'] == $user_id) ? $arcade->get_image('src', 'img', '1st.gif', '') : '',
					'SCORE'				=> (!$arcade->hidden_score($row['game_id'], $user_id)) ? $arcade->number_format($row['score']) : $user->lang['HIDDEN'],
					'COMMENT'			=> ($comment_display !== '') ? $comment_display : '&nbsp;',
					'DATE'				=> $user->format_date($row['score_date']),
					'TOTAL_PLAYS'		=> $arcade->number_format($row['total_plays']),
					'TOTAL_TIME'		=> $arcade->time_format($row['total_time']),
					'AVG_TIME'			=> $arcade->time_format($row['total_time']/$row['total_plays']),
				));
			}
			$db->sql_freeresult($result);

			// This will return the user rank, rank image, and avatar image
			// as well as the users total wins, total time, and games played...
			// Since $user_id is passed to this function it will return an array that has
			// the user info whose stats we are looking for stored.
			$profile = (!$game_id) ? true : false;
			$userdata = $arcade->user_info('stats', 'arcade', $user_id, $profile);

			$s_user_fav_hidden_fields = array('mode' => 'play');

			if ($_SID)
			{
				$s_user_fav_hidden_fields['sid'] = $_SID;
			}

			$arcade->user_online($user_id);

			$template->assign_vars(array(
				'S_ACTION_USER_FAV'			=> $arcade->url($arcade->gametop),
				'S_ARCADE_ACTION'			=> $arcade->url("mode=stats&amp;u={$user_id}" . ($highscores ? '&amp;hs=1' : '')),
				'S_USER_FAV_HIDDEN_FIELDS'	=> build_hidden_fields($s_user_fav_hidden_fields),
				'S_USER_STATS'				=> true,

				'S_SELECT_SORT_CAT'			=> (!$game_id) ? $s_limit_cat : false,
				'S_SELECT_SORT_DIR'			=> (!$game_id) ? $s_sort_dir : false,
				'S_SELECT_SORT_KEY'			=> (!$game_id) ? $s_sort_key : false,

				'U_ARCADE_USER_STATS_TYPE'	=> $arcade->url("mode=stats&amp;u={$user_id}" . ($highscores ? '' : '&amp;hs=1')),

				'L_ARCADE_USER_STATS_TYPE'	=> $user->lang['ARCADE_USER_' . (($highscores) ? 'SCORES' : 'HIGHSCORES')]
			));

			if (!$game_id)
			{
				$page_title = sprintf($user->lang['ARCADE_STATS_USER_GAME_PAGE_TITLE'], $userdata['username']);

				$template->assign_vars(array(
					'PAGE_NUMBER'	=> on_page($total_games, $arcade_config['stat_items_per_page'], $start),
					'TOTAL_DATA'	=> ($total_games) ? $total_games . ' ' . $user->lang['ARCADE_GAME' . (($total_games > 1) ? 'S' : '')] : false,
					'PAGINATION'	=> generate_pagination($arcade->url("mode=stats&amp;u=$user_id" . (($highscores) ? '&amp;hs=1' : '') . "&amp;$u_sort_param"), $total_games, $arcade_config['stat_items_per_page'], $start),
				));
			}
			else
			{
				$page_title = sprintf($user->lang['ARCADE_STATS_SCORE_PAGE_TITLE'], $game_name, $userdata['username']);
			}

			$template->assign_block_vars('navlinks', array(
				'FORUM_NAME'	=> $userdata['username'],
				'U_VIEW_FORUM'	=> get_username_string('profile', $userdata['user_id'], $userdata['username']),
			));
		}
		else if ($game_id)
		{
			// Get game and category data for page and generate the nav
			$game_data = $arcade->get_game_cat_data($game_id);

			generate_arcade_nav($game_data, true, 'stats');

			$page_title = sprintf($user->lang['ARCADE_STATS_USER_GAME_PAGE_TITLE'], $game_data['game_name']);

			$sql_array = array(
				'SELECT'	=> 'COUNT(s.game_id) AS total_scores, SUM(p.total_plays) AS total_plays, SUM(p.total_time) AS total_time',
				'FROM'		=> array(
					ARCADE_SCORES_TABLE	=> 's',
				),
				'LEFT_JOIN'	=> array(
					array(
						'FROM'	=> array(ARCADE_PLAYS_TABLE => 'p'),
						'ON'	=> 's.game_id = p.game_id AND s.user_id = p.user_id'
					),
				),
				'WHERE'	=> 's.game_id = ' . (int) $game_data['game_id'],
			);

			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			$game_data['total_scores'] = (int) $row['total_scores'];
			$game_data['total_plays'] = (int) $row['total_plays'];
			$game_data['total_time'] = (int) $row['total_time'];

			if (!$game_data['total_scores'])
			{
				$game_link = $arcade->url("mode=play&amp;g={$game_data['game_id']}");
				trigger_error(sprintf($user->lang['ARCADE_GAME_NO_SCORES'], $game_data['game_name'], $game_link));
			}

			// Lets check if the game plays is out of sync...
			if ($game_data['game_plays'] != $game_data['total_plays'])
			{
				$db->sql_query('UPDATE ' . ARCADE_GAMES_TABLE . ' SET game_plays = ' . (int) $game_data['total_plays'] . ' WHERE game_id = ' . (int) $game_data['game_id']);
			}

			$score_columns = ($arcade_config['game_comment']) ? 's.*' : 's.score, s.score_date';
			$score_order = ($game_data['game_scoretype'] == SCORETYPE_HIGH) ? 'DESC' : 'ASC';

			$sql_array = array(
				'SELECT'	=> $score_columns . ', p.total_time, p.total_plays, u.user_id, u.user_colour, u.username, u.user_avatar_type, u.user_avatar, u.user_avatar_width, u.user_avatar_height',
				'FROM'		=> array(
					USERS_TABLE	=> 'u',
				),
				'LEFT_JOIN'	=> array(
					array(
						'FROM'	=> array(ARCADE_SCORES_TABLE => 's'),
						'ON'	=> 'u.user_id = s.user_id'
					),
					array(
						'FROM'	=> array(ARCADE_PLAYS_TABLE => 'p'),
						'ON'	=> 's.game_id = p.game_id AND s.user_id = p.user_id'
					),
				),
				'WHERE'		=> 's.game_id = ' . (int) $game_data['game_id'],
				'ORDER_BY'	=> 's.score ' . $score_order . ', s.score_date ASC',
			);

			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query_limit($sql, 1);
			$best_user = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			$result = $db->sql_query_limit($sql, $arcade_config['stat_items_per_page'], $start);
			$position = ($start > 0 ) ? $start : 0;
			$actual_position = ($start > 0 ) ? $start : 0;
			$lastscore = '';
			while ($row = $db->sql_fetchrow($result))
			{
				$actual_position++;
				if ($lastscore != $row['score'])
				{
					$position = $actual_position;
				}
				$lastscore = $row['score'];

				$comment_display = ($arcade_config['game_comment'] && $row['comment_text'] !== '') ? generate_text_for_display($row['comment_text'], $row['comment_uid'], $row['comment_bitfield'], $row['comment_options']) : '';
				$template->assign_block_vars('scorerow', array(
					'POS'			=> $position,
					'USERNAME'		=> get_arcade_user_name('full', $row['user_id'], $row['username'], $row['user_colour'], 'arcade', 'x'),
					'SCORE'			=> (!$arcade->hidden_score($game_data['game_id'], $row['user_id'])) ? $arcade->number_format($row['score']) : $user->lang['HIDDEN'],
					'COMMENT'		=> ($comment_display !== '') ? $comment_display : '&nbsp;',
					'DATE'			=> $user->format_date($row['score_date']),
					'TOTAL_PLAYS'	=> $arcade->number_format($row['total_plays']),
					'TOTAL_TIME'	=> $arcade->time_format($row['total_time'])
				));
			}
			$db->sql_freeresult($result);

			$arcade->user_online($best_user['user_id']);

			$template->assign_vars(array(
				'S_GAME_STATS'		=> true,
				'S_CAN_DOWNLOAD'	=> ($game_data['cat_download'] && $game_data['game_download'] && $auth_arcade->acl_get('u_arcade_download') && $auth_arcade->acl_get('c_download', $game_data['cat_id'])) ? true : false,

				'BEST_USER'			=> get_arcade_user_name('full', $best_user['user_id'], $best_user['username'], $best_user['user_colour'], 'arcade', 'x'),
				'BEST_SCORE'		=> (!$arcade->hidden_score($game_data['game_id'], $best_user['user_id'])) ? $arcade->number_format($best_user['score']) : $user->lang['HIDDEN'],
				'BEST_DATE'			=> $user->format_date($best_user['score_date']),

				'GAME_TOTAL_TIME'	=> $arcade->time_format($game_data['total_time']),
				'GAME_TOTAL_PLAYS'	=> $arcade->number_format($game_data['total_plays']),
				'GAME_NAME'			=> get_arcade_game_name($game_data['game_name'], true, 'play', $game_data['cat_id'], $game_data['game_id'], 'x'),
				'GAME_DOWNLOAD'		=> $arcade->number_format($game_data['game_download_total']),
				'GAME_RATING_IMG'	=> $arcade->set_rating_image($game_data, 'stats'),
				'GAME_IMAGE'		=> ($arcade->optionget('view_game_image')) ? get_arcade_game_image($game_data['game_image'], 60, 60, 'x', 'play', $game_data['cat_id'], $game_data['game_id']) : false,
				'AVATAR'			=> ($arcade->optionget('view_avatars')) ? get_arcade_user_avatar($best_user['user_avatar'], $best_user['user_avatar_type'], 60, 60, 'x', 'arcade', $best_user['user_id']) : false,
				'PAGE_NUMBER'		=> on_page($game_data['total_scores'], $arcade_config['stat_items_per_page'], $start),
				'TOTAL_SCORES'		=> $user->lang['ARCADE_SCORE' . (($game_data['total_scores'] > 1) ? 'S' : '')],
				'PAGINATION'		=> generate_pagination($arcade->url("mode=stats&amp;g=$game_id"), $game_data['total_scores'], $arcade_config['stat_items_per_page'], $start),
			));
		}
		else
		{
			$page_title = $user->lang['ARCADE_STATS_PAGE_TITLE'];

			$arcade->obtain_data('longest_highscores', $arcade_config['longest_held_scores']);
			$arcade->obtain_data('leaders', $arcade_config['arcade_leaders']);
			$arcade->obtain_data('popular_games', $arcade_config['most_popular'], 'most');
			$arcade->obtain_data('popular_games', $arcade_config['least_popular'], 'least');
			$arcade->obtain_data('played_users', $arcade_config['most_played_users'], 'most');
			$arcade->obtain_data('played_users', $arcade_config['least_played_users'], 'least');
			$arcade->obtain_data('downloaded_games', $arcade_config['most_downloaded'], 'most');
			$arcade->obtain_data('downloaded_games', $arcade_config['least_downloaded'], 'least');

			$arcade->games_list('game_jump');
			$arcade->users_list();

			$s_hidden_fields = array('mode' => 'stats');

			if ($_SID)
			{
				$s_hidden_fields['sid'] = $_SID;
			}

			$template->assign_vars(array(
				'S_ACTION'				=> $arcade->url(),
				'S_HIDDEN_FIELDS'		=> build_hidden_fields($s_hidden_fields),

				'L_ARCADE_STATS_TITLE'	=> $user->lang['ARCADE_STATS']
			));
		}

		display_arcade_header('arcade', $arcade_config['welcome_stats'], $arcade_config['search_stats'], $arcade_config['links_stats']);
	break;
}

?>