<?php
/**
*
* @package arcade
* @version $Id: viewonline.php 2022 2012-03-20 16:20:21Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (!isset($config['arcade_install']))
{
	continue;
}

if (!isset($arcade))
{
	define('IN_PHPBB_ARCADE', true);
	include($phpbb_root_path . 'arcade/includes/common.' . $phpEx);
	// Initialize arcade class
	$arcade = new arcade(false);
}

// This will have to be looked at.  There might be a better way.
if (!$auth_arcade->acl_get('u_arcade'))
{
	continue;
}

// Grab some common modules
$url_params = array(
	'mode=play'						=> 'PLAYING_GAME',
	'mode=popup'					=> 'PLAYING_GAME',
	'mode=random'					=> 'PLAYING_GAME',
	'mode=cat'						=> 'VIEWING_ARCADE_CAT',
	'mode=view_cat_stats'			=> 'VIEWING_ARCADE_CAT_STATS',
	'mode=download'					=> 'DOWNLOADING_GAME',
	'mode=stats'					=> 'VIEWING_ARCADE_STATS',
	'mode=search'					=> 'VIEWING_ARCADE_SEARCH',
	'mode=fav'						=> 'VIEWING_ARCADE_FAVS',

	'mode=challenge'				=> 'VIEWING_ARCADE_CHALLENGE',
	'mode=rand_challenge'			=> 'VIEWING_ARCADE_CHALLENGE',
	'mode=champion_challenge'		=> 'VIEWING_ARCADE_CHALLENGE',
	'mode=view_challenge_stats'		=> 'VIEWING_ARCADE_CHALLENGE_STATS',
);

// default values
$location		= $user->lang['VIEWING_ARCADE'];
$location_url	= $arcade->url();

foreach ($url_params as $param => $lang)
{
	if (strpos($row['session_page'], $param) !== false)
	{
		if ($param == 'mode=cat' || $param == 'mode=view_cat_stats')
		{
			preg_match('#c=([0-9]+)#', $row['session_page'], $cat_id);
			$cat_id = (sizeof($cat_id)) ? (int) $cat_id[1] : 0;
			$cat_name = $arcade->get_cat_field($cat_id, 'cat_name');

			if (!$auth_arcade->acl_get('c_view', $cat_id) || !$cat_name)
			{
				break;
			}

			$location = sprintf($user->lang[$lang], $cat_name);
			$location_url = $arcade->url("$param&amp;c=$cat_id");
			break;
		}
		else if ($param == 'mode=download')
		{
			if (!$auth_arcade->acl_get('u_arcade_download'))
			{
				break;
			}

			preg_match('#g=([0-9]+)#', $row['session_page'], $game_id);
			$game_id = (sizeof($game_id)) ? (int) $game_id[1] : 0;
			$game_name = $arcade->get_game_field($game_id, 'game_name');
			$cat_id = $arcade->get_game_field($game_id, 'cat_id');

			if (!$game_name || !$cat_id || !$auth_arcade->acl_get('c_download', $cat_id))
			{
				break;
			}

			$location = sprintf($user->lang[$lang], $game_name);
			$location_url = $arcade->url('mode=download&amp;g=' . $game_id);
			break;
		}
		else if ($param == 'mode=play' || $param == 'mode=popup' || $param == 'mode=random')
		{
			if (!$auth_arcade->acl_get('u_arcade_view_whoisplaying'))
			{
				break;
			}

			preg_match('#g=([0-9]+)#', $row['session_page'], $game_id);
			$game_id = (sizeof($game_id)) ? (int) $game_id[1] : 0;
			$game_name = $arcade->get_game_field($game_id, 'game_name');
			$cat_id = $arcade->get_game_field($game_id, 'cat_id');

			if (!$game_name || !$cat_id)
			{
				break;
			}

			if (!$auth_arcade->acl_get('c_play', $cat_id))
			{
				break;
			}

			$location = sprintf($user->lang[$lang], $game_name);
			$location_url = $arcade->url('mode=play&amp;g=' . $game_id);
			break;
		}
		else if ($param == 'mode=stats' || $param == 'mode=view_challenge_stats')
		{
			if (!$auth_arcade->acl_get('u_arcade_viewstats'))
			{
				break;
			}

			preg_match('#g=([0-9]+)#', $row['session_page'], $game_id);
			$game_id = (sizeof($game_id)) ? (int) $game_id[1] : 0;

			preg_match('#u=([0-9]+)#', $row['session_page'], $user_id);
			$user_id = (sizeof($user_id)) ? (int) $user_id[1] : 0;

			if ($game_id && $user_id)
			{
				if (!$game_name = $arcade->get_game_field($game_id, 'game_name'))
				{
					break;
				}

				// Get Username from User ID
				$username = $arcade->userdata('username', $user_id);

				if (!$username)
				{
					break;
				}

				$location = sprintf($user->lang[$lang . '_GAME_USER'], $game_name, $username);
				$location_url = $arcade->url($param . "&amp;g={$game_id}&amp;u={$user_id}");
				break;
			}
			else if ($game_id)
			{
				if (!$game_name = $arcade->get_game_field($game_id, 'game_name'))
				{
					break;
				}

				$location = sprintf($user->lang[$lang . '_GAME'], $game_name);
				$location_url = $arcade->url($param . "&amp;g={$game_id}");
				break;
			}
			else if ($user_id)
			{
				// Get Username from User ID
				$username = $arcade->userdata('username', $user_id);

				if (!$username)
				{
					break;
				}

				$location = sprintf($user->lang[$lang . '_USER'], $username);
				$location_url = $arcade->url($param . "&amp;u={$user_id}");
				break;
			}
			else
			{
				$location = $user->lang[$lang];
				$location_url = $arcade->url($param);
				break;
			}
		}
		else if (in_array($param, array('mode=search', 'mode=fav')))
		{
			if (($param == 'search' && !$auth_arcade->acl_get('u_arcade_search')) || ($param == 'fav' && !$auth_arcade->acl_get('u_arcade_favorites')))
			{
				break;
			}

			$location = $user->lang[$lang];
			$location_url = $arcade->url($param);
		}
		else if (in_array($param, array('mode=challenge', 'mode=rand_challenge', 'mode=champion_challenge')))
		{
			if (!$auth_arcade->acl_get('u_arcade_challenge'))
			{
				break;
			}

			$location = $user->lang[$lang];
			$location_url = $arcade->url('mode=challenge');
		}

		break;
	}
}

?>