<?php
/**
*
* @package arcade
* @version $Id: ajax.php 2018 2012-03-18 17:55:10Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

if (!isset($_POST['g']))
{
	exit;
}

define('IN_PHPBB', true);
define('IN_PHPBB_ARCADE', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH . '../../' : './../../';
$phpbb_root_relative_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin(false);
$auth->acl($user->data);
$user->setup();

$game_id = request_var('g', 0);
$rating	 = request_var('r', 0);
$fav	 = request_var('f', 0);
$cat_id	 = request_var('c', 0);
$mode	 = request_var('mode', '');
$chall	 = request_var('chall', false);

header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . 'GMT');
header('Cache-Control: no-cache, must-revalidate');
header('Pragma: no-cache');
header('Content-type: text/xml; charset=UTF-8');

$type = ($chall) ? 'challenge' : false;
include($phpbb_root_path . 'arcade/includes/common.' . $phpEx);

$set_data = (in_array($mode, array('quick_jump', 'game_jump'))) ? true : false;

$arcade = new arcade(false, $set_data, $chall);

if ($chall)
{
	include($phpbb_root_path . 'arcade/includes/class_challenge.'.$phpEx);
	$challenge = new challenge();
}

echo "<" . "?xml version='1.0' encoding='UTF-8' ?" . "><phpbbarcade>";

$challenge_blocked = ($chall && ($game_id == CHALLENGE_LOAD || $mode == 'quick_jump')) ? true : false;

if (!$user->data['is_registered'] && ($rating || $fav || $challenge_blocked))
{
	if ($user->data['is_bot'])
	{
		_arcade_print('error', 'Exit');
	}
	else
	{
		_arcade_print('error', 'session_time_end');
	}

	echo "</phpbbarcade>";

	garbage_collection();
	exit_handler();
}

if ($fav && !$auth_arcade->acl_get('u_arcade_favorites'))
{
	_arcade_print('error', 'Exit');
}

	$image = $info = '';
	$user_id = (int) $user->data['user_id'];

	if ($game_id && $cat_id && $rating)
	{
		$sql_ary = array(
			'game_id'		=> (int) $game_id,
			'user_id'		=> $user_id,
			'game_rating'	=> (int) $rating,
			'rating_date'	=> time(),
			'user_ip'		=> $user->ip);

		$sql = 'UPDATE ' . ARCADE_RATING_TABLE . '
				SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
				WHERE game_id = ' . (int) $game_id . '
				AND user_id	  = ' . $user_id;
		$db->sql_query($sql);

		if (!$db->sql_affectedrows())
		{
			$db->sql_return_on_error(true);
			$db->sql_query('INSERT INTO ' . ARCADE_RATING_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));
			$db->sql_return_on_error(false);

			$sql = 'UPDATE ' . ARCADE_GAMES_TABLE . '
					SET game_votetotal	= game_votetotal + 1,
						game_votesum	= game_votesum + ' . (int) $rating . '
					WHERE game_id = ' . (int) $game_id;
			$db->sql_query($sql);
		}

		$arcade->sync('rating', $game_id);

		$sql_array = array(
			'SELECT'	=> 'g.game_votetotal, g.game_votesum, r.game_rating',
			'FROM'		=> array(ARCADE_RATING_TABLE => 'r'),
			'LEFT_JOIN'	=> array(array(
			'FROM'		=> array(ARCADE_GAMES_TABLE	 => 'g'),
			'ON'		=> 'r.game_id = g.game_id')),
			'WHERE'		=> 'r.game_id = ' . (int) $game_id . ' AND r.user_id = ' . $user_id);

		$result	= $db->sql_query($db->sql_build_query('SELECT', $sql_array));
		$row	= $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		$c_new_rate = $auth_arcade->acl_get('c_re_rate', $cat_id) ? true : false;

		if ($row['game_votetotal'] > 0)
		{
			$star_width = (int) (($row['game_votesum'] / $row['game_votetotal']) * 16);
		}
		else
		{
			$star_width = 0;
		}

		$title = (!$c_new_rate && !empty($row['game_rating'])) ? sprintf($user->lang['ARCADE_RATING_ALREADY'], $rating) : '';

		$image = "<ul class='arcade-rate'" . ($title ? " title='{$title}'" : "") . ">
					<li class='arcade-current-rate' style='width:{$star_width}px;'></li>
					<li class='arcade-rating-num'><span title='{$user->lang['ARCADE_RATING_NUM']}'>({$row['game_votetotal']})</span></li>";

		if ($c_new_rate)
		{
			for ($x = 1; $x <= 5; $x++)
			{
				$image.= "<li><a onclick='arcade(\"rating\", \"{$game_id}\", \"{$x}\", \"{$cat_id}\", \"{$mode}\");return false;' title='" . sprintf($user->lang['ARCADE_RATING_VALUE'], $x) . "' alt='" . sprintf($user->lang['ARCADE_RATING_VALUE'], $x) . "' class='arcade-rate-{$x}' rel='nofollow'>{$x}</a></li>";
			}
		}

		$image.= "</ul>";
		$info = "<span class='arcade_ajax_info'>" . $user->lang['ARCADE_RATING_THX'] . "</span>";

		_arcade_print('image', $image);
		_arcade_print('info', $info);
	}
	else if ($game_id && $fav)
	{
		$fav_data = $fav_image = false;

		if ($fav == ARCADE_FAV_ADD)
		{
			$data = array(
				'user_id' => $user_id,
				'game_id' => (int) $game_id
			);

			$db->sql_return_on_error(true);
			$db->sql_query('INSERT INTO ' . ARCADE_FAVS_TABLE . ' ' . $db->sql_build_array('INSERT', $data));
			$db->sql_return_on_error(false);

			$fav_image	= str_replace($phpbb_root_path, $phpbb_root_relative_path, $arcade->get_image('src', 'img', 'remove_favorite.png'));
			$image		= "<a onclick='arcade(\"fav\", \"{$game_id}\", \"" . ARCADE_FAV_DEL . "\", \"\", \"{$mode}\"); return false;'><img class='arcade_fav' src='" . $fav_image . "' title='{$user->lang['ARCADE_REMOVE_FAV']}' alt='{$user->lang['ARCADE_REMOVE_FAV']}' /></a>";
			$info		= "<span class='arcade_ajax_info' style='vertical-align:middle;'>" . $user->lang['ARCADE_FAV_ADD'] . "</span>";
		}
		else if ($fav == ARCADE_FAV_DEL)
		{
			$sql = 'DELETE FROM ' . ARCADE_FAVS_TABLE . '
					WHERE game_id = ' . (int) $game_id . '
					AND   user_id = ' . $user_id;
			$db->sql_query($sql);

			$fav_image	= str_replace($phpbb_root_path, $phpbb_root_relative_path, $arcade->get_image('src', 'img', 'add_favorite.png'));
			$image		= "<a onclick='arcade(\"fav\", \"{$game_id}\", \"" . ARCADE_FAV_ADD . "\", \"\", \"{$mode}\"); return false;'><img class='arcade_fav' src='" . $fav_image . "' title='{$user->lang['ARCADE_ADD_FAV']}' alt='{$user->lang['ARCADE_ADD_FAV']}' /></a>";
			$info		= "<span class='arcade_ajax_info' style='vertical-align:middle;'>" . $user->lang['ARCADE_FAV_DEL'] . "</span>";
		}
		else
		{
			_arcade_print('error', $user->lang['NO_MODE']);
		}

		if ($fav_image)
		{
			if ($mode != '' && $arcade_config['search_cats'])
			{
				$game_fav_data = $arcade->get_fav_data();

				if (sizeof($game_fav_data))
				{
						$fav_data = '<select class="arcade-games-select" name="g">';

					foreach($game_fav_data as $game_id => $game)
					{
						$fav_data.= "<option value='{$game_id}'>{$game['game_name']}</option>";
					}
						$fav_data.= '</select>';
				}
			}

			_arcade_print('image', $image);
			_arcade_print('info', $info);

			if ($fav_data)
			{
				_arcade_print('favdata', $fav_data);
			}
		}
	}
	else if ($mode == 'quick_jump' || $mode == 'game_jump')
	{
		$played_game_color = str_replace('#', '', $arcade_config['played_colour']);

		if ($user->data['is_registered'] && $mode == 'quick_jump' && $played_game_color !== '')
		{
			$played_games = ($chall) ? $challenge->get_played_games() : $arcade->get_played_games();
		}

		if ($mode == 'quick_jump')
		{
			$games_list  = ($chall) ? '<select id="all_games" name="g" ' . ($played_game_color !== '' ? 'title="' . $user->lang['CHALLENGE_PLAYED_GAMES_HIGHLIGHT'] . '"' : '') . '>' : '<select class="arcade-games-select" name="g" ' . ($played_game_color !== '' && $user->data['is_registered'] ? 'title="' . $user->lang['ARCADE_PLAYED_GAMES_HIGHLIGHT'] . '"' : '') . '>';
		}
		else
		{
			$games_list  = '<select class="arcade-games-select" name="g">';
		}

		$fav_load = $fg_list = $g_list = false;

		$extra_data = ($mode == 'quick_jump') ? true : false;

		$play_games = ($chall) ? $challenge->play_games($extra_data) : $arcade->games;

		if ($chall && $game_id == CHALLENGE_LOAD)
		{
			$fav_load = ($auth_arcade->acl_get('u_arcade_favorites')) ? true : false;
			$fav_games  = '<select disabled="disabled" name="g" id="all_fav_games">';
		}

		$user_age = $arcade->user_age();
		$founder_exemption = ($arcade_config['founder_exempt'] && $user->data['user_type'] == USER_FOUNDER) ? true : false;

		foreach ($play_games as $gid => $game)
		{
			if ($mode == 'quick_jump')
			{
				$cat_age = $arcade->get_cat_field($game['cat_id'], 'cat_age');

				if (($arcade->get_cat_field($game['cat_id'], 'cat_status') == ITEM_LOCKED) || !$auth_arcade->acl_get('c_play', $game['cat_id']) || ($cat_age && !$founder_exemption && ($user_age === '' || ($user_age < $cat_age))))
				{
					continue;
				}

				$played = true;
				if (!isset($played_games[$gid]))
				{
					$played = false;
				}

				$games_list .= '<option value="' . $gid . '"'. ($played_game_color && !$played ? ' style="background-color: #' . $played_game_color . ';"' : '') .'>' . $game['game_name'] . '</option>';

				if ($fav_load && $game['game_fav'])
				{
					$fav_games .= '<option value="' . $gid . '">' . $game['game_name'] . '</option>';
					$fg_list = true;
				}
			}
			else
			{
				// Only show a game in the games statistics drop down if its been played
				if ((!$chall && $game['game_highuser'] == 0 && $game['game_highdate'] == 0) || ($chall && !$game['game_play']))
				{
					continue;
				}

				$games_list .= '<option value="'. $gid .'">'. $game['game_name'] .'</option>';
			}

			$g_list = true;
		}

		$games_list .= '</select>';

		$games_list = ($g_list === true) ? $games_list : $user->lang['ARCADE_NO_' . (($mode == 'quick_jump') ? 'GAMES' : 'PLAYS')];

		_arcade_print('gameslist', $games_list);

		if ($g_list === true)
		{
			_arcade_print('listenable', 'yes');
		}

		if ($chall && $game_id == CHALLENGE_LOAD)
		{
			$users_list = $user_friends = '';
			challenge_users_list($mode, $users_list, $user_friends);

			$fav_games .= '</select>';

			if ($fg_list !== true)
			{
				$fav_games = ($fav_load) ? $user->lang['ARCADE_NO_GAME_FAVS'] : 'off';
				_arcade_print('fav_radio', true);
			}

			$user_friends .= '</select>';

			if ($fu_list !== true)
			{
				$user_friends  = $user->lang['CHALLENGE_NO_FRIEND'];
				_arcade_print('friend_radio', true);
			}

			_arcade_print('fav_games', $fav_games);
			_arcade_print('userslist', $users_list);
			_arcade_print('user_friends', $user_friends);
		}
	}
	else if ($mode == 'user_jump' || $mode == 'stat_user_jump')
	{
		if (!$chall)
		{
			$u_list = false;

			$users_list  = '<select name="u">';

			foreach ($arcade->obtain_arcade_users() as $_uid => $_user)
			{
				$u_list = true;
				$users_list .= '<option value="'. $_uid .'">'. $_user['username'] .'</option>';
			}

			$users_list .= '</select>';

			$users_list = ($u_list === true) ? $users_list : $user->lang['ARCADE_NO_PLAYS'];
		}
		else
		{
			$users_list = $user_friends = '';
			challenge_users_list($mode, $users_list, $user_friends);
		}

		if ($u_list === true)
		{
			_arcade_print('listenable', 'yes');
		}

		_arcade_print('userslist', $users_list);
	}
	else
	{
		_arcade_print('error', $user->lang['NO_MODE']);
	}

	echo "</phpbbarcade>";
	garbage_collection();
	exit_handler();

	function challenge_users_list($mode, &$users_list, &$user_friends)
	{
		global $user, $phpbb_root_path, $phpbb_root_relative_path, $arcade, $challenge, $arcade_config, $arcade_cache, $game_id, $fu_list, $u_list;

		$played_user_color = str_replace('#', '', $arcade_config['played_colour']);

		if ($mode == 'quick_jump')
		{
			// Quick jump of all the users in the challenge...
			if ($played_user_color !== '' && $arcade_config['challenge_users_select'])
			{
				$played_users = $challenge->get_played_users();
			}

			if ($game_id == CHALLENGE_LOAD)
			{
				$user_friends .= '<select disabled="disabled" name="u" id="all_friend_users">';
				$friend = $challenge->friends();
			}
		}

		$users_list .= '<select id="all_users" name="u"' . (($mode == 'quick_jump' && $played_user_color !== '') ? ' title="' . $user->lang['CHALLENGE_PLAYED_USERS_HIGHLIGHT'] . '"' : '') . '>';

		$fu_list = $u_list = false;

		foreach ($challenge->obtain_all_users() as $user_id => $row)
		{
			if (($mode == 'quick_jump' && ($user_id == $user->data['user_id'])) || ($mode == 'stat_user_jump' && !$row['user_play']))
			{
				continue;
			}

			if ($mode == 'quick_jump' && $game_id == CHALLENGE_LOAD && !empty($friend[$user_id]) && $user_id == $friend[$user_id])
			{
				$user_friends .= '<option value="' . $user_id . '">' . $row['username'] . '</option>';
				$fu_list = true;
			}

			if ($mode == 'quick_jump' && $arcade_config['challenge_users_select'])
			{
				$played = true;
				if (!isset($played_users[$user_id]))
				{
					$played = false;
				}

				$users_list .= '<option value="'. $user_id .'"'. (($played_user_color && !$played) ? ' style="background-color: #'. $played_user_color .';"' : '') .'>'. $row['username'] .'</option>';
			}
			else if ($mode == 'stat_user_jump')
			{
				$users_list .= '<option value="'. $user_id .'">'. $row['username'] .'</option>';
			}

			$u_list = true;

			if ($mode == 'quick_jump' && !$arcade_config['challenge_users_select'])
			{
				break;
			}
		}

		$users_list .= '</select>';

		$users_list = ($mode == 'quick_jump' && !$arcade_config['challenge_users_select']) ? '<input type="text" class="inputbox autowidth" id="username" name="username" size="25" value="" /> <span id="find_username">[ <a href="' . str_replace($phpbb_root_path, $phpbb_root_relative_path, $arcade->url('mode=searchuser&amp;form=challenge&amp;field=username&amp;select_single=true', 'memberlist')) . '" onclick="find_username(this.href); return false;">' . $user->lang['FIND_USERNAME'] . '</a> ]</span>' : $users_list;

		if (!$u_list)
		{
			$users_list = $user->lang[($mode == 'quick_jump') ? 'CHALLENGE_NO_USERS' : 'CHALLENGE_NO_PLAYS'];
		}
	}

	function _arcade_xml($contents)
	{
		$contents = str_replace('&nbsp;', '', $contents);

		if ( preg_match('/\<(.*?)\>/xsi', $contents) )
		{
			$contents = preg_replace('/\<script[\s]+(.*)\>(.*)\<\/script\>/xsi', '', $contents);
		}

		if (!(strpos($contents, '>') === false) || !(strpos($contents, '<') === false) || !(strpos($contents, '&') === false))
		{
			if (!(strpos($contents, ']]>') === false))
			{
				return htmlspecialchars($contents);
			}
			else
			{
				return '<![CDATA[' . $contents . ']]>';
			}
		}
		else
		{
			return htmlspecialchars($contents);
		}

		return $contents;
	}

	function _arcade_print($xml, $value)
	{
		echo '<'.$xml.'>'. _arcade_xml($value) .'</'.$xml.'>';
	}

?>