/**
*
* @package arcade
* @version $Id: arcade.js 2017 2012-03-18 17:53:40Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

var arcade_flash_width = 640;
var arcade_flash_height = 480;

	function arcade(type, game_id, key, cat_id, mode)
	{
		var htar = http_arcade();
		var id = type;
		var params = '';

		switch (type)
		{
			case 'rating':
				params = 'g=' + game_id + '&mode=' + mode + '&c=' + cat_id + '&r=' + key;
				id = 'star_' + game_id;
			break;

			case 'fav':
				params = 'g=' + game_id + '&mode=' + mode + '&f=' + key;
				id = 'fav_' + game_id;
			break;

			case 'games_list':
				params  = 'g=1&mode=' + ((game_id == 1) ? 'quick_jump' : 'game_jump') + ((key == 'chall') ? '&chall=1' : '');
				id = (game_id == 1) ? 'header_loading' : 'stat_loading';
			break;

			case 'users_list':
				params  = 'g=1&mode=' + ((game_id == 1) ? 'user_jump' : 'stat_user_jump') + ((key == 'chall') ? '&chall=1' : '');
				id = (key != 'chall') ? 'user_loading' : ((game_id == 1) ? 'user_jump' : 'user_loading');
			break;

			case 'challenge':
				params = 'mode=quick_jump&chall=1&g=-1';
				id = 'challenge_view_submit';
			break;
		}

		arcadeHtml(id, '');
		arcade_loading_img(type, id, mode);

		try
		{
			if (htar.readyState == 4 || htar.readyState == 0)
			{
				htar.open('POST', root_path + 'arcade/js/ajax.' + phpex + '?rand='+Math.floor(Math.random() * 99999999), true);

				htar.onreadystatechange = function()
				{
					try
					{
						if (htar.readyState != 4)
						{
							return;
						}

						if (htar.readyState == 4)
						{
							arcade_xml = htar.responseXML;

							if (typeof arcade_xml != 'object')
							{
								arcade_error(id, 'arcade_error', arcade_lang['XML_ERROR']);
								return;
							}

							if (arcadeXGB('error') && arcadeXGB('error').length > 0)
							{
								var error = arcadeXGBV('error');

								if (error == 'Exit')
								{
									arcadeHtml(id, '');
									return false;
								}

								if (error == 'session_time_end')
								{
									timer_info = setTimeout('arcadeLoginPage();', 5000);
									error = arcade_lang['SESSION_TIME_END'];
								}

								arcade_error(id, 'arcade_error', error);
							}
							else
							{
								switch (type)
								{
									case 'rating':
										arcadeSetAtt(id, 'align', ((!mode) ? 'center' : 'left'));
										arcadeSW(id, 'auto');
									break;

									case 'fav':
									break;

									case 'games_list':
										var games_list  = (arcadeXGB('gameslist').length > 0) ? arcadeXGBV('gameslist') : '';

										if (!games_list)
										{
											arcade_error(id, 'arcade_error', arcade_lang['EMPTY_DATA']);
											return false;
										}
										else
										{
											if (arcadeXGB('listenable').length > 0)
											{
												arcadeSD(id, 'none');
												arcadeSD(((game_id == 1) ? 'all_games' : 'stat_all_games'), 'block');
												arcadeHtml(((game_id == 1) ? 'header_quick_jump' : 'stat_game_jump'), games_list);
											}
											else
											{
												arcadeHtml(id, games_list);
											}
										}
									break;

									case 'users_list':
										var users_list  = (arcadeXGB('userslist').length > 0) ? arcadeXGBV('userslist') : '';

										if (!users_list)
										{
											arcade_error(id, 'arcade_error', arcade_lang['EMPTY_DATA']);
											return false;
										}
										else
										{
											if (arcadeXGB('listenable').length > 0)
											{
												arcadeSD(id, 'none');
												arcadeSD('stat_all_users', 'block');
												arcadeHtml(((game_id == 1) ? 'user_jump' : 'stat_user_jump'), users_list);
											}
											else
											{
												arcadeHtml(id, users_list);
											}
										}
									break;

									case 'challenge':
										var games_list		= (arcadeXGB('gameslist').length > 0) ? arcadeXGBV('gameslist') : '';
										var fav_list		= (arcadeXGB('fav_games').length > 0) ? arcadeXGBV('fav_games') : '';
										var users_list		= (arcadeXGB('userslist').length > 0) ? arcadeXGBV('userslist') : '';
										var friends_list	= (arcadeXGB('user_friends').length > 0) ? arcadeXGBV('user_friends') : '';
										var fav_radio		= (arcadeXGB('fav_radio').length > 0) ? true : false;
										var friend_radio	= (arcadeXGB('friend_radio').length > 0) ? true : false;

										if (!games_list || !fav_list || !users_list || !friends_list)
										{
											arcade_error(id, 'arcade_error', arcade_lang['EMPTY_DATA']);
											return false;
										}
										else
										{
											arcadeHtml('challenge_view', '');
											arcadeSD('challenge_view', 'none');
											arcadeSD('challenge_box', 'block');
											window.location = '#challenge';
											arcadeHtml('header_quick_jump', games_list);
											arcadeHtml('users', users_list);
											arcadeHtml('friend_users', friends_list);

											if (fav_list != 'off')
											{
												if (fav_radio)
												{
													arcadeSetAtt('cr1', 'colspan', '2');
													arcadeSD('cg1', 'none');

													if (arcadeGEBI('cr2') != null)
													{
														arcadeSetAtt('cr2', 'colspan', '2');
														arcadeSD('cg2', 'none');
													}
												}

												arcadeHtml('fav_games', fav_list);
											}

											if (friend_radio)
											{
												arcadeSetAtt('cr3', 'colspan', '2');
												arcadeSD('cu1', 'none');

												if (arcadeGEBI('cr3') != null)
												{
													arcadeSetAtt('cr4', 'colspan', '2');
													arcadeSD('cu2', 'none');
												}
											}
										}
									break;

									default:
										return false;
									break;
								}

								if (type == 'rating' || type == 'fav')
								{
									arcade_replace_image(type, id, mode);
								}
							}
						}
					}
					catch (e)
					{
						arcade_error_file(e, id);
						return;
					}
				}

				htar.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
				htar.send(params);
			}
			else
			{
				arcade_error(id, 'arcade_error', arcade_lang['DOUBLE_REQUEST_FOUND']);
				return;
			}
		}
		catch (e)
		{
			arcade_error_file(e, id);
			return;
		}
	}

	function arcadeLoginPage()
	{
		window.location.href = root_path + 'ucp.' + phpex + '?mode=login';
	}

	function http_arcade()
	{
		try
		{
			var http_request = false;

			if (window.XMLHttpRequest)
			{	// Mozilla, Safari,...
				http_request = new XMLHttpRequest();

				if (http_request.overrideMimeType)
				{
					http_request.overrideMimeType('text/xml');
				}
			}
			else if (window.ActiveXObject)
			{	// IE
				try
				{
					http_request = new ActiveXObject('Msxml2.XMLHTTP');
				}
				catch (e)
				{
					try
					{
						http_request = new ActiveXObject('Microsoft.XMLHTTP');
					}

					catch (e)
					{
					}
				}
			}

			if (!http_request)
			{
				arcade_error(id, 'arcade_error', arcade_lang['REQUEST_ERROR']);
			}

			return http_request;
		}
		catch (e)
		{
			arcade_error_file(e, id);
			return false;
		}
	}

	function arcade_error_file(e, id)
	{
		var tmp = '<span class="arcade_error">'+ arcade_lang['ERROR'] +'</span><br /><br />';

		if (e.fileName && e.lineNumber)
		{
			tmp += e.fileName + ' <b>(' + e.lineNumber + ')</b><br /><br />';
		}

		tmp += '<span class="arcade_error">' + e.message + '</span>';

		arcadeSW(id, '98%');
		arcadeSH(id, 'auto');
		arcade_error(id, 'arcade_error_file', tmp);

		timer_info = setTimeout(arcade_error_close, 5000);

		function arcade_error_close()
		{
			arcadeHtml(id, '');
			arcadeSD(id, 'none');
			clearTimeout(timer_info);
		}
	}

	function arcade_error(id, cn, msg)
	{
		arcadeSW(id, '100%');
		arcadeSH(id, 'auto');
		arcadeGEBI(id).className = cn;
		arcadeHtml(id, msg);
	}

	function arcade_replace_image(type, id, mode)
	{
		mode = (mode == undefined) ? '' : mode;
		var image = (arcadeXGB('image').length > 0) ? arcadeXGBV('image') : '';
		var info  = (arcadeXGB('info').length > 0)  ? arcadeXGBV('info') : '';

		if (!image)
		{
			arcade_error(id, 'arcade_error', arcade_lang['EMPTY_DATA']);
			return false;
		}

		if (mode && type == 'fav' && arcadeGEBI('fav_games') != undefined)
		{
			var fav_data = (arcadeXGB('favdata').length > 0) ? arcadeXGBV('favdata') : '';

			if (fav_data)
			{
				arcadeSD('fav_games', 'block');
				arcadeSD('no_fav_game', 'none');
				arcadeHtml('arcade_fav_games', fav_data);
			}
			else
			{
				arcadeSD('fav_games', 'none');
				arcadeSD('no_fav_game', 'block');
			}
		}

		arcadeHtml(id, info);
		var timer_info = '';
		timer_info.id = setTimeout(arcade_add_image, 3000);

		function arcade_add_image()
		{
			if (type != 'fav' && mode)
			{
				arcadeSW(id, '80px');
			}

			arcadeHtml(id, image);
			clearTimeout(timer_info.id);
		};
	}

	function arcade_refresh_page(page_url)
	{
		if (window.opener && !window.opener.closed)
		{
			window.opener.location.reload(true);
			window.opener.location.href = page_url.replace(/&amp;/g, '&');
			window.self.close();
		}
	}

	function arcade_resize_screen(w, h)
	{
		window.self.resizeTo(screen.width * w, screen.height * h);
		window.moveTo((screen.width / 2) - ((screen.width * w) / 2), (screen.height / 2) - ((screen.height * h) / 2));
	}

	function arcade_popup_game(pop_page, w, h)
	{
		w = (arcade_intro == 'yes') ? arcade_flash_width : w;
		h = (arcade_intro == 'yes') ? arcade_flash_height : h;
		var lp = (screen.width)  ? (screen.width  - w) / 2 : 0;
		var tp = (screen.height) ? (screen.height - h) / 2 : 0;

		if (arcadeGEBI('bet') != null)
		{
			var bet = arcadeGEBI('bet').value;
			pop_page = pop_page + '&bet=' + bet;
		}

		var settings = 'height=' + h + ', width=' + w + ', top=' + tp + ', left=' + lp + ', scrollbars=yes, resizable=yes';
		var arcade_game_window = window.open(pop_page.replace(/&amp;/g, '&'), '_phpbbarcadegame', settings);

		if (window.focus)
		{
			arcade_game_window.focus();
		}

		return false;
	}

	function arcade_play_info_block()
	{
		if (arcadeGEBI('arcade_play_info_block').style.display == 'none')
		{
			arcadeSD('arcade_play_info_block', 'block');
			arcadeSetAtt('arcade_right_block_co', 'title', arcade_lang['INFO_BLOCK_CLOSE']);

			arcadeSW(gametop, '75%');
		}
		else
		{
			arcadeSD('arcade_play_info_block', 'none');
			arcadeSetAtt('arcade_right_block_co', 'title', arcade_lang['INFO_BLOCK_OPEN']);
			arcadeSW(gametop, '100%');
		}

		arcade_swf_object_resize('auto');
	}

	function arcade_swf_object()
	{
		var swf_file	= '';
		var flashvars	= {};
		var width		= (arcade_game_popup == 'yes') ? '100%' : parseInt((arcade_intro == 'yes') ? arcade_flash_width : arcade_game_width);
		var height		= (arcade_game_popup == 'yes') ? '100%' : parseInt((arcade_intro == 'yes') ? arcade_flash_height : arcade_game_height);

		if (arcade_game_popup == 'no')
		{
			var x = arcadeGEBI(gametop);

			if (width > x.offsetWidth && x.offsetWidth > 0)
			{
				var resize	= parseFloat((x.offsetWidth / width) - .05);
				width		= parseInt(resize * width);
				height		= parseInt(resize * height);
			}

			if ((arcade_intro == 'yes') && (arcade_game_width > x.offsetWidth && x.offsetWidth > 0))
			{
				var game_resize		= parseFloat((x.offsetWidth / arcade_game_width) - .05);
				arcade_game_width 	= parseInt(game_resize * arcade_game_width);
				arcade_game_height	= parseInt(game_resize * arcade_game_height);
			}
		}

		if (arcade_intro == 'yes')
		{
			swf_file	= arcade_swf;

			flashvars	= {
					gameName:	arcade_game_name,
					topTitle:	arcade_lang['TOP_SCORES'],
					topUser1:	arcade_topuser1,
					topUser2:	arcade_topuser2,
					topUser3:	arcade_topuser3,
					descTitle:	arcade_lang['GAME_DESC'],
					gameDesc:	arcade_game_desc
				};
		}
		else
		{
			swf_file	= arcade_game_swf;

			flashvars	= {
					g:					parseInt(arcade_game_id),
					game_sid:			arcade_game_sid,
					ibpro_gameid:		parseInt(arcade_game_gid),

					phpBBArcadeUrl:		root_path + 'arcade.' + phpex + '?swf=score',
					phpBBArcadeVars:	arcade_game_sid +
										'|' + arcade_game_gid +
										'|' + arcade_game_scorevar +
										'|' + root_path +
										'|' + phpex +
										'|'
				};
		}

		var params = {
				menu:		"false",
				quality:	"high"
			};

		swfobject.embedSWF(swf_file, 'phpbb_arcade_flash_game', width, height, arcade_flash_version, arcade_flash_player_up.replace(/&amp;/g, '&'), flashvars, params);
	}

	function arcade_gameSid()
	{
		return arcade_game_sid;
	}

	function arcade_swf_object_resize(size)
	{
		var container = arcadeGEBI('flash_game_window');
		var flash	  = arcadeGEBI('phpbb_arcade_flash_game');

		if (size == 'reduce')
		{
			if (container.offsetWidth < (5.75 * flash.offsetWidth))
			{
				flash.width  = parseInt(.75 * flash.offsetWidth);
				flash.height = parseInt(.75 * flash.offsetHeight);
			}
		}
		else if (size == 'increase')
		{
			if (container.offsetWidth > (1.25 * flash.offsetWidth))
			{
				flash.width  = parseInt(1.25 * flash.offsetWidth);
				flash.height = parseInt(1.25 * flash.offsetHeight);
			}
		}
		else
		{
			size = container.offsetWidth / arcade_game_width - .05;
			flash.width  = parseInt(size * arcade_game_width);
			flash.height = parseInt(size * arcade_game_height);
		}
	}

	function arcade_add_head()
	{
		var value = ".arcade-rate{background-image:url('" + star_img + "');}.arcade-rate li a:hover{background-image:url('" + star_img + "');}.arcade-rate li.arcade-current-rate{background-image:url('" + star_img + "');}";
		var arcade_head = document.getElementsByTagName("head")[0];
		var arcade_image = arcadeTN(value);

			arcade_style_node = arcadeEl("style");
			arcade_style_node.setAttribute("type", "text/css");

			if (arcade_style_node.styleSheet)
			{
				arcade_style_node.styleSheet.cssText = arcade_image.nodeValue;
			}
			else
			{
				arcade_style_node.appendChild(arcade_image);
			}

			arcade_head.appendChild(arcade_style_node);

		return false;
	}

	function arcade_full_screen()
	{
		arcade_intro		= 'no';
		arcade_game_popup	= 'yes';
		arcade_swf_object();

		document.write(
			'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n' +
			'<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr">\n' +
			'	<head>\n' +
			'		<meta http-equiv="content-type" content="text/html; charset=utf-8" />\n' +
			'		<title>' + arcade_game_name + '</title>\n' +
			'		<style type="text/css">\n' +
			'			/* <![CDATA[ */\n' +
			'				html{width: 100%; height: 100%; overflow: hidden;}\n' +
			'				body{font-family: "Lucida Grande", Verdana, Helvetica, Arial, sans-serif; width: 100%; height: 100%; margin: 0; padding: 0; background-color: #000; text-align:center; color:#C8C8C8;}\n' +
			'				#flashcontent{width: 100%; height: 100%;}\n' +
			'				#footer{font-size: 9px; margin-top: 5px;}#footer a{color: #F1F1F1; text-decoration: none;}\n' +
			'			/* ]]> */\n' +
			'		</style>\n' +
			'	</head>\n' +
			'	<body>\n' +
			'		<div id="' + gametop + '" style="display: none;">\n' +
			'			<div id="phpbb_arcade_flash_game" style="width: 100%; height: 100%;">\n' +
							arcadeGEBI('flash_game_window').innerHTML + '\n' +
			'			</div>\n' +
			'		</div>\n' +
			'		<div id="arcade_refresh" style="display: block; font-weight: bold; font-size: 15px; color: #ff0000;">F5 - ' + arcade_lang['REQUEST_ERROR'] + '</div>\n' +
			'		<div id="footer">Powered by <a href="http://phpbbarcade.origon.dk">phpBB Arcade</a> &copy; 2008-2012</div>\n' +
			'	</body>\n' +
			'</html>'
		);
		document.close();
		arcadeSD('arcade_refresh', 'none');
		arcadeSetAtt(gametop, 'style', 'width: 100%; height: 96%; display: block;');
	}

	function arcade_get_width()
	{
		var x = 0;

		if (self.innerWidth)
		{
			x = self.innerWidth;
		}
		else if (document.documentElement && document.documentElement.clientHeight)
		{
			x = document.documentElement.clientWidth;
		}
		else if (document.body)
		{
			x = document.body.clientWidth;
		}

		return x;
	}

	function arcade_game_play(mode)
	{
		form = document.forms['arcade_game_play'];

		switch (mode)
		{
			case 'random':
				var inp			= arcadeEl('input');
					inp.type	= 'hidden';
					inp.id		= 'mode';
					inp.name	= 'mode';
					inp.value	= 'random';
			form.appendChild(inp);
			break;
		}

		form.submit();
	}

	function arcade_get_height()
	{
		var y = 0;

		if (self.innerHeight)
		{
			y = self.innerHeight;
		}
		else if (document.documentElement && document.documentElement.clientHeight)
		{
			y = document.documentElement.clientHeight;
		}
		else if (document.body)
		{
			y = document.body.clientHeight;
		}

		return y;
	}

	function arcade_fit_screen()
	{
		var fw = (arcade_intro == 'yes') ? arcade_flash_width : arcade_game_width;
		var fh = (arcade_intro == 'yes') ? arcade_flash_height : arcade_game_height;

		if (arcade_intro == 'no' && arcadeGEBI('copyright') != null)
		{
			fh += 25;
			arcadeSD('copyright', 'block');
			arcadeSetAtt('gtop', 'style', 'width: 100%; height: 95%;');
		}

		if (arcade_get_width() != fw || arcade_get_height() != fh)
		{
			var w = 0
			var h = 0;
			w = fw - arcade_get_width() ;
			h = fh - arcade_get_height() ;
			window.self.resizeBy(w, h);
			window.self.moveTo((screen.width / 2) - (fw / 2), (screen.height / 2) - (fh / 2));
		}

		return false;
	}

	function arcade_loading_img(type, id, mode)
	{
		if (type != 'fav' && mode != undefined && mode)
		{
			arcadeSetAtt(id, 'align', 'center');
			arcadeSW(id, '80px');
		}

		var load_img = arcadeEl('img');

		if (type == 'games_list' || type == 'users_list' || type == 'challenge')
		{
			load_img.src = loading_img2;
		}
		else
		{
			var img_px = (type == 'fav') ? '13px' : '16px';

			load_img.src = loading_img1;
			load_img.style.width  = img_px;
			load_img.style.height = img_px;
		}

			load_img.style.verticalAlign = 'middle';
			arcadeGEBI(id).appendChild(load_img);
	}

	function arcade_game_start()
	{
		arcade_intro = 'no';
		arcade_swf_object();

		if (arcade_game_popup == 'yes')
		{
			arcade_fit_screen();
		}
		else
		{
			window.location = '#gametop';
		}
	}

	function challenge_box(ac, key)
	{
		if (ac == 'option')
		{
			var dgeP = arcadeGEBI('bet');
			var pV = dgeP.value;
			dgeP.value = '';
			key.defaultValue = ((key.defaultValue == 0) ? 1 : 0);
			arcadeSD('challenge_bet', ((key.defaultValue == 0) ? 'block' : 'none'));
			dgeP.focus();
			dgeP.value = pV;
		}
		else
		{
			arcadeSD('challenge_view', ((ac) ? 'none' : 'block'));
			arcadeSD('challenge_box', ((ac) ? 'block' : 'none'));

			if (ac)
			{
				window.location = '#challenge';
				challenge_game_user_radio_check();
			}
		}
	}

	function challenge_game_user_radio_check()
	{
		for (var i=1; i <= 2; i++)
		{
			if (arcadeGEBI('challenge_games' + [i]) != null && document.forms['challenge']['challenge_games' + [i]].checked)
			{
				challenge_select_type('games', ((document.forms['challenge']['challenge_games' + [i]].value == 1) ? true : false));
			}
		}

		for (var i=1; i <= 2; i++)
		{
			if (arcadeGEBI('challenge_users' + [i]) != null && document.forms['challenge']['challenge_users' + [i]].checked)
			{
				challenge_select_type('users', ((document.forms['challenge']['challenge_users' + [i]].value == 1) ? true : false));
			}
		}
	}

	function challenge_select_type(type, action)
	{
		var cua1 = (action) ? 'chall_active' : 'chall_inactive';
		var cua2 = (action) ? 'chall_inactive' : 'chall_active';
		var cua3 = (action) ? arcade_lang['ACTIVE'] : arcade_lang['INACTIVE'];
		var cua4 = (action) ? arcade_lang['INACTIVE'] : arcade_lang['ACTIVE'];

		switch (type)
		{
			case 'games':
				if (arcadeGEBI('all_games') != null && arcadeGEBI('all_fav_games') != null)
				{
					(action) ? arcadeRemAtt('all_games', 'disabled') : arcadeSetAtt('all_games', 'disabled', 'disabled');
					(action) ? arcadeSetAtt('challenge_games1', 'checked', 'checked') : arcadeRemAtt('challenge_games1', 'checked');
					(action) ? arcadeSetAtt('all_fav_games', 'disabled', 'disabled') : arcadeRemAtt('all_fav_games', 'disabled');
					(action) ? arcadeRemAtt('challenge_games2', 'checked') : arcadeSetAtt('challenge_games2', 'checked', 'checked');
					arcadeSetAtt('cg1', 'class', cua1);
					arcadeSetAtt('cg1', 'title', cua3);
					arcadeSetAtt('cg2', 'class', cua2);
					arcadeSetAtt('cg2', 'title', cua4);
				}
			break;

			case 'users':
				if (arcadeGEBI('all_friend_users') != null && (arcadeGEBI('all_users') != null || arcadeGEBI('username') != null))
				{
					if (arcadeGEBI('all_users') != null)
					{
						(action) ? arcadeRemAtt('all_users', 'disabled') : arcadeSetAtt('all_users', 'disabled', 'disabled');
					}
					else if (arcadeGEBI('username') != null)
					{
						(action) ? arcadeRemAtt('username', 'disabled') : arcadeSetAtt('username', 'disabled', 'disabled');

						arcadeSD('find_username', ((action) ? 'inline' : 'none'));

						if (!action)
						{
							document.forms['challenge']['username'].value = '';
						}
					}

					(action) ? arcadeSetAtt('challenge_users1', 'checked', 'checked') : arcadeRemAtt('challenge_users1', 'checked');
					(action) ? arcadeSetAtt('all_friend_users', 'disabled', 'disabled') : arcadeRemAtt('all_friend_users', 'disabled');
					(action) ? arcadeRemAtt('challenge_users2', 'checked') : arcadeSetAtt('challenge_users2', 'checked', 'checked');
					arcadeSetAtt('cu1', 'class', cua1);
					arcadeSetAtt('cu1', 'title', cua3);
					arcadeSetAtt('cu2', 'class', cua2);
					arcadeSetAtt('cu2', 'title', cua4);
				}
			break;
		}
	}

	function arcadeEl(e)
	{
		return document.createElement(e);
	}

	function arcadeTN(e)
	{
		return document.createTextNode(e);
	}

	function arcadeHtml(id, value)
	{
		arcadeGEBI(id).innerHTML = value;
	}

	function arcadeSD(id, value)
	{
		arcadeGEBI(id).style.display = value;
	}

	function arcadeSW(id, value)
	{
		arcadeGEBI(id).style.width = value;
	}

	function arcadeSH(id, value)
	{
		arcadeGEBI(id).style.height = value;
	}

	function arcadeSetAtt(id, key, value)
	{
		arcadeGEBI(id).setAttribute(key, value);
	}

	function arcadeRemAtt(id, key)
	{
		arcadeGEBI(id).removeAttribute(key);
	}

	function arcadeReloadPage()
	{
		window.parent.location.reload();
	}

	function arcadeGEBI(id)
	{
		return document.getElementById(id);
	}

	function arcadeXGB(id)
	{
		return arcade_xml.getElementsByTagName(id);
	}

	function arcadeXGBV(id)
	{
		return arcadeXGB(id)[0].childNodes[0].nodeValue;
	}