<?php
/**
*
* @package acp
* @version $Id: acp_arcade_settings.php 1967 2012-03-12 16:38:53Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_arcade_settings
{
	var $u_action;
	var $tpl_name;
	var $page_title;
	var $new_config = array();

	function main($id, $mode)
	{
		global $db, $user, $auth, $config, $template, $phpbb_admin_path, $phpbb_root_path, $phpEx;
		global $arcade, $auth_arcade, $arcade_cache, $arcade_config, $file_functions;

		define('IN_PHPBB_ARCADE', true);

		include($phpbb_root_path . 'arcade/includes/common.' . $phpEx);

		// Initialize arcade class
		$arcade = new arcade_admin();

		$form_key = 'acp_arcade';
		add_form_key($form_key);

		$submit = (isset($_POST['submit'])) ? true : false;

		switch ($mode)
		{
			case 'settings':
					$display_vars = array(
						'title'								=> 'ACP_ARCADE_SETTINGS_GENERAL',
						'vars'	=> array(
							'legend1'						=> 'ACP_ARCADE_SETTINGS_GENERAL',
							'arcade_disable'				=> array('lang' => 'DISABLE_ARCADE',					'validate' => 'bool',		'type' => 'custom',			'explain'	=> true,	'method' => 'arcade_disable'),
							'arcade_disable_msg'			=> false,
							'auto_disable'					=> array('lang' => 'ARCADE_AUTO_DISABLE',				'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'auto_disable_start'			=> array('lang' => 'ARCADE_AUTO_DISABLE_START',			'validate' => 'string',		'type' => 'text:5:5',		'explain'	=> true),
							'auto_disable_end'				=> array('lang' => 'ARCADE_AUTO_DISABLE_END',			'validate' => 'string',		'type' => 'text:5:5',		'explain'	=> true),
							'backup_limit'					=> array('lang' => 'ARCADE_BACKUP_LIMIT',				'validate' => 'int:5:100',	'type' => 'text:3:4',		'explain'	=> true),
							'load_list'						=> array('lang' => 'ARCADE_LOAD_LIST_LOADING',			'validate' => 'bool', 		'type' => 'custom',			'explain'	=> true,	'method' => 'load_list'),
							'game_comment'					=> array('lang' => 'ARCADE_GAME_COMMENT_ENABLED', 		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'download_list'					=> array('lang' => 'ARCADE_DOWNLOAD_LIST', 				'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'download_list_message'			=> array('lang' => 'ARCADE_DOWNLOAD_LIST_MESSAGE',		'validate' => 'string',		'type' => 'textarea:3:40',	'explain'	=> true),
							'download_on_demand'			=> array('lang' => 'ARCADE_DOWNLOAD_ON_DEMAND', 		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'download_file_type'			=> array('lang' => 'ARCADE_DOWNLOAD_FILE_TYPE', 		'validate' => 'string',		'type' => 'select',			'explain'	=> false,	'method' => 'download_file_type_select'),
							'new_games_delay'				=> array('lang' => 'ARCADE_NEW_GAMES_DELAY',			'validate' => 'int:1',		'type' => 'text:3:4',		'explain'	=> true,	'append' => ' ' . $user->lang['DAYS']),
							'flash_version'					=> array('lang' => 'ARCADE_ACP_FLASH_VERSION',			'validate' => 'string:7:15','type' => 'text:16:15',		'explain'	=> true),
							'parse_bbcode'					=> array('lang' => 'ARCADE_COMMENTS_BBCODE', 			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'parse_smilies'					=> array('lang' => 'ARCADE_COMMENTS_SMILIES', 			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'parse_links'					=> array('lang' => 'ARCADE_COMMENTS_LINKS', 			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'played_colour'					=> array('lang' => 'ARCADE_PLAYED_GAMES_COLOUR',		'validate' => 'string',		'type' => 'custom',			'explain'	=> true,	'method' => 'arcade_colour_palette'),
							'cache_time'					=> array('lang' => 'ARCADE_CACHE_TIME',					'validate' => 'int:1',		'type' => 'text:4:5',		'explain'	=> true,	'append' => ' ' . $user->lang['HOURS']),
							'online_time'					=> array('lang' => 'ARCADE_ONLINE_TIME',				'validate' => 'int:',		'type' => 'text:4:5',		'explain'	=> true,	'append' => ' ' . $user->lang['MINUTES']),
							'session_length'				=> array('lang' => 'ARCADE_SESSION_LENGTH',				'validate' => 'int:3600',	'type' => 'text:4:5',		'explain'	=> true,	'append' => ' ' . $user->lang['SECONDS']),

							'legend2'						=> 'ACP_ARCADE_SETTINGS_FLOOD',
							'play_anonymous_interval'		=> array('lang' => 'ARCADE_PLAY_INTERVAL_GUEST',		'validate' => 'int:0:3600',	'type' => 'text:3:10',		'explain'	=> true,	'append' => ' ' . $user->lang['SECONDS']),
							'play_interval'					=> array('lang' => 'ARCADE_PLAY_INTERVAL',				'validate' => 'int:0:3600',	'type' => 'text:3:10',		'explain'	=> true,	'append' => ' ' . $user->lang['SECONDS']),
							'download_anonymous_interval'	=> array('lang' => 'ARCADE_DOWNLOAD_INTERVAL_GUEST',	'validate' => 'int:0:3600',	'type' => 'text:3:10',		'explain'	=> true,	'append' => ' ' . $user->lang['SECONDS']),
							'download_interval'				=> array('lang' => 'ARCADE_DOWNLOAD_INTERVAL',			'validate' => 'int:0:3600',	'type' => 'text:3:10',		'explain'	=> true,	'append' => ' ' . $user->lang['SECONDS']),
							'search_anonymous_interval'		=> array('lang' => 'ARCADE_SEARCH_INTERVAL_GUEST',		'validate' => 'int:0:3600',	'type' => 'text:3:10',		'explain'	=> true,	'append' => ' ' . $user->lang['SECONDS']),
							'search_interval'				=> array('lang' => 'ARCADE_SEARCH_INTERVAL',			'validate' => 'int:0:3600',	'type' => 'text:3:10',		'explain' 	=> true,	'append' => ' ' . $user->lang['SECONDS']),
						));

				if ($user->data['user_type'] == USER_FOUNDER)
				{
						$display_vars['vars'] += array(
							'legend3'						=> 'ACP_ARCADE_SETTINGS_FOUNDER',
							'founder_exempt'				=> array('lang' => 'ARCADE_FOUNDER_EXEMPT',				'validate' => 'bool',		'type' => 'radio:yes_no',	'explain' 	=> true),
							'search_filter_age'				=> array('lang' => 'ARCADE_SEARCH_FILTER_AGE',			'validate' => 'int',		'type' => 'select',			'explain'	=> true,	'method'	=> 'search_check_select'),
							'search_filter_password'		=> array('lang' => 'ARCADE_SEARCH_FILTER_PASSWORD',		'validate' => 'int',		'type' => 'select',			'explain'	=> true,	'method'	=> 'search_check_select'),
						);
				}

				if ($arcade->points['installed'] && $auth->acl_get('a_arcade_points_settings'))
				{
						$display_vars['vars'] += array(
							'legend4'						=> 'ACP_ARCADE_POINTS',
							'use_points'					=> array('lang' => 'ARCADE_USE_POINTS',					'validate' => 'bool', 		'type' => 'custom',			'method'	=>			'points_detect',		'explain' => true),
						);

					if ($arcade->points['type'] == ARCADE_CASH_MOD)
					{
						$display_vars['vars'] += array(
							'cm_currency_id'				=> array('lang' => 'ARCADE_CM_CURRENCY',				'validate' => 'string',		'type' => 'select',			'method'	=>			'cm_currency_select',	'explain' => true),
						);
					}

						$display_vars['vars'] += array(
							'game_download_cost'			=> array('lang' => 'ARCADE_GLOBAL_GAME_DOWNLOAD_COST', 	'validate' => 'string',		'type' => 'text:10:11', 	'explain'	=> true,	'append' => ' ' . $arcade->points['name']),
							'game_cost'						=> array('lang' => 'ARCADE_GLOBAL_GAME_COST', 			'validate' => 'string',		'type' => 'text:10:11', 	'explain'	=> true,	'append' => ' ' . $arcade->points['name']),
							'game_reward'					=> array('lang' => 'ARCADE_GLOBAL_GAME_REWARD',			'validate' => 'string',		'type' => 'text:10:11', 	'explain'	=> true,	'append' => ' ' . $arcade->points['name']),
							'use_jackpot'					=> array('lang' => 'ARCADE_GLOBAL_USE_JACKPOT',			'validate' => 'bool',		'type' => 'radio:yes_no', 	'explain'	=> true),
							'jackpot_Minimum'				=> array('lang' => 'ARCADE_JACKPOT_MINIMUM',			'validate' => 'string',		'type' => 'text:10:11', 	'explain'	=> true,	'append' => ' ' . $arcade->points['name']),
							'jackpot_Maximum'				=> array('lang' => 'ARCADE_JACKPOT_MAXIMUM',			'validate' => 'string',		'type' => 'text:10:11', 	'explain'	=> true,	'append' => ' ' . $arcade->points['name']),
							'playfree_reward'				=> array('lang' => 'ARCADE_PLAYFREE_REWARD',			'validate' => 'bool',		'type' => 'radio:yes_no', 	'explain'	=> true),
						);
				}

						$display_vars['vars'] += array(
							'legend5'						=> 'ACP_SUBMIT_CHANGES'
						);
			break;

			case 'game':
					$display_vars = array(
						'title'								=> 'ACP_ARCADE_SETTINGS_GAME',
						'vars'	=> array(
							'legend1'						=> 'ACP_ARCADE_SETTINGS_GAME',
							'game_zero_negative_score'		=> array('lang' => 'ARCADE_GAME_ZERO_NEGATIVE_SCORE',	'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'game_autosize'					=> array('lang' => 'ARCADE_GLOBAL_GAME_AUTOSIZE',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'game_width'					=> array('lang' => 'ARCADE_GLOBAL_GAME_WIDTH',			'validate' => 'int:',		'type' => 'text:3:4',		'explain'	=> true),
							'game_height'					=> array('lang' => 'ARCADE_GLOBAL_GAME_HEIGHT',			'validate' => 'int:',		'type' => 'text:3:4',		'explain'	=> true),
							'override_user_sort'			=> array('lang' => 'ARCADE_OVERRIDE_USER_SORT', 		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'games_sort_order'				=> array('lang' => 'ARCADE_GAMES_SORT_ORDER',  			'validate' => 'string',		'type' => 'select',			'explain'	=> true,	'method'	=> 'games_sort_order_select'),
							'games_sort_dir'				=> array('lang' => 'ARCADE_GAMES_SORT_DIR',  			'validate' => 'string',		'type' => 'select',			'explain'	=> true,	'method'	=> 'games_sort_dir_select'),
							'games_per_page'				=> array('lang' => 'ARCADE_GAMES_PER_PAGE',				'validate' => 'int:3',		'type' => 'text:3:4',		'explain'	=> true),

							'legend2'						=> 'ARCADE_SCORE_SECURITY',
							'corrupt_score_banned'			=> array('lang' => 'ARCADE_CORRUPT_SCORE_BANNED',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'score_security_level'			=> array('lang' => 'ARCADE_SCORE_SECURITY_LEVEL',		'validate' => 'int',		'type' => 'select',			'explain'	=> true,	'method'	=> 'score_security_level'),
							'legend3'						=> 'ACP_SUBMIT_CHANGES'
						));
			break;

			case 'challenge':
					$display_vars = array(
						'title'								=> 'ACP_ARCADE_SETTINGS_CHALLENGE',
						'vars'	=> array(
							'legend1'						=> 'ACP_ARCADE_SETTINGS_CHALLENGE',
							'challenge_disable'				=> array('lang' => 'DISABLE_CHALLENGE',					'validate' => 'bool',		'type' => 'custom',			'explain'	=> true,	'method' => 'challenge_disable'),
							'challenge_disable_msg'			=> false,
							'challenge_users_select'		=> array('lang' => 'ACP_CHALLENGE_USER_SELECT_TYPE',	'validate' => 'bool',		'type' => 'custom',			'explain'	=> true,	'method' => 'challenge_users_select'),
							'challenge_acc_exp_date'		=> array('lang' => 'CHALLENGE_ACC_EXP_DATE',			'validate' => 'int:',		'type' => 'select',			'explain'	=> true,	'method' => 'challenge_exp_date_select'),
							'challenge_ong_exp_date'		=> array('lang' => 'CHALLENGE_ONG_EXP_DATE',			'validate' => 'int:',		'type' => 'select',			'explain'	=> true,	'method' => 'challenge_exp_date_select'),
						));

				if ($arcade->points['installed'] && $auth->acl_get('a_arcade_points_settings'))
				{
						$display_vars['vars'] += array(
							'legend2'						=> 'ACP_ARCADE_POINTS',
							'challenge_bet_Minimum'			=> array('lang' => 'CHALLENGE_BET_MIN',					'validate' => 'string',		'type' => 'text:10:11',		'explain'	=> true,	'append' => ' ' . $arcade->points['name']),
							'challenge_bet_Maximum'			=> array('lang' => 'CHALLENGE_BET_MAX',					'validate' => 'string',		'type' => 'text:10:11',		'explain'	=> true,	'append' => ' ' . $arcade->points['name']),
							'challenge_bet_fix'				=> array('lang' => 'CHALLENGE_BET_FIX',					'validate' => 'string',		'type' => 'text:10:11',		'explain'	=> true,	'append' => ' ' . $arcade->points['name']),
						);
				}

						$display_vars['vars'] += array(
							'legend3'						=> 'ACP_SUBMIT_CHANGES'
						);
			break;

			case 'feature':
					$display_vars = array(
						'title'								=> 'ACP_ARCADE_SETTINGS_FEATURE',
						'vars'	=> array(
							'legend1'						=> 'ACP_ARCADE_SETTINGS_PM',
							'send_arcade_pm'				=> array('lang' => 'ARCADE_SEND_PM',					'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),

							'legend2'						=> 'ACP_ARCADE_SETTINGS_ANNOUNCE',
							'announce_game'					=> array('lang' => 'ARCADE_ANNOUNCE_GAME',				'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'announce_forum'				=> array('lang' => 'ARCADE_ANNOUNCE_FORUM',				'validate' => 'int:',		'type' => 'select', 		'explain'	=> true,	'method'	=> 'arcade_announce_game'),
							'announce_subject'				=> array('lang' => 'ARCADE_ANNOUNCE_SUBJECT',			'validate' => 'string',		'type' => 'textarea:5:25',	'explain'	=> true),
							'announce_message'				=> array('lang' => 'ARCADE_ANNOUNCE_MESSAGE',			'validate' => 'string',		'type' => 'textarea:8:25',	'explain'	=> true),

							'legend3'						=> 'ACP_ARCADE_SETTINGS_PLAY',
							'limit_play'					=> array('lang' => 'ARCADE_LIMIT_PLAY',					'validate' => 'int:',		'type' => 'select',			'explain'	=> true,	'method'	=> 'arcade_limit_play_select'),
							'limit_play_total_posts'		=> array('lang' => 'ARCADE_LIMIT_PLAY_TOTAL_POSTS',		'validate' => 'int:',		'type' => 'text:3:4',		'explain'	=> true),
							'limit_play_posts'				=> array('lang' => 'ARCADE_LIMIT_PLAY_POSTS',			'validate' => 'int:',		'type' => 'text:3:4',		'explain'	=> true),
							'limit_play_days'				=> array('lang' => 'ARCADE_LIMIT_PLAY_DAYS',			'validate' => 'int:',		'type' => 'text:3:4',		'explain'	=> true),

							'legend4'						=> 'ARCADE_SETTINGS_GAME_SHARE',
							'share_icons_enable'			=> array('lang' => 'ARCADE_SHARE_ICONS_ENABLE',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'facebook_like_enable'			=> array('lang' => 'ARCADE_FACEBOOK_LIKE_ENABLE',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'google_like_enable'			=> array('lang' => 'ARCADE_GOOGLE_LIKE_ENABLE',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'tweet_like_enable'				=> array('lang' => 'ARCADE_TWEET_LIKE_ENABLE',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'like_counter_enable'			=> array('lang' => 'ARCADE_LIKE_COUNTER_ENABLE',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'like_background_color'			=> array('lang' => 'ARCADE_BACKGROUND_COLOR',			'validate' => 'string',		'type' => 'custom',			'explain'	=> true,	'method'	=> 'arcade_colour_palette'),

							'legend5'						=> 'ACP_SUBMIT_CHANGES'
						));
			break;

			case 'apage':
					$display_vars = array(
						'title'								=> 'ACP_ARCADE_SETTINGS_ARCADE_PAGE',
						'vars'	=> array(
							'legend1'						=> 'ACP_ARCADE_SETTINGS_PAGE_GENERAL',
							'display_game_image'			=> array('lang' => 'ARCADE_DISPLAY_GAME_IMAGE',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'enable_image_link'				=> array('lang' => 'ARCADE_ENABLE_IMAGE_LINK',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'display_game_popup_icon'		=> array('lang' => 'ARCADE_DISPLAY_GAME_POPUP_ICON',	'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'display_user_avatar'			=> array('lang' => 'ARCADE_DISPLAY_USER_AVATAR',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'enable_user_avatar_link'		=> array('lang' => 'ARCADE_ENABLE_USER_AVATAR_LINK',	'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'gamename_maxchars'				=> array('lang' => 'ARCADE_GAMENAME_MAXCHARS',			'validate' => 'int:0',		'type' => 'text:4:5',		'explain'	=> true),
							'stat_items_per_page'			=> array('lang' => 'ARCADE_STAT_ITEMS_PER_PAGE',		'validate' => 'int:3',		'type' => 'text:4:5',		'explain'	=> true),
							'smilies_popup_width'			=> array('lang' => 'ARCADE_SMILIES_POPUP_WIDTH',		'validate' => 'int:200',	'type' => 'text:4:5',		'explain'	=> false),
							'smilies_popup_height'			=> array('lang' => 'ARCADE_SMILIES_POPUP_HEIGHT',		'validate' => 'int:200',	'type' => 'text:4:5',		'explain'	=> false),

							'legend2'						=> 'ACP_ARCADE_SETTINGS_HEADER',
							'newest_games'					=> array('lang' => 'ARCADE_NEWEST_GAMES_HEADER',		'validate' => 'int:3',		'type' => 'text:2:3',		'explain'	=> true),
							'latest_highscores'				=> array('lang' => 'ARCADE_LATEST_HIGHSCORES_HEADER',	'validate' => 'int:3',		'type' => 'text:2:3',		'explain'	=> true),
							'arcade_leaders_header'			=> array('lang' => 'LEADERS_HEADER',					'validate' => 'int:3:9',	'type' => 'select',			'explain'	=> true,	'method'	=> 'leaders_header_select'),

							'legend3'						=> 'ACP_ARCADE_SETTINGS_PAGE_INDEX',
							'welcome_index'					=> array('lang' => 'ARCADE_DISPLAY_WELCOME_BOX',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'search_index'					=> array('lang' => 'ARCADE_DISPLAY_SEARCH_BOX',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'links_index'					=> array('lang' => 'ARCADE_DISPLAY_LINKS_BOX',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),

							'legend4'						=> 'ACP_ARCADE_SETTINGS_PAGE_CATS',
							'welcome_cats'					=> array('lang' => 'ARCADE_DISPLAY_WELCOME_BOX',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'search_cats'					=> array('lang' => 'ARCADE_DISPLAY_SEARCH_BOX',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'links_cats'					=> array('lang' => 'ARCADE_DISPLAY_LINKS_BOX',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'cat_leaders'					=> array('lang' => 'LEADERS',							'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'cat_most_popular'				=> array('lang' => 'ARCADE_MOST_POPULAR',				'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'cat_least_popular'				=> array('lang' => 'ARCADE_LEAST_POPULAR',				'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'cat_most_played_users'			=> array('lang' => 'ARCADE_MOST_PLAYED_USERS',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'cat_least_played_users'		=> array('lang' => 'ARCADE_LEAST_PLAYED_USERS',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'cat_most_downloaded'			=> array('lang' => 'ARCADE_MOST_DOWNLOADED',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'cat_least_downloaded'			=> array('lang' => 'ARCADE_LEAST_DOWNLOADED',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'cat_longest_held_scores'		=> array('lang' => 'ARCADE_LONGEST_HELD_SCORES',		'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),

							'legend5'						=> 'ACP_ARCADE_SETTINGS_PAGE_STATS',
							'welcome_stats'					=> array('lang' => 'ARCADE_DISPLAY_WELCOME_BOX', 		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'search_stats'					=> array('lang' => 'ARCADE_DISPLAY_SEARCH_BOX', 		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'links_stats'					=> array('lang' => 'ARCADE_DISPLAY_LINKS_BOX', 			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'arcade_leaders'				=> array('lang' => 'LEADERS',							'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'most_popular'					=> array('lang' => 'ARCADE_MOST_POPULAR',				'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'least_popular'					=> array('lang' => 'ARCADE_LEAST_POPULAR',				'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'most_played_users'				=> array('lang' => 'ARCADE_MOST_PLAYED_USERS',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'least_played_users'			=> array('lang' => 'ARCADE_LEAST_PLAYED_USERS',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'most_downloaded'				=> array('lang' => 'ARCADE_MOST_DOWNLOADED',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'least_downloaded'				=> array('lang' => 'ARCADE_LEAST_DOWNLOADED',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'longest_held_scores'			=> array('lang' => 'ARCADE_LONGEST_HELD_SCORES',		'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),

							'legend6'						=> 'ACP_ARCADE_SETTINGS_PAGE_PLAY',
							'arcade_flash_intro'			=> array('lang' => 'ARCADE_FLASH_INTRO',				'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'display_desc'					=> array('lang' => 'ARCADE_DISPLAY_DESC', 				'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'game_desc_parse_html'			=> array('lang' => 'ARCADE_DISPLAY_DESC_PARSE_HTML', 	'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'display_game_type'				=> array('lang' => 'ARCADE_DISPLAY_GAME_TYPE', 			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'resolution_select'				=> array('lang' => 'ARCADE_RESOLUTION_SELECT', 			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'game_scores'					=> array('lang' => 'ARCADE_TOTAL_GAME_SCORES',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),

							'legend7'						=> 'ACP_ARCADE_SETTINGS_PAGE_BOARD',
							'display_viewtopic'				=> array('lang' => 'ARCADE_DISPLAY_VIEWTOPIC',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'display_memberlist'			=> array('lang' => 'ARCADE_DISPLAY_MEMBERLIST',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),

							'legend8'						=> 'ACP_ARCADE_SETTINGS_PAGE_ACP',
							'acp_items_per_page'			=> array('lang' => 'ARCADE_ACP_ITEMS_PER_PAGE',			'validate' => 'int:5',		'type' => 'text:3:4',		'explain'	=> true),
							'download_list_per_page'		=> array('lang' => 'ARCADE_DOWNLOAD_LIST_PER_PAGE',		'validate' => 'int:50',		'type' => 'select',			'explain'	=> true,	'method'	=> 'download_list_per_page_select'),

							'legend9'						=> 'ACP_SUBMIT_CHANGES'
						));
			break;

			case 'cpage':
					$display_vars = array(
						'title'								=> 'ACP_ARCADE_SETTINGS_CHALLENGE_PAGE',
						'vars'	=> array(
							'legend1'						=> 'ACP_ARCADE_SETTINGS_HEADER',
							'challenge_top_games_header'	=> array('lang' => 'CHALLENGE_TOP_GAMES_HEADER',		'validate' => 'int:3',		'type' => 'text:2:3',		'explain'	=> true),
							'challenge_latest_winners'		=> array('lang' => 'CHALLENGE_LATEST_WINNERS_HEADER',	'validate' => 'int:3',		'type' => 'text:2:3',		'explain'	=> true),
							'challenge_leaders_header'		=> array('lang' => 'LEADERS_HEADER',					'validate' => 'int:3:9',	'type' => 'select',			'explain'	=> true,	'method' => 'leaders_header_select'),

							'legend2'						=> 'ACP_ARCADE_SETTINGS_PAGE_INDEX',
							'challenge_welcome_index'		=> array('lang' => 'ARCADE_DISPLAY_WELCOME_BOX',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'challenge_links_index'			=> array('lang' => 'ARCADE_DISPLAY_LINKS_BOX',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),

							'legend3'						=> 'ACP_ARCADE_SETTINGS_PAGE_STATS',
							'challenge_welcome_stats'		=> array('lang' => 'ARCADE_DISPLAY_WELCOME_BOX',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'challenge_links_stats'			=> array('lang' => 'ARCADE_DISPLAY_LINKS_BOX',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> false),
							'challenge_leaders'				=> array('lang' => 'LEADERS',							'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'challenge_most_popular'		=> array('lang' => 'ARCADE_MOST_POPULAR',				'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'challenge_least_popular'		=> array('lang' => 'ARCADE_LEAST_POPULAR',				'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'challenge_most_played_users'	=> array('lang' => 'ARCADE_MOST_PLAYED_USERS',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),
							'challenge_least_played_users'	=> array('lang' => 'ARCADE_LEAST_PLAYED_USERS',			'validate' => 'int:0',		'type' => 'text:3:4',		'explain'	=> true),

							'legend4'						=> 'ACP_SUBMIT_CHANGES'
						));
			break;

			case 'path':
					$display_vars = array(
						'title'								=> 'ACP_ARCADE_SETTINGS_PATH',
						'vars'	=> array(
							'legend1'						=> 'ACP_ARCADE_SETTINGS_PROTECT',
							'protect_phpbbarcade'			=> array('lang' => 'ARCADE_PROTECT_PHPBBARCADE',		'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'protect_amod'					=> array('lang' => 'ARCADE_PROTECT_AMOD',				'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'protect_ibpro'					=> array('lang' => 'ARCADE_PROTECT_IBPRO',				'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),
							'protect_v3arcade'				=> array('lang' => 'ARCADE_PROTECT_V3ARCADE',			'validate' => 'bool',		'type' => 'radio:yes_no',	'explain'	=> true),

							'legend2'						=> 'ACP_ARCADE_SETTINGS_PATH',
							'game_path'						=> array('lang' => 'ARCADE_GAME_PATH',					'validate' => 'wpath',		'type' => 'text:30:65',		'explain'	=> true),
							'unpack_game_path'				=> array('lang' => 'ARCADE_UNPACK_GAME_PATH',			'validate' => 'wpath',		'type' => 'text:30:65',		'explain'	=> true),
							'image_path'					=> array('lang' => 'ARCADE_IMAGE_PATH',					'validate' => 'path',		'type' => 'text:30:65',		'explain'	=> true),
							'cat_image_path'				=> array('lang' => 'ARCADE_CAT_IMAGE_PATH',				'validate' => 'path',		'type' => 'text:30:65',		'explain'	=> true),
							'cat_backup_path'				=> array('lang' => 'ARCADE_CAT_BACKUP_PATH',			'validate' => 'wpath',		'type' => 'text:30:65',		'explain'	=> true),

							'legend3'						=> 'ACP_SUBMIT_CHANGES'
						));
			break;

			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}

		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		$this->new_config = $arcade_config;
		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);
		$this->validate_configs($display_vars['vars'], $cfg_array, $error);

		if ($submit && !check_form_key($form_key))
		{
			$error[] = $user->lang['FORM_INVALID'];
		}

		// Do not write values if there is an error
		if (sizeof($error))
		{
			$submit = false;
		}

		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}

			$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];

			if ($submit)
			{
				if (in_array($config_name, array('game_download_cost', 'game_cost', 'game_reward', 'jackpot_Minimum', 'jackpot_Maximum', 'challenge_bet_Minimum', 'challenge_bet_Maximum', 'challenge_bet_fix')))
				{
					$negative = (in_array($config_name, array('jackpot_Minimum', 'jackpot_Maximum', 'challenge_bet_Minimum', 'challenge_bet_Maximum', 'challenge_bet_fix'))) ? true : false;
					$arcade->float_num($config_value, $negative);
				}

				if ($config_name == 'download_list_per_page' && !in_array($config_value, array(50, 100, 200, 400)))
				{
					$config_value = 50;
				}

				if (in_array($config_name, array('arcade_leaders_header', 'challenge_leaders_header')) && !in_array($config_value, array(3, 6, 9)))
				{
					$config_value = 3;
				}

				if (in_array($config_name, array('game_path', 'unpack_game_path', 'image_path', 'cat_image_path', 'cat_backup_path')))
				{
					$file_functions->append_slash($config_value);
				}

				$arcade->set_config($config_name, $config_value);

				if ($config_name == 'jackpot_Minimum')
				{
					$arcade->reset('jackpot_min_max');
				}
			}
		}

		if ($submit)
		{
			add_log('admin', 'LOG_ARCADE_' . strtoupper($mode));
			$arcade_cache->destroy('sql', ARCADE_CATS_TABLE);
			$arcade_cache->destroy('sql', ARCADE_GAMES_TABLE);
			$arcade_cache->destroy('_arcade_leaders');
			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}

		$this->tpl_name = 'acp_board';
		$this->page_title = $display_vars['title'];

		$template->assign_vars(array(
			'L_TITLE'				=> $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN'		=> $user->lang[$display_vars['title'] . '_EXPLAIN'],

			'S_ERROR'				=> (sizeof($error)) ? true : false,
			'ERROR_MSG'				=> implode('<br />', $error),

			'U_ACTION'				=> $this->u_action
		));

		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'	=> true,
					'LEGEND'	=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars
				));

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			if (in_array($config_key, array('game_download_cost', 'game_cost', 'game_reward', 'jackpot_Minimum', 'jackpot_Maximum', 'challenge_bet_Minimum', 'challenge_bet_Maximum', 'challenge_bet_fix')))
			{
				$this->new_config[$config_key] = $arcade->number_format($this->new_config[$config_key], true);
			}

			$content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);

			if (empty($content))
			{
				continue;
			}

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'CONTENT'		=> $content
			));

			unset($display_vars['vars'][$config_key]);
		}
	}

	function arcade_announce_game($value, $key = '')
	{
		return make_forum_select($value, false, true, true, true, false, false);
	}

	function arcade_limit_play_select($value, $key = '')
	{
		global $user;

		return '<option value="' . LIMIT_PLAY_TYPE_NONE  . '"' . (($value == LIMIT_PLAY_TYPE_NONE)  ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_NONE'] . '</option>
				<option value="' . LIMIT_PLAY_TYPE_POSTS . '"' . (($value == LIMIT_PLAY_TYPE_POSTS) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_LIMIT_PLAY_TOTAL_POSTS'] . '</option>
				<option value="' . LIMIT_PLAY_TYPE_DAYS  . '"' . (($value == LIMIT_PLAY_TYPE_DAYS)  ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_LIMIT_PLAY_POSTS'] . '</option>
				<option value="' . LIMIT_PLAY_TYPE_BOTH  . '"' . (($value == LIMIT_PLAY_TYPE_BOTH)  ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_LIMIT_PLAY_BOTH'] . '</option>';
	}

	function games_sort_order_select($value, $key = '')
	{
		global $user;

		return '<option value="' . ARCADE_ORDER_FIXED .'"'		. (($value == ARCADE_ORDER_FIXED)		? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_FIXED'] . '</option>
				<option value="' . ARCADE_ORDER_INSTALLDATE .'"'. (($value == ARCADE_ORDER_INSTALLDATE) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_INSTALLDATE'] . '</option>
				<option value="' . ARCADE_ORDER_NAME . '"'		. (($value == ARCADE_ORDER_NAME)		? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_NAME'] . '</option>
				<option value="' . ARCADE_ORDER_PLAYS . '"'		. (($value == ARCADE_ORDER_PLAYS)		? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_PLAYS'] . '</option>
				<option value="' . ARCADE_ORDER_RATING . '"'	. (($value == ARCADE_ORDER_RATING)		? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_RATING'] . '</option>';
	}

	function games_sort_dir_select($value, $key = '')
	{
		global $user;

		return '<option value="' . ARCADE_ORDER_ASC . '"'  . (($value == ARCADE_ORDER_ASC)  ? ' selected="selected"' : '') . '>' . $user->lang['ASCENDING']  . '</option>
				<option value="' . ARCADE_ORDER_DESC . '"' . (($value == ARCADE_ORDER_DESC) ? ' selected="selected"' : '') . '>' . $user->lang['DESCENDING'] . '</option>';
	}

	function download_list_per_page_select($value, $key = '')
	{
		return '<option value="50"'  . (($value == 50)  ? ' selected="selected"' : '') . '>50</option>
				<option value="100"' . (($value == 100) ? ' selected="selected"' : '') . '>100</option>
				<option value="200"' . (($value == 200) ? ' selected="selected"' : '') . '>200</option>
				<option value="400"' . (($value == 400) ? ' selected="selected"' : '') . '>400</option>';
	}

	function leaders_header_select($value, $key = '')
	{
		return '<option value="3"' . (($value == 3) ? ' selected="selected"' : '') . '>3</option>
				<option value="6"' . (($value == 6) ? ' selected="selected"' : '') . '>6</option>
				<option value="9"' . (($value == 9) ? ' selected="selected"' : '') . '>9</option>';
	}

	function cm_currency_select($value, $key = '')
	{
		global $user, $cash;

		return $cash->get_currencies($value, true);
	}

	function points_detect($value, $key)
	{
		global $arcade, $user;

		$point_status = ($arcade->points['enabled']) ? 'ENABLED': 'DISABLED';
		$detect = '';
		switch($arcade->points['type'])
		{
			case ARCADE_CASH_MOD:
				$detect = sprintf($user->lang['ARCADE_POINTS_DETECT_' . $point_status], $user->lang['ARCADE_CASH_MOD']);
			break;

			case ARCADE_POINTS_SYSTEM:
				$detect = sprintf($user->lang['ARCADE_POINTS_DETECT_' . $point_status], $user->lang['ARCADE_POINTS_SYSTEM']);
			break;

			case ARCADE_SIMPLE_POINTS_SYSTEM:
				$detect = sprintf($user->lang['ARCADE_POINTS_DETECT_' . $point_status], $user->lang['ARCADE_SIMPLE_POINTS_SYSTEM']);
			break;

			case ARCADE_ULTIMATE_POINTS_SYSTEM:
				$detect = sprintf($user->lang['ARCADE_POINTS_DETECT_' . $point_status], $user->lang['ARCADE_ULTIMATE_POINTS_SYSTEM']);
			break;

			case ARCADE_JV_POINTS_SYSTEM:
				$detect = sprintf($user->lang['ARCADE_POINTS_DETECT_' . $point_status], $user->lang['ARCADE_JV_POINTS_SYSTEM']);
			break;

			case ARCADE_POINTS_MOD:
				$detect = sprintf($user->lang['ARCADE_POINTS_DETECT_' . $point_status], $user->lang['ARCADE_POINTS_MOD']);
			break;

			default:
			break;
		}

		$radio_ary = array(1 => 'YES', 0 => 'NO');
		return $detect . '<br />' . h_radio('config[use_points]', $radio_ary, $value, $key);
	}

	/**
	* Arcade disable option and message
	*/
	function arcade_disable($value, $key)
	{
		$radio_ary = array(1 => 'YES', 0 => 'NO');
		return h_radio('config[arcade_disable]', $radio_ary, $value, $key) . '<br /><br /><input id="arcade_disable_msg" type="text" name="config[arcade_disable_msg]" maxlength="255" size="50" value="' . $this->new_config['arcade_disable_msg'] . '" />';
	}

	function load_list($value, $key)
	{
		$radio_ary = array(1 => 'ARCADE_LOAD_LIST_ALWAYS', 0 => 'ARCADE_LOAD_LIST_ONCLICK');
		return h_radio('config[load_list]', $radio_ary, $value, $key);
	}

	function arcade_colour_palette($value, $key)
	{
		global $user, $phpbb_admin_path, $phpEx;

		$bgc   = ($value) ? '&nbsp;<span style="background-color: #'.$value.'">&nbsp; &nbsp;</span>' : '<strong>&nbsp;&nbsp;'.$user->lang['DISABLED'].'</strong>';
		return '<input type="text" id="'.$key.'" name="config['.$key.']" value="'.$value.'" maxlength="6" size="7" />
		&nbsp;&nbsp;<span>[ <a href="'.append_sid("{$phpbb_admin_path}swatch.$phpEx", "form=acp_board&amp;name={$key}").'" onclick="popup(this.href, 636, 150, \'_swatch\'); return false">'.$user->lang['COLOUR_SWATCH'].'</a> ]</span>'.$bgc;
	}

	function score_security_level($value)
	{
		global $user;

		return '<option value="' . SCORE_SECURITY_LOW	 . '"' . (($value == SCORE_SECURITY_LOW)	? ' selected="selected"' : '') . '>' . $user->lang['LOW'] . '</option>
				<option value="' . SCORE_SECURITY_MEDIUM . '"' . (($value == SCORE_SECURITY_MEDIUM)	? ' selected="selected"' : '') . '>' . $user->lang['MEDIUM'] . '</option>
				<option value="' . SCORE_SECURITY_HIGH	 . '"' . (($value == SCORE_SECURITY_HIGH)	? ' selected="selected"' : '') . '>' . $user->lang['HIGH'] . '</option>';
	}

	function download_file_type_select($value)
	{
		global $user, $arcade;

		$return = '<option value=""' . (($value == '')	? ' selected="selected"' : '') . '>' . $user->lang['FREELY_OPTIONAL'] . '</option>';
		foreach ($arcade->compress_methods() as $method)
		{
			$return .= '<option value="' . $method	 . '"' . (($value == $method)	? ' selected="selected"' : '') . '>' . $method . '</option>';
		}

		return $return;
	}

	function search_check_select($value)
	{
		global $user;

		return '<option value="' . ARCADE_CHECK_EVERYONE    . '"' . (($value == ARCADE_CHECK_EVERYONE)    ? ' selected="selected"' : '') . '>' . $user->lang['ACP_ARCADE_CHECK_EVERYONE'] . '</option>
				<option value="' . ARCADE_CHECK_USER_NORMAL . '"' . (($value == ARCADE_CHECK_USER_NORMAL) ? ' selected="selected"' : '') . '>' . $user->lang['ACP_ARCADE_CHECK_USER_NORMAL'] . '</option>
				<option value="' . ARCADE_CHECK_DISABLED    . '"' . (($value == ARCADE_CHECK_DISABLED)    ? ' selected="selected"' : '') . '>' . $user->lang['ACP_ARCADE_CHECK_DISABLED'] . '</option>';
	}

	function validate_configs($config_vars, &$cfg_array, &$error)
	{
		global $user, $config, $arcade;

		$validate_configs = array();
		foreach ($config_vars as $config_name => $config_definition)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}

			$validate_configs[$config_name] = true;
		}

		if (isset($validate_configs['session_length']))
		{
			$arcade_session_length = (int) $cfg_array['session_length'];
			if ($config['session_length'] < $arcade_session_length)
			{
				$error[] = sprintf($user->lang['ARCADE_PHPBB_SESSION_LENGTH_ERROR'], '<a href="' . $arcade->url('i=board&amp;mode=load', 'adm/index', $user->session_id) . '">', '</a>');
			}
		}

		if (isset($validate_configs['flash_version']))
		{
			$cfg_array['flash_version'] = $this->delete_last_chars($cfg_array['flash_version'], '.');
			$min_flash_version = '10.0.0.0';
			if (phpbb_version_compare($cfg_array['flash_version'], $min_flash_version, '<'))
			{
				$error[] = sprintf($user->lang['ACP_ARCADE_FLASH_PLAYER_VERSION_EXPLAIN'], $min_flash_version);
			}
		}

		if (isset($validate_configs['jackpot_Minimum']) && isset($validate_configs['jackpot_Maximum']))
		{
			$jackpot_Minimum = (float) $cfg_array['jackpot_Minimum'];
			$jackpot_Maximum = (float) $cfg_array['jackpot_Maximum'];
			if ($jackpot_Maximum > 0 && $jackpot_Minimum > $jackpot_Maximum)
			{
				$error[] = $user->lang['ARCADE_JACKPOT_MIN_MAX_ERROR'];
			}
		}

		if (isset($validate_configs['challenge_bet_Minimum']) && isset($validate_configs['challenge_bet_Maximum']))
		{
			$challenge_bet_Minimum = (float) $cfg_array['challenge_bet_Minimum'];
			$challenge_bet_Maximum = (float) $cfg_array['challenge_bet_Maximum'];
			if ($challenge_bet_Maximum > 0 && $challenge_bet_Minimum > $challenge_bet_Maximum)
			{
				$error[] = $user->lang['CHALLENGE_BET_MIN_MAX_ERROR'];
			}
		}

		if (isset($validate_configs['auto_disable']) && isset($validate_configs['auto_disable_start']) && isset($validate_configs['auto_disable_end']))
		{
			if ($cfg_array['auto_disable_start'] == '' && $cfg_array['auto_disable_end'] == '')
			{
				$cfg_array['auto_disable'] = 0;
				return;
			}

			if (!sizeof($start_ary = $arcade->validate_time($cfg_array['auto_disable_start'])))
			{
				$error[] = sprintf($user->lang['ARCADE_AUTO_DISABLE_START_ERROR'], $cfg_array['auto_disable_start']);
			}

			if (!sizeof($end_ary = $arcade->validate_time($cfg_array['auto_disable_end'])))
			{
				$error[] = sprintf($user->lang['ARCADE_AUTO_DISABLE_END_ERROR'], $cfg_array['auto_disable_end']);
			}

			if (sizeof($start_ary) && sizeof($end_ary))
			{
				if (($start_ary['hour'] > $end_ary['hour']) || ($start_ary['hour'] == $end_ary['hour'] && $start_ary['min'] >= $end_ary['min']))
				{
					$error[] = $user->lang['ARCADE_AUTO_DISABLE_START_END_ERROR'];
				}
			}
		}
	}

	function delete_last_chars($text, $chars)
	{
		if ($text != '')
		{
			$lenght = strlen($text);

			for ($i=0; $i < $lenght; $i++)
			{
				if ($text[strlen($text) - 1] === $chars)
				{
					$text = substr($text, 0, -1);
				}
				else
				{
					break;
				}
			}
		}

		return $text;
	}

	function challenge_disable($value, $key)
	{
		$radio_ary = array(1 => 'YES', 0 => 'NO');

		return h_radio('config[challenge_disable]', $radio_ary, $value) . '<br /><br /><input id="' . $key . '" type="text" name="config[challenge_disable_msg]" maxlength="255" size="50" value="' . $this->new_config['challenge_disable_msg'] . '" />';
	}

	function challenge_users_select($value, $key)
	{
		global $user;
		$radio_ary = array(0 => 'ACP_CHALLENGE_USER_TEXT', 1 => 'ACP_CHALLENGE_USER_SELECT');
		return h_radio('config[challenge_users_select]', $radio_ary, $value, $key);
	}

	function challenge_exp_date_select($value, $key)
	{
		global $user;
		return '<option value="86400"' . (($value == 86400) ? ' selected="selected"' : '') . '>1 '.$user->lang['DAY'].'</option><option value="172800"' . (($value == 172800) ? ' selected="selected"' : '') . '>2 '.$user->lang['DAY'].'</option><option value="604800"' . (($value == 604800) ? ' selected="selected"' : '') . '>7 '.$user->lang['DAY'].'</option><option value="1209600"' . (($value == 1209600) ? ' selected="selected"' : '') . '>14 '.$user->lang['DAY'].'</option><option value="2592000"' . (($value == 2592000) ? ' selected="selected"' : '') . '>30 '.$user->lang['DAY'].'</option>';
	}
}

?>