<?php
/**
*
* @package acp
* @version $Id: acp_arcade_utilities.php 1977 2012-03-13 17:28:13Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_arcade_utilities
{
	var $u_action;
	var $tpl_name;
	var $page_title;

	function main($id, $mode)
	{
		global $db, $user, $config, $auth, $template, $phpbb_admin_path, $phpbb_root_path, $phpEx;
		global $arcade, $auth_arcade, $arcade_cache, $arcade_config, $file_functions;

		define('IN_PHPBB_ARCADE', true);
		include($phpbb_root_path . 'arcade/includes/common.' . $phpEx);

		// Initialize arcade class
		$arcade = new arcade_admin();

		$this->tpl_name = 'acp_arcade_utilities';
		$this->page_title = $user->lang['ACP_ARCADE_UTILITIES_' . strtoupper($mode)];

		$ip		= request_var('ip', 'ip');
		$start	= request_var('start', 0);
		$action	= request_var('action', '');
		$marked	= request_var('mark', array(0));

		switch ($mode)
		{
			case 'create_install':
				$form_key = 'acp_arcade_utilities';
				add_form_key($form_key);

				$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : array();

				$download = (isset($_POST['download'])) ? true : false;
				$downloadnew = (isset($_POST['downloadnew'])) ? true : false;

				$view = request_var('view', '');
				$view = ($view != '') ? true : false;
				$viewnew = request_var('viewnew', '');
				$viewnew = ($viewnew != '') ? true : false;

				$create = (isset($_POST['create'])) ? true : false;
				$update = (isset($_POST['update'])) ? true : false;

				$game_id = request_var('g', 0);

				$methods = $arcade->compress_methods();

				$cfg_array['game_name'] = (isset($cfg_array['game_name'])) ? $cfg_array['game_name'] : '';
				$cfg_array['game_desc'] = (isset($cfg_array['game_desc'])) ? $cfg_array['game_desc'] : '';
				$cfg_array['game_image'] = (isset($cfg_array['game_image'])) ? $cfg_array['game_image'] : '';
				$cfg_array['game_swf'] = (isset($cfg_array['game_swf'])) ? $cfg_array['game_swf'] : '';
				$cfg_array['game_scorevar'] = (isset($cfg_array['game_scorevar'])) ? $cfg_array['game_scorevar'] : '';
				$cfg_array['game_width'] = (isset($cfg_array['game_width'])) ? $cfg_array['game_width'] : 550;
				$cfg_array['game_height'] = (isset($cfg_array['game_height'])) ? $cfg_array['game_height'] : 400;
				$cfg_array['game_type'] = (isset($cfg_array['game_type'])) ? $cfg_array['game_type'] : false;
				$cfg_array['game_scoretype'] = (isset($cfg_array['game_scoretype'])) ? $cfg_array['game_scoretype'] : false;
				$cfg_array['use_method'] = (isset($cfg_array['use_method'])) ? $cfg_array['use_method'] : '.tar';
				$cfg_array['use_method_new'] = (isset($cfg_array['use_method_new'])) ? $cfg_array['use_method_new'] : '.tar';

				$template->assign_vars(array(
					'S_IN_CREATE_INSTALL'		=> true,
					'GAME_NAME'					=> $cfg_array['game_name'],
					'GAME_DESC'					=> $cfg_array['game_desc'],
					'GAME_IMAGE'				=> $cfg_array['game_image'],
					'GAME_SWF'					=> $cfg_array['game_swf'],
					'GAME_SCOREVAR'				=> $cfg_array['game_scorevar'],
					'GAME_WIDTH'				=> $cfg_array['game_width'],
					'GAME_HEIGHT'				=> $cfg_array['game_height'],
					'GAME_TYPE_SELECT'			=> $arcade->game_type_select($cfg_array['game_type']),
					'GAME_SCORETYPE_SELECT'		=> $arcade->game_scoretype_select($cfg_array['game_scoretype']),
				));

				$install_new_file = arcade_game_create_install_file($cfg_array);

				if ($create && !empty($cfg_array['game_swf']) && !empty($cfg_array['game_scorevar']))
				{
					if (!check_form_key($form_key))
					{
						trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					if ($arcade->create_install_folder($install_new_file, $cfg_array['game_swf']))
					{
						trigger_error($user->lang['ARCADE_CREATE_INSTALL_FOLDER_FILE'] . adm_back_link($this->u_action), E_USER_WARNING);
					}
					else
					{
						trigger_error($user->lang['ARCADE_CREATE_INSTALL_FOLDER_FILE_ERROR'] . adm_back_link($this->u_action));
					}
				}

				if ($downloadnew && !empty($cfg_array['use_method_new']) && !empty($cfg_array['game_swf']) && !empty($cfg_array['game_scorevar']))
				{
					if (!check_form_key($form_key))
					{
						trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					$arcade->download_install_file($install_new_file, $file_functions->remove_extension($cfg_array['game_swf']), $cfg_array['use_method_new'], $methods);
					garbage_collection();
					exit_handler();
				}

				if ($viewnew)
				{
					$template->assign_vars(array(
						'S_VIEW_NEW_FILE'	=> true,
						'INSTALL_NEW_FILE'	=> utf8_htmlspecialchars($install_new_file),
					));
				}

				// Quick jump of all the games in the arcade...
				$sql = 'SELECT game_id, game_name, game_name_clean
						FROM ' . ARCADE_GAMES_TABLE . "
						ORDER BY game_name_clean ASC";
				$result = $db->sql_query($sql);

				$first_gid = true;
				while ($row = $db->sql_fetchrow($result))
				{
					if ($first_gid)
					{
						$first_gid = false;
						$game_id = ($game_id == 0) ?  $row['game_id'] : $game_id;
					}

					$template->assign_block_vars('games', array(
						'GAME_ID'	=> $row['game_id'],
						'GAME_NAME'	=> $row['game_name'],
						'SELECTED'	=> ($row['game_id'] == $game_id) ? ' selected="selected"' : ''
					));
				}
				$db->sql_freeresult($result);
				// Quick jump of all the games in the arcade...

				if ($game_id > 0)
				{
					$game_info = $arcade->get_game_data($game_id);
					$install_file = arcade_game_create_install_file($game_info);

					if ($update)
					{
						if (arcade_game_update_install_file($game_id))
						{
							trigger_error($user->lang['ARCADE_GAME_UPDATED'] . adm_back_link($this->u_action));
						}
						else
						{
							trigger_error($user->lang['ARCADE_GAME_UPDATED_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
						}
					}

					if ($download && !empty($cfg_array['use_method']))
					{
					if (!check_form_key($form_key))
					{
						trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

						$arcade->download_install_file($install_file, $file_functions->remove_extension($game_info['game_swf']), $cfg_array['use_method'], $methods);
						garbage_collection();
						exit_handler();
					}

					if ($view)
					{
						$template->assign_vars(array(
							'S_VIEW_FILE'	=> true,
							'INSTALL_FILE'	=> utf8_htmlspecialchars($install_file),
						));
					}

					include($arcade->set_path($game_info['game_swf'], 'install'));
					if (!$this->verify_install_file($game_info, $game_data))
					{
						$template->assign_var('S_ERROR_GAME', true);
					}
				}

				$radio_buttons = $radio_buttons_new = '';
				foreach ($methods as $method)
				{
					$checked = ($method == $cfg_array['use_method']) ? ' checked="checked"' : '';
					$checked_new = ($method == $cfg_array['use_method_new']) ? ' checked="checked"' : '';
					$radio_buttons .= '<input type="radio"' . ((!$radio_buttons) ? ' id="use_method"' : '') . ' class="radio" value="' . $method . '" name="config[use_method]"' . $checked . ' />&nbsp;' . $method . '&nbsp;';
					$radio_buttons_new .= '<input type="radio"' . ((!$radio_buttons_new) ? ' id="use_method_new"' : '') . ' class="radio" value="' . $method . '" name="config[use_method_new]"' . $checked_new . ' />&nbsp;' . $method . '&nbsp;';
				}

				$view_action = ($view) ? '&amp;view=true' : '';
				$view_action .= ($viewnew) ? '&amp;viewnew=true' : '';
				$template->assign_vars(array(
					'U_ACTION'			=> $this->u_action . $view_action,

					'RADIO_BUTTONS'		=> $radio_buttons,
					'RADIO_BUTTONS_NEW'	=> $radio_buttons_new,
				));
			break;

			case 'errors':
				$deletemark	= (!empty($_POST['delmarked'])) ? true : false;
				$deleteall	= (!empty($_POST['delall'])) ? true : false;

				// Sort keys
				$sort_days	= request_var('st', 0);
				$sort_key	= request_var('sk', 't');
				$sort_dir	= request_var('sd', 'd');

				$template->assign_var('S_IN_ARCADE_ERRORS', true);

				switch ($action)
				{
					case 'whois':
						$this->whois();
						return;
					break;

					default:
					break;
				}

				// Delete entries if requested and able
				if ($deletemark || $deleteall)
				{
					if ($deletemark && !sizeof($marked))
					{
						trigger_error($user->lang['ARCADE_SELECT_EMPTY'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					if (confirm_box(true))
					{
						$where_sql = '';

						if ($deletemark && sizeof($marked))
						{
							$sql_in = array();
							foreach ($marked as $mark)
							{
								$sql_in[] = $mark;
							}
							$where_sql = $db->sql_in_set('error_id', $sql_in);
							unset($sql_in);
						}

						if ($where_sql || $deleteall)
						{
							if ($where_sql)
							{
								$db->sql_query('DELETE FROM ' . ARCADE_ERRORS_TABLE . " WHERE $where_sql");
							}
							else
							{
								$arcade->delete_table_data(ARCADE_ERRORS_TABLE);
							}

							add_log('admin', 'LOG_ARCADE_CLEAR_' . strtoupper($mode));
						}
					}
					else
					{
						confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
							'start'		=> $start,
							'delmarked'	=> $deletemark,
							'delall'	=> $deleteall,
							'mark'		=> $marked,
						)));
					}
				}

				$error_count = $arcade->get_total('error');

				// Sorting
				$limit_days = array(0 => $user->lang['ALL_ENTRIES'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);
				$sort_by_text = array('u' => $user->lang['SORT_USERNAME'], 'i' => $user->lang['SORT_IP'], 'g' => $user->lang['ARCADE_GAME_NAME'], 's' => $user->lang['ARCADE_SCORE'], 'pt' => $user->lang['ARCADE_CHAMPION_SPENT'], 't' => $user->lang['SORT_DATE']);
				$sort_by_sql = array('u' => 'u.username_clean', 'i' => 'e.error_ip', 'g' => 'g.game_name_clean', 's' => 'e.score', 'pt' => 'e.played_time', 't' => 'e.error_date');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

				// Define where and sort sql for use in displaying logs
				$sql_where = ($sort_days) ? (time() - ($sort_days * 86400)) : 0;
				$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				$sql_array = array(
					'SELECT'	=> 'e.*, u.user_id, u.username, u.user_colour, g.game_name',
					'FROM'		=> array(
						ARCADE_ERRORS_TABLE	=> 'e',
					),
					'LEFT_JOIN'	=> array(
						array(
							'FROM'	=> array(USERS_TABLE => 'u'),
							'ON'	=> 'e.user_id = u.user_id'
						),
						array(
							'FROM'	=> array(ARCADE_GAMES_TABLE => 'g'),
							'ON'	=> 'e.game_id = g.game_id'
						),
					),
					'ORDER_BY'	=> $sql_sort,
				);

				if ($sql_where)
				{
					$sql_array['WHERE'] = 'e.error_date >= ' . $sql_where;
				}

				$sql = $db->sql_build_query('SELECT', $sql_array);
				$result = $db->sql_query_limit($sql, $arcade_config['acp_items_per_page'], $start);
				$error_data = $db->sql_fetchrowset($result);
				$db->sql_freeresult($result);

				foreach ($error_data as $row)
				{
					$template->assign_block_vars('errors', array(
						'S_LINK_SCORE'	=> (!$row['user_id'] || $row['user_id'] == ANONYMOUS || $row['error_type'] != ARCADE_ERROR_TIME) ? false : true,
						'ERROR_ID'		=> $row['error_id'],
						'USERNAME'		=> get_arcade_user_name('full', $row['user_id'], $row['username'], $row['user_colour'], 'arcade', 'x'),
						'U_GAME'		=> append_sid("{$phpbb_admin_path}index.$phpEx", "i=arcade_manage&amp;mode=games&amp;action=edit&amp;g={$row['game_id']}"),
						'GAME_NAME'		=> $row['game_name'],
						'SCORE'			=> ($row['error_type'] == ARCADE_ERROR_TIME) ? $arcade->number_format($row['score']) : '-',
						'U_SCORE'		=> append_sid("{$phpbb_admin_path}index.$phpEx", "i=arcade_manage&amp;mode=users&amp;action=edit&amp;g={$row['game_id']}&amp;u={$row['user_id']}"),
						'PLAYED_TIME'	=> ($row['error_type'] == ARCADE_ERROR_TIME) ? (($row['played_time']) ? $arcade->time_format($row['played_time']) : '0') . ' ' . $user->lang['TIME_SEC'] : '-',
						'ERROR_TYPE'	=> $arcade->display_error_type($row['error_type']),
						'ERROR_DATE'	=> $user->format_date($row['error_date']),
						'ERROR_IP' 		=> ($ip == 'hostname') ? gethostbyaddr($row['error_ip']) : $row['error_ip'],
						'U_ERROR_IP'	=> $this->u_action . "&amp;ip=" . (($ip == 'ip') ? 'hostname' : 'ip'),
						'U_WHOIS'		=> $this->u_action . "&amp;action=whois&amp;whois_ip={$row['error_ip']}"
					));
				}

				$template->assign_vars(array(
					'S_LIMIT_DAYS'	=> $s_limit_days,
					'S_SORT_KEY'	=> $s_sort_key,
					'S_SORT_DIR'	=> $s_sort_dir,
					'U_ACTION'		=> $this->u_action,
					'S_ON_PAGE'		=> on_page($error_count, $arcade_config['acp_items_per_page'], $start),
					'PAGINATION'	=> generate_pagination($this->u_action . "&amp;sk=$sort_key&amp;sd=$sort_dir", $error_count, $arcade_config['acp_items_per_page'], $start, true),
				));
			break;

			case 'reports':
				$deletemark = (!empty($_POST['delmarked'])) ? true : false;
				$deleteall	= (!empty($_POST['delall'])) ? true : false;

				// Sort keys
				$sort_days	= request_var('st', 0);
				$sort_key	= request_var('sk', 'd');
				$sort_dir	= request_var('sd', 'd');

				$template->assign_var('S_IN_ARCADE_REPORTS', true);

				switch ($action)
				{
					case 'whois':
						$this->whois();
						return;
					break;

					case 'open':
					case 'close':
						$report_id = request_var('report_id', 0);
						if ($report_id)
						{
							$arcade->report_toggle($action, $report_id);
						}
					break;

					default:
					break;
				}

				// Delete entries if requested and able
				if ($deletemark || $deleteall)
				{
					if ($deletemark && !sizeof($marked))
					{
						trigger_error($user->lang['ARCADE_SELECT_EMPTY'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					if (confirm_box(true))
					{
						$where_sql = '';

						if ($deletemark && sizeof($marked))
						{
							$sql_in = array();
							foreach ($marked as $mark)
							{
								$sql_in[] = $mark;
							}
							$where_sql = $db->sql_in_set('report_id', $sql_in);
							unset($sql_in);
						}

						if ($where_sql || $deleteall)
						{
							if ($where_sql)
							{
								$sql = 'SELECT COUNT(report_id) AS total_open FROM ' . ARCADE_REPORTS_TABLE . "
										WHERE {$where_sql}
										AND report_closed = 0";
								$result = $db->sql_query($sql);
								$total_open = (int) $db->sql_fetchfield('total_open');
								$db->sql_freeresult($result);

								$db->sql_query('DELETE FROM ' . ARCADE_REPORTS_TABLE . " WHERE {$where_sql}");
								$arcade->set_config('reports_open', ($arcade_config['reports_open'] - $total_open));
							}
							else
							{
								$arcade->delete_table_data(ARCADE_REPORTS_TABLE);
								$arcade->set_config('reports_open', 0);
							}

							$arcade_cache->destroy('sql', ARCADE_REPORTS_TABLE);
							add_log('admin', 'LOG_ARCADE_CLEAR_' . strtoupper($mode));
						}
					}
					else
					{
						confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
							'start'		=> $start,
							'delmarked'	=> $deletemark,
							'delall'	=> $deleteall,
							'mark'		=> $marked,
						)));
					}
				}

				$sql = 'SELECT COUNT(report_id) AS total FROM ' . ARCADE_REPORTS_TABLE;
				$result = $db->sql_query($sql);
				$report_count = (int) $db->sql_fetchfield('total');
				$db->sql_freeresult($result);

				// Sorting
				$limit_days = array(0 => $user->lang['ALL_ENTRIES'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);
				$sort_by_text = array('u' => $user->lang['SORT_USERNAME'], 'i' => $user->lang['SORT_IP'], 'g' => $user->lang['ARCADE_GAME_NAME'], 't' => $user->lang['ARCADE_TYPE'], 'd' => $user->lang['SORT_DATE']);
				$sort_by_sql = array('u' => 'u.username_clean', 'i' => 'r.report_ip', 'g' => 'g.game_name_clean', 't' => 'r.report_type', 'd' => 'r.report_time');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

				// Define where and sort sql for use in displaying logs
				$sql_where = ($sort_days) ? (time() - ($sort_days * 86400)) : 0;
				$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				$sql_array = array(
					'SELECT'	=> 'r.*, u.username, u.user_colour, u.user_id, g.game_name, g.game_image, g.cat_id',
					'FROM'		=> array(
						ARCADE_REPORTS_TABLE	=> 'r',
					),
					'LEFT_JOIN'	=> array(
						array(
							'FROM'	=> array(USERS_TABLE => 'u'),
							'ON'	=> 'r.user_id = u.user_id'
						),
						array(
							'FROM'	=> array(ARCADE_GAMES_TABLE => 'g'),
							'ON'	=> 'r.game_id = g.game_id'
						),
					),
					'ORDER_BY'	=> $sql_sort,
				);

				if ($sql_where)
				{
					$sql_array['WHERE'] = 'r.report_time >= ' . $sql_where;
				}

				$sql = $db->sql_build_query('SELECT', $sql_array);
				$result = $db->sql_query_limit($sql, $arcade_config['acp_items_per_page'], $start);
				$report_data = $db->sql_fetchrowset($result);
				$db->sql_freeresult($result);

				foreach ($report_data as $row)
				{
					$template->assign_block_vars('reports', array(
						'S_REPORT_CLOSED'	=> $row['report_closed'],

						'U_GAME'			=> append_sid("{$phpbb_admin_path}index.$phpEx", "i=arcade_manage&amp;mode=games&amp;action=edit&amp;g={$row['game_id']}"),
						'U_GAME_PLAY'		=> $arcade->url("mode=play&amp;g={$row['game_id']}"),
						'U_OPEN'			=> "{$this->u_action}&amp;action=open&amp;report_id={$row['report_id']}",
						'U_CLOSE'			=> "{$this->u_action}&amp;action=close&amp;report_id={$row['report_id']}",
						'U_REPORT_IP'		=> $this->u_action . "&amp;ip=" . (($ip == 'ip') ? 'hostname' : 'ip'),
						'U_WHOIS'			=> $this->u_action . "&amp;action=whois&amp;whois_ip={$row['report_ip']}",

						'GAME_NAME'			=> get_arcade_game_name($row['game_name']),
						'GAME_IMAGE'		=> ($arcade->optionget('view_game_image')) ? get_arcade_game_image($row['game_image'], 50, 50, 'x', 'play', $row['cat_id'], $row['game_id']) : false,
						'REPORT_ID'			=> $row['report_id'],
						'REPORT_IP'			=> ($ip == 'hostname') ? gethostbyaddr($row['report_ip']) : $row['report_ip'],
						'REPORT_DESC'		=> generate_text_for_display($row['report_desc'], $row['report_desc_uid'], $row['report_desc_bitfield'], $row['report_desc_options']),
						'REPORT_TIME'		=> $user->format_date($row['report_time']),
						'REPORT_TYPE'		=> $arcade->display_report_type($row['report_type']),
						'USERNAME'			=> get_arcade_user_name('full', $row['user_id'], $row['username'], $row['user_colour'], 'pm', 'x')
					));
				}

				$template->assign_vars(array(
					'S_GAME_EDIT'	=> ($auth->acl_get('a_arcade_game')) ? true : false,
					'S_LIMIT_DAYS'	=> $s_limit_days,
					'S_SORT_KEY'	=> $s_sort_key,
					'S_SORT_DIR'	=> $s_sort_dir,
					'U_ACTION'		=> $this->u_action,
					'S_ON_PAGE'		=> on_page($report_count, $arcade_config['acp_items_per_page'], $start),
					'PAGINATION'	=> generate_pagination($this->u_action . "&amp;sk=$sort_key&amp;sd=$sort_dir", $report_count, $arcade_config['acp_items_per_page'], $start, true),
				));
			break;

			case 'download_stats':
				$template->assign_var('S_IN_DOWNLOAD_STATS', true);

				switch ($action)
				{
					case 'view':
						$template->assign_var('S_IN_DOWNLOAD_STATS_VIEW', true);

						$user_id	= request_var('u', 0);
						$sort_key	= request_var('sk', 'g');
						$sort_dir	= request_var('sd', 'a');

						// Sorting
						$limit_days = array();
						$sort_by_text = array('g' => $user->lang['ARCADE_GAME_NAME'], 't' => $user->lang['ARCADE_STATS_TOTAL_DOWNLOADS'], 'd' => $user->lang['ARCADE_DOWNLOAD_DATE']);
						$sort_by_sql = array('g' => 'g.game_name_clean', 't' => 'total', 'd' => 'download_time');

						$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
						gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

						// Define where and sort sql for use in displaying logs
						$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

						$sql_array = array(
							'SELECT'	=> 'd.total, d.game_id, d.download_time, g.game_name, g.game_name_clean, g.game_image',
							'FROM'		=> array(
								ARCADE_DOWNLOAD_TABLE	=> 'd',
							),
							'LEFT_JOIN'	=> array(
								array(
									'FROM'	=> array(ARCADE_GAMES_TABLE => 'g'),
									'ON'	=> 'd.game_id = g.game_id'
								),
							),
							'WHERE'		=> 'd.user_id = ' . (int) $user_id,
							'ORDER_BY'	=> $sql_sort,
						);

						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query_limit($sql, $arcade_config['acp_items_per_page'], $start);
						$row = $db->sql_fetchrowset($result);
						$db->sql_freeresult($result);

						$row_count = $arcade->get_total('download_stats', $user_id);
						if (!$row_count)
						{
							trigger_error($user->lang['NO_ARCADE_DOWNLOAD_STATS_USER'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						foreach ($row as $item)
						{
							$template->assign_block_vars('games', array(
								'DATE'			=> ($item['download_time']) ? $user->format_date($item['download_time']) : $user->lang['NA'],
								'GAME_IMAGE'	=> ($item['game_image']) ? $arcade->url("img={$item['game_image']}") : '',
								'U_GAME'		=> append_sid("{$phpbb_admin_path}index.$phpEx", "i=arcade_manage&amp;mode=games&amp;action=edit&amp;g={$item['game_id']}"),
								'GAME_NAME'		=> $item['game_name'],
								'TOTAL'			=> $item['total'],
							));
						}

						$user_data = $arcade->userdata('full_username', $user_id);

						$template->assign_vars(array(
							'U_ACTION'				=> $this->u_action . "&amp;action=$action&amp;u=$user_id",
							'S_SORT_KEY'			=> $s_sort_key,
							'S_SORT_DIR'			=> $s_sort_dir,
							'DOWNLOAD_STATS_USER'	=> sprintf($user->lang['ARCADE_DOWNLOAD_USER_STATS'], get_arcade_user_name('full', $user_data['user_id'], $user_data['username'], $user_data['user_colour'], 'arcade', 'x')),
							'S_ON_PAGE'				=> on_page($row_count, $arcade_config['acp_items_per_page'], $start),
							'PAGINATION'			=> generate_pagination($this->u_action . "&amp;action=view&amp;u=$user_id&amp;sk=$sort_key&amp;sd=$sort_dir", $row_count, $arcade_config['acp_items_per_page'], $start, true),
						));
					break;

					default:
						$sort_key	= request_var('sk', 'g');
						$sort_dir	= request_var('sd', 'a');

						// Sorting
						$limit_days = array();
						$sort_by_text = array('u' => $user->lang['SORT_USERNAME'], 't' => $user->lang['ARCADE_STATS_TOTAL_DOWNLOADS']);
						$sort_by_sql = array('u' => 'u.username_clean', 't' => 'total');

						$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
						gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

						// Define where and sort sql for use in displaying logs
						$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

						$sql_array = array(
							'SELECT'	=> 'SUM(d.total) as total, u.user_id, u.username, u.username_clean, u.user_colour',
							'FROM'		=> array(
								ARCADE_DOWNLOAD_TABLE	=> 'd',
							),
							'LEFT_JOIN'	=> array(
								array(
									'FROM'	=> array(USERS_TABLE => 'u'),
									'ON'	=> 'd.user_id = u.user_id'
								),
							),
							'GROUP_BY'	=> 'u.user_id, u.username, u.username_clean, u.user_colour',
							'ORDER_BY'	=> $sql_sort,
						);

						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query_limit($sql, $arcade_config['acp_items_per_page'], $start);
						$row = $db->sql_fetchrowset($result);
						$db->sql_freeresult($result);

						$row_count = $arcade->get_total('download_stats');
						if (!$row_count)
						{
							trigger_error($user->lang['NO_ARCADE_DOWNLOAD_STATS'], E_USER_WARNING);
						}

						foreach ($row as $item)
						{
							$template->assign_block_vars('users', array(
								'USERNAME'	=> get_username_string('full', $item['user_id'], $item['username'], $item['user_colour'], false, "{$this->u_action}&amp;action=view"),
								'TOTAL'		=> $item['total'],
							));
						}

						$template->assign_vars(array(
							'U_ACTION'		=> $this->u_action,
							'S_SORT_KEY'	=> $s_sort_key,
							'S_SORT_DIR'	=> $s_sort_dir,
							'S_ON_PAGE'		=> on_page($row_count, $arcade_config['acp_items_per_page'], $start),
							'PAGINATION'	=> generate_pagination($this->u_action . "&amp;sk=$sort_key&amp;sd=$sort_dir", $row_count, $arcade_config['acp_items_per_page'], $start, true),
						));
					break;
				}
			break;

			case 'global_announce':
				$form_key = 'acp_global_announce';
				add_form_key($form_key);
				$user->add_lang('posting');

				$submit				= (isset($_POST['submit']))  ? true : false;
				$preview			= (isset($_POST['preview'])) ? true : false;

				$announce_enable	= request_var('announce_enable', $arcade_config['global_announce_enable']);

				if ($submit || $preview)
				{
					$announce_data = array(
						'user_id'			=> (int) $user->data['user_id'],
						'username'			=> $user->data['username'],
						'user_colour'		=> $user->data['user_colour'],
						'announce_title'	=> utf8_normalize_nfc(request_var('announce_title', '', true)),
						'announce_text'		=> utf8_normalize_nfc(request_var('message', '', true)),
						'announce_uid'		=> '',
						'announce_bitfield'	=> '',
						'announce_options'	=> 0,
						'announce_author'	=> request_var('announce_author', false),
						'announce_anonym'	=> request_var('announce_anonym', false),
						'announce_scroll'	=> request_var('announce_scroll', false),
						'announce_date'		=> time(),
					);

					generate_text_for_storage($announce_data['announce_text'], $announce_data['announce_uid'], $announce_data['announce_bitfield'], $announce_data['announce_options'], request_var('announce_parse_bbcode', false), request_var('announce_parse_urls', false), request_var('announce_parse_smilies', false));

					if ($submit)
					{
						if (!check_form_key($form_key))
						{
							trigger_error('FORM_INVALID');
						}

						$arcade->delete_table_data(ARCADE_ANNOUNCE_TABLE);

						$db->sql_query('INSERT INTO ' . ARCADE_ANNOUNCE_TABLE . ' ' . $db->sql_build_array('INSERT', $announce_data));

						if (!$announce_data['announce_text'])
						{
							$announce_enable = false;
						}

						$arcade->set_config('global_announce_enable', $announce_enable);
						$arcade_cache->destroy('sql', ARCADE_ANNOUNCE_TABLE);

						add_log('admin', 'LOG_ARCADE_GLOBAL_ANNOUNCE');
						trigger_error($user->lang['ARCADE_GLOBAL_ANNOUNCE_UPDATE_SUCCESS'] . adm_back_link($this->u_action));
					}
				}
				else
				{
					$sql = 'SELECT * FROM ' . ARCADE_ANNOUNCE_TABLE;
					$result = $db->sql_query($sql);
					$announce_data = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);

					$adata = array(
						'text'			=> $announce_data['announce_text'],
						'allow_bbcode'	=> true,
						'allow_smilies'	=> true,
						'allow_urls'	=> true
					);
				}

				$announce_preview = ($preview) ? generate_text_for_display($announce_data['announce_text'], $announce_data['announce_uid'], $announce_data['announce_bitfield'], $announce_data['announce_options']) : '';

				// Build custom bbcodes array
				if (!function_exists('display_custom_bbcodes'))
				{
					include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
				}

				display_custom_bbcodes();

				if (isset($announce_data['announce_text']))
				{
					$adata = generate_text_for_edit($announce_data['announce_text'], $announce_data['announce_uid'], $announce_data['announce_options']);
				}

				$template->assign_vars(array(
					'S_IN_ANNOUNCE'					=> true,
					'S_BBCODE_FLASH'				=> true,
					'S_BBCODE_QUOTE'				=> true,
					'S_BBCODE_IMG'					=> true,
					'S_ANNOUNCE_ENABLE'				=> ($announce_enable) ? true : false,
					'S_ANNOUNCE_AUTHOR'				=> ($announce_data['announce_author']) ? true : false,
					'S_ANNOUNCE_ANONYM'				=> ($announce_data['announce_anonym']) ? true : false,
					'S_ANNOUNCE_SCROLL'				=> ($announce_data['announce_scroll']) ? true : false,
					'S_ANNOUNCE_BBCODE_CHECKED'		=> ($adata['allow_bbcode']) ? true : false,
					'S_ANNOUNCE_SMILIES_CHECKED'	=> ($adata['allow_smilies']) ? true : false,
					'S_ANNOUNCE_URLS_CHECKED'		=> ($adata['allow_urls']) ? true : false,

					'U_ACTION'						=> $this->u_action,
					'U_SMILIES'						=> append_sid("{$phpbb_root_path}posting.$phpEx", 'mode=smilies'),

					'ANNOUNCE_TITLE'				=> censor_text($announce_data['announce_title']),
					'ANNOUNCE_TEXT'					=> $adata['text'],
					'ANNOUNCE_PREVIEW'				=> $announce_preview
				));
			break;

			case 'user_guide':
				$template->assign_vars(array(
					'S_IN_ARCADE_USERGUIDE'	=> true,
					'L_BACK_TO_TOP'			=> $user->lang['BACK_TO_TOP'],
					'ICON_BACK_TO_TOP'		=> '<img src="' . $phpbb_admin_path . 'images/icon_up.gif" style="vertical-align: middle;" alt="' . $user->lang['BACK_TO_TOP'] . '" title="' . $user->lang['BACK_TO_TOP'] . '" />',
				));

				$user->add_lang('mods/arcade', false, true);

				// Pull the array data from the lang pack
				foreach ($user->help as $help_ary)
				{
					if ($help_ary[0] == '--')
					{
						$template->assign_block_vars('userguide_block', array(
							'BLOCK_TITLE' => $help_ary[1])
						);

						continue;
					}

					$template->assign_block_vars('userguide_block.userguide_row', array(
						'USERGUIDE_QUESTION'	=> $help_ary[0],
						'USERGUIDE_ANSWER'	=> $help_ary[1]
					));
				}
			break;

			case 'users_banned':
				if (!$auth->acl_get('a_arcade_user'))
				{
					trigger_error($user->lang['NOT_AUTHORISED'] . adm_back_link($this->u_action));
				}

				$deletemark	= (!empty($_POST['delmarked'])) ? true : false;
				$deleteall	= (!empty($_POST['delall'])) ? true : false;

				// Sort keys
				$sort_days	= request_var('st', 0);
				$sort_key	= request_var('sk', 't');
				$sort_dir	= request_var('sd', 'd');

				$template->assign_var('S_IN_ARCADE_BANNED', true);

				switch ($action)
				{
					case 'whois':
						$this->whois();
						return;
					break;

					default:
					break;
				}

				if ($deletemark || $deleteall)
				{
					if ($deletemark && !sizeof($marked))
					{
						trigger_error($user->lang['ARCADE_SELECT_EMPTY'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					if (confirm_box(true))
					{
						$where_sql = '';

						if ($deletemark && sizeof($marked))
						{
							$sql_in = array();
							foreach ($marked as $mark)
							{
								$sql_in[] = $mark;
							}
							$where_sql = $db->sql_in_set('user_id', $sql_in);
							unset($sql_in);
						}

						if ($where_sql || $deleteall)
						{
							if ($where_sql)
							{
								$db->sql_query('DELETE FROM ' . ARCADE_USERS_BANNED_TABLE . " WHERE $where_sql");

								$sql = 'SELECT username
										FROM ' . USERS_TABLE . "
										WHERE $where_sql";
								$result = $db->sql_query($sql);
								$usernames = array();
								while ($row = $db->sql_fetchrow($result))
								{
									$usernames[] = $row['username'];
								}
								$db->sql_freeresult($result);

								$usernames = implode(', ', $usernames);
								$log_msg = sprintf($user->lang['LOG_ARCADE_CLEAR_' . ((sizeof($marked) > 1) ? 'USERS' : 'USER') . '_BANNED'], $usernames);
								$message = sprintf($user->lang['ARCADE_BANNED_EXCLUDE_MARKED_SUCCESS_' . ((sizeof($marked) > 1) ? 'USERS' : 'USER')], $usernames);
							}
							else
							{
								$arcade->delete_table_data(ARCADE_USERS_BANNED_TABLE);
								$log_msg = 'LOG_ARCADE_CLEAR_ALL_USERS_BANNED';
								$message = $user->lang['ARCADE_BANNED_EXCLUDE_ALL_SUCCESS'];
							}

							$arcade_cache->destroy('sql', ARCADE_USERS_BANNED_TABLE);
							add_log('admin', 'LOG_ARCADE_CLEAR_ALL_USERS_BANNED');
							trigger_error($message . adm_back_link($this->u_action));
						}
					}
					else
					{
						confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
							'start'		=> $start,
							'delmarked'	=> $deletemark,
							'delall'	=> $deleteall,
							'mark'		=> $marked
						)));
					}
				}

				$banned_count = $arcade->get_total('banned');

				$limit_days = array(0 => $user->lang['ALL_ENTRIES'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);
				$sort_by_text = array('u' => $user->lang['SORT_USERNAME'], 'i' => $user->lang['SORT_IP'], 't' => $user->lang['SORT_DATE']);
				$sort_by_sql = array('u' => 'u.username_clean', 'i' => 'b.banned_ip', 't' => 'b.banned_date');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

				$sql_where = ($sort_days) ? (time() - ($sort_days * 86400)) : 0;
				$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				$sql_array = array(
					'SELECT'	=> 'b.*, u.user_id, u.username, u.user_colour, u.username_clean, u.user_avatar, u.user_avatar_type, g.game_name, g.game_type, g.cat_id',
					'FROM'		=> array(
						ARCADE_USERS_BANNED_TABLE	=> 'b',
					),
					'LEFT_JOIN'	=> array(
						array(
							'FROM'	=> array(USERS_TABLE => 'u'),
							'ON'	=> 'b.user_id = u.user_id'
						),
						array(
							'FROM'	=> array(ARCADE_GAMES_TABLE => 'g'),
							'ON'	=> 'b.game_id = g.game_id'
						),
					),

					'ORDER_BY'	=> $sql_sort,
				);

				if ($sql_where)
				{
					$sql_array['WHERE'] = 'b.banned_date >= ' . $sql_where;
				}

				$sql = $db->sql_build_query('SELECT', $sql_array);
				$result = $db->sql_query_limit($sql, $arcade_config['acp_items_per_page'], $start);
				$banned_data = $db->sql_fetchrowset($result);
				$db->sql_freeresult($result);

				foreach ($banned_data as $row)
				{
					$game_info = '';
					if (!empty($row['game_id']))
					{
						$game_info =	'<strong>' . $user->lang['ARCADE_GAME_NAME'] . ':</strong> ' . get_arcade_game_name($row['game_name'], true, 'play', $row['cat_id'], $row['game_id'], 'x') . '<br />' .
										'<strong>' . $user->lang['ARCADE_TYPE'] . ':</strong> ' . $arcade->display_game_type($row['game_type']) . '<br />' .
										'<strong>' . $user->lang['ARCADE_SCORE'] . ':</strong> ' . $arcade->number_format($row['score']);
					}
					else if ($row['banned_type'] == ARCADE_BANNED_SCORE)
					{
						$game_info = '<strong><span style="color: #ff0000;">Hacker</span></strong>';
					}

					$template->assign_block_vars('banned', array(
						'USER_ID'		=> $row['user_id'],
						'AVATAR'		=> ($arcade->optionget('view_avatars')) ? get_arcade_user_avatar($row['user_avatar'], $row['user_avatar_type'], 40, 40, 'x', 'profile', $row['user_id']) : '',
						'USERNAME'		=> get_arcade_user_name('full', $row['user_id'], $row['username'], $row['user_colour'], 'arcade', 'x'),
						'BANNED_TYPE'	=> $this->display_banned_type($row['banned_type']),
						'BANNED_DATE'	=> $user->format_date($row['banned_date']),
						'BANNED_IP'		=> ($ip == 'hostname') ? gethostbyaddr($row['banned_ip']) : $row['banned_ip'],
						'GAME_INFO'		=> $game_info,
						'U_BANNED_IP'	=> $this->u_action . "&amp;ip=" . (($ip == 'ip') ? 'hostname' : 'ip'),
						'U_WHOIS'		=> $this->u_action . "&amp;action=whois&amp;whois_ip={$row['banned_ip']}",
					));
				}

				$template->assign_vars(array(
					'S_LIMIT_DAYS'	=> $s_limit_days,
					'S_SORT_KEY'	=> $s_sort_key,
					'S_SORT_DIR'	=> $s_sort_dir,
					'U_ACTION'		=> $this->u_action,
					'S_ON_PAGE'		=> on_page($banned_count, $arcade_config['acp_items_per_page'], $start),
					'PAGINATION'	=> generate_pagination($this->u_action . "&amp;sk=$sort_key&amp;sd=$sort_dir", $banned_count, $arcade_config['acp_items_per_page'], $start, true),
				));
			break;

			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}

		$template->assign_vars(array(
			'L_TITLE'	=> $this->page_title,
			'L_EXPLAIN'	=> $user->lang['ACP_ARCADE_UTILITIES_' . strtoupper($mode) . '_EXPLAIN'],
		));
	}

	function verify_install_file($db_info, $file_info)
	{
		foreach ($file_info as $key => $value)
		{
			if (isset($db_info[$key]))
			{
				if ($db_info[$key] !== $value)
				{
					return false;
				}
			}
		}
		return true;
	}

	function whois()
	{
		global $user, $template, $phpbb_root_path, $phpEx;

		$user->add_lang('acp/users');
		$this->page_title = 'WHOIS';
		$this->tpl_name = 'simple_body';

		$whois_ip = request_var('whois_ip', '');
		$domain = gethostbyaddr($whois_ip);
		$ipwhois = '';

		include($phpbb_root_path . 'includes/functions_user.' . $phpEx);

		if ($ipwhois = user_ipwhois($whois_ip))
		{
			$ipwhois = preg_replace('#(\s)([\w\-\._\+]+@[\w\-\.]+)(\s)#', '\1<a href="mailto:\2">\2</a>\3', $ipwhois);
			$ipwhois = preg_replace('#(\s)(http:/{2}[^\s]*)(\s)#', '\1<a href="\2" target="_blank">\2</a>\3', $ipwhois);
		}

		$template->assign_vars(array(
			'MESSAGE_TITLE'	=> sprintf($user->lang['IP_WHOIS_FOR'], $domain),
			'MESSAGE_TEXT'	=> nl2br($ipwhois)
		));
	}

	function display_banned_type($banned_type)
	{
		global $user;

		$type = '';

		switch ($banned_type)
		{
			case ARCADE_BANNED_UNKNOWN:
				$type = $user->lang['ARCADE_UNKNOWN'];
			break;

			case ARCADE_BANNED_ADMIN:
				$type = $user->lang['ARCADE_BANNED_TYPE_ADMIN'];
			break;

			case ARCADE_BANNED_SCORE:
				$type = $user->lang['ARCADE_BANNED_TYPE_SCORE'];
			break;

			default:
				$type = $user->lang['ARCADE_UNKNOWN'];
			break;
		}

		return $type;
	}
}

?>