<?php
/**
*
* @package ucp
* @version $Id: ucp_arcade.php 1935 2012-03-07 12:03:09Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ucp_prefs
* Changing user preferences
* @package ucp
*/
class ucp_arcade
{
	var $u_action;
	var $tpl_name;
	var $page_title;

	function main($id, $mode)
	{
		global $db, $user, $auth_arcade, $arcade, $arcade_cache, $template, $phpbb_root_path, $phpEx, $arcade_config;

		define('IN_PHPBB_ARCADE', true);
		include($phpbb_root_path . 'arcade/includes/common.' . $phpEx);
		$arcade = new arcade(false, true);

		$submit = (isset($_POST['submit'])) ? true : false;
		$error = $data = array();

		switch ($mode)
		{
			case 'settings':
				add_form_key('ucp_arcade_settings');

				$cdata = array(
					'challenge'			=> (bool) request_var('challenge', $arcade->optionget('challenge')),
					'arcade_pm'			=> (bool) request_var('arcade_pm', $arcade->optionget('arcade_pm')),
					'notifypm'			=> (bool) request_var('notifypm', $arcade->optionget('notifypm')),
					'view_avatars'		=> (bool) request_var('avatars', $arcade->optionget('view_avatars')),
					'view_game_image'	=> (bool) request_var('game_image', $arcade->optionget('view_game_image')),
					'view_popup_icon'	=> (bool) request_var('popup_icon', $arcade->optionget('view_popup_icon'))
				);

				$data = array(
					'games_per_page'	=> request_var('games_per_page'		, $user->data['games_per_page']),
					'games_sort_order'	=> request_var('games_sort_order'	, $user->data['games_sort_order']),
					'games_sort_dir'	=> request_var('games_sort_dir'		, $user->data['games_sort_dir']),
				);

				if ($submit)
				{
					$validate_array = array(
						'games_sort_order'	=> array('string', false, 1, 1),
						'games_sort_dir'	=> array('string', false, 1, 1),
						'games_per_page'	=> array('num', false, 0, ARCADE_UCP_GAMES_PER_PAGE_MAX),
					);

					$error = validate_data($data, $validate_array);

					if (!check_form_key('ucp_arcade_settings'))
					{
						$error[] = 'FORM_INVALID';
					}

					if (!sizeof($error))
					{
						$arcade->optionset('arcade_pm', $cdata['arcade_pm']);
						$arcade->optionset('notifypm', $cdata['notifypm']);
						$arcade->optionset('challenge', $cdata['challenge']);
						$arcade->optionset('view_avatars', $cdata['view_avatars']);
						$arcade->optionset('view_game_image', $cdata['view_game_image']);
						$arcade->optionset('view_popup_icon', $cdata['view_popup_icon']);

						$data['user_arcade_options'] = $user->data['user_arcade_options'];

						$sql = 'UPDATE ' . ARCADE_USERS_TABLE . '
								SET ' . $db->sql_build_array('UPDATE', $data) . '
								WHERE user_id = ' . (int) $user->data['user_id'];
						$db->sql_query($sql);

						$arcade_cache->destroy('sql', ARCADE_CHALLENGE_CHAMP_TABLE);
						meta_refresh(3, $this->u_action);
						$message = $user->lang['PREFERENCES_UPDATED'] . '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
						trigger_error($message);
					}

					$error = preg_replace('#^([A-Z_]+)$#e', "(!empty(\$user->lang['\\1'])) ? \$user->lang['\\1'] : '\\1'", $error);
				}

				if ($arcade_config['override_user_sort'])
				{
					$error[] = $user->lang['UCP_ARCADE_OVERRIDE_USER_SORT_UCP'];
				}

				if (!$auth_arcade->acl_get('u_arcade_pm'))
				{
					$error[] = $user->lang['UCP_ARCADE_NO_PERM_PM_LOSS_HIGHSCORE'];
				}

				$template->assign_vars(array(
					'S_SHOW_ARCADE_PM'		=> ($arcade_config['send_arcade_pm']) ? true : false,
					'S_SHOW_AVATAR'			=> ($arcade_config['display_user_avatar']) ? true : false,
					'S_SHOW_GAME_IMAGE'		=> ($arcade_config['display_game_image']) ? true : false,
					'S_SHOW_POPUP_ICON'		=> ($arcade_config['display_game_popup_icon'] && $auth_arcade->acl_get('u_arcade_popup')) ? true : false,

					'S_ARCADE_PM_ENABLED'	=> $cdata['arcade_pm'],
					'S_ARCADE_NOTIFY_PM'	=> $cdata['notifypm'],
					'S_CHALLENGE_ENABLED'	=> $cdata['challenge'],
					'S_AVATARS_ENABLE'		=> $cdata['view_avatars'],
					'S_GAME_IMAGE_ENABLED'	=> $cdata['view_game_image'],
					'S_POPUP_ICON_ENABLED'	=> $cdata['view_popup_icon'],

					'ERROR'					=> (sizeof($error)) ? implode('<br />', $error) : '',

					'GAMES_PER_PAGE'		=> $data['games_per_page'],
					'GAMES_SORT_ORDER'		=> arcade_games_sort_order_select($data['games_sort_order']),
					'GAMES_SORT_DIR'		=> arcade_games_sort_dir_select($data['games_sort_dir']),
				));
			break;

			case 'favorites':
				if (!$auth_arcade->acl_get('u_arcade_favorites'))
				{
					meta_refresh(3, $arcade->url('i=arcade&amp;mode=settings', 'ucp', $user->session_id));
					trigger_error('ARCADE_NO_PERMISSION_FAV');
				}

				$start		= request_var('start', 0);
				$sort_key	= request_var('sk', 'a');
				$sort_dir	= request_var('sd', 'a');

				$delete		= (isset($_POST['delete'])) ? true : false;
				$confirm	= (isset($_POST['confirm'])) ? true : false;
				$delete_ids	= array_keys(request_var('games', array(0)));

				if ($delete && sizeof($delete_ids))
				{
					$s_hidden_fields = array(
						'delete' => true
					);

					foreach ($delete_ids as $game_id)
					{
						$s_hidden_fields['games'][$game_id] = 1;
					}

					if (confirm_box(true))
					{

						$sql = 'DELETE FROM ' . ARCADE_FAVS_TABLE . '
								WHERE ' . $db->sql_in_set('game_id', $delete_ids) . '
								AND user_id = ' . (int) $user->data['user_id'];
						$db->sql_query($sql);

						meta_refresh(3, $this->u_action);
						$message = $user->lang['UCP_ARCADE_FAVORITE' . ((sizeof($delete_ids) > 1) ? 'S' : '') . '_DELETED'] . '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
						trigger_error($message);
					}
					else
					{
						confirm_box(false, (sizeof($delete_ids) == 1) ? 'UCP_ARCADE_DELETE_FAVORITE' : 'UCP_ARCADE_DELETE_FAVORITES', build_hidden_fields($s_hidden_fields));
					}
				}

				$games_per_page = $arcade_config['games_per_page'];
				if (!empty($user->data['games_per_page']))
				{
					$games_per_page = $user->data['games_per_page'];
				}

				// Select box eventually
				$sort_key_text = array('n' => $user->lang['ARCADE_GAME_NAME'], 'c' => $user->lang['ARCADE_CATEGORY']);
				$sort_key_sql = array('n' => 'g.game_name_clean', 'c' => 'c.cat_name');

				$sort_dir_text = array('a' => $user->lang['ASCENDING'], 'd' => $user->lang['DESCENDING']);

				$s_sort_key = '';
				foreach ($sort_key_text as $key => $value)
				{
					$selected = ($sort_key == $key) ? ' selected="selected"' : '';
					$s_sort_key .= '<option value="' . $key . '"' . $selected . '>' . $value . '</option>';
				}

				$s_sort_dir = '';
				foreach ($sort_dir_text as $key => $value)
				{
					$selected = ($sort_dir == $key) ? ' selected="selected"' : '';
					$s_sort_dir .= '<option value="' . $key . '"' . $selected . '>' . $value . '</option>';
				}

				if (!isset($sort_key_sql[$sort_key]))
				{
					$sort_key = 'n';
				}

				$order_by = $sort_key_sql[$sort_key] . ' ' . (($sort_dir == 'a') ? 'ASC' : 'DESC');

				$sql_array = array(
					'SELECT'	=> 'g.game_id, g.game_name, g.game_name_clean, g.game_image, g.game_width, g.game_height, c.cat_id, c.cat_name',
					'FROM'		=> array(
						ARCADE_GAMES_TABLE	=> 'g',
					),
					'LEFT_JOIN'	=> array(
						array(
							'FROM'	=> array(ARCADE_FAVS_TABLE => 'f'),
							'ON'	=> 'g.game_id = f.game_id'
						),
						array(
							'FROM'	=> array(ARCADE_CATS_TABLE => 'c'),
							'ON'	=> 'g.cat_id = c.cat_id'
						),
					),
					'WHERE'	=> 'f.user_id = ' . (int) $user->data['user_id'],
					'ORDER_BY' => $order_by,
				);

				$sql = $db->sql_build_query('SELECT', $sql_array);
				$result = $db->sql_query_limit($sql, $games_per_page, $start);
				$row = $db->sql_fetchrowset($result);
				$db->sql_freeresult($result);

				if (sizeof($row))
				{
					$template->assign_var('S_GAME_ROWS', true);
				}

				$num_favs = $arcade->get_total('fav', $user->data['user_id']);

				$row_count = 0;
				foreach ($row as $item)
				{
					$template->assign_block_vars('games', array(
						'U_CAT'			=> $arcade->url('mode=cat&amp;c='  . $item['cat_id']),

						'ROW_NUMBER'	=> $row_count + ($start + 1),

						'GAME_ID'		=> $item['game_id'],
						'GAME_IMAGE'	=> ($arcade->optionget('view_game_image')) ? get_arcade_game_image($item['game_image'], 25, 25, 'x', 'play', $item['cat_id'], $item['game_id']) : false,
						'GAME_POPUP'	=> ($arcade->optionget('view_popup_icon')) ? get_arcade_game_popup('icon', $item['cat_id'], $item['game_id'], $item['game_width'], $item['game_height'], 'x', 13) : false,
						'GAME_NAME'		=> get_arcade_game_name($item['game_name'], false, 'play', $item['cat_id'], $item['game_id'], 'x'),
						'CAT_NAME'		=> $item['cat_name']
					));

					$row_count++;
				}

				$template->assign_vars(array(
					'PAGE_NUMBER'			=> on_page($num_favs, $games_per_page, $start),
					'PAGINATION'			=> generate_pagination($this->u_action . "&amp;sk=$sort_key&amp;sd=$sort_dir", $num_favs, $games_per_page, $start, true),
					'TOTAL_GAMES'			=> $num_favs,

					'U_SORT_GAME_NAME'		=> $this->u_action . "&amp;sk=n&amp;sd=" . (($sort_key == 'n' && $sort_dir == 'a') ? 'd' : 'a'),
					'U_SORT_CATEGORY_NAME'	=> $this->u_action . "&amp;sk=c&amp;sd=" . (($sort_key == 'c' && $sort_dir == 'a') ? 'd' : 'a'),

					'S_DISPLAY_MARK_ALL'	=> ($num_favs) ? true : false,
					'S_DISPLAY_PAGINATION'	=> ($num_favs) ? true : false,
					'S_SORT_OPTIONS' 		=> $s_sort_key,
					'S_ORDER_SELECT'		=> $s_sort_dir
				));
			break;

			case 'post':
				$data = array(
					'bbcode'	=> (bool) request_var('bbcode', $arcade->optionget('bbcode')),
					'smilies'	=> (bool) request_var('smilies', $arcade->optionget('smilies'))
				);

				add_form_key('ucp_arcade_post');

				if ($submit)
				{
					if (check_form_key('ucp_arcade_post'))
					{
						$arcade->optionset('bbcode', $data['bbcode']);
						$arcade->optionset('smilies', $data['smilies']);

						$sql_ary = array('user_arcade_options' => $user->data['user_arcade_options']);

						$sql = 'UPDATE ' . ARCADE_USERS_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
							WHERE user_id = ' . (int) $user->data['user_id'];
						$db->sql_query($sql);

						$msg = $user->lang['PREFERENCES_UPDATED'];
					}
					else
					{
						$msg = $user->lang['FORM_INVALID'];
					}

					meta_refresh(3, $this->u_action);
					$message = $msg . '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
					trigger_error($message);
				}

				$template->assign_vars(array(
					'S_BBCODE_ENABLED'	=> $data['bbcode'],
					'S_SMILIES_ENABLED'	=> $data['smilies']
				));
			break;

			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;

		}

		$template->assign_vars(array(
			'L_TITLE'			=> $user->lang['UCP_ARCADE_' . strtoupper($mode)],
			'L_TITLE_EXPLAIN'	=> $user->lang['UCP_ARCADE_' . strtoupper($mode) . '_EXPLAIN'],
			'S_UCP_ACTION'		=> $this->u_action
		));

		$this->tpl_name = 'ucp_arcade_' . $mode;
		$this->page_title = 'UCP_ARCADE_' . strtoupper($mode);
	}
}

?>