<?php
/**
*
* @package arcade
* @version $Id: config.php 2027 2012-03-20 18:45:39Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* Mod installation script created for phpbb Arcade
* by JRSweets. This can easily be modifed for
* use with any mod.
* @copyright (c) 2010 http://www.phpbbarcade.com
* @copyright (c) 2008 http://www.jeffrusso.net
* Some config values so the script can be used for different mods.
* EDIT VALUES BELOW
*/

if (!defined('IN_INSTALL') || !defined('IN_PHPBB'))
{
	exit;
}

$arcade_mod_config = array(
	'copyright'		=> 'Powered by <a href="http://phpbbarcade.origon.dk">phpBB Arcade</a> © 2008-2012',
	'version'		=> array(
		'current' 	=> '2.0.RC3',
		'oldest'	=> '1.0.0',
		'phpbb'		=> '3.0.10',
	)
);

$arcade_mod_config += array(
	'data_file'		=> array(
		'add'		=> '',
		'remove'	=> '',
	),
	'permission_options'		=> array(
		'arcade'	=> array(
			'local'		=> array('c_', 'c_list', 'c_view', 'c_play', 'c_playfree', 'c_score', 'c_rate', 'c_re_rate', 'c_comment', 'c_report', 'c_download', 'c_ignorecontrol', 'c_ignoreflood_download', 'c_ignoreflood_play', 'c_challenge_playing_games', 'c_challenge_start_game_warning', 'c_downloadfree'),
			'global'	=> array('u_', 'u_arcade', 'u_arcade_challenge', 'u_arcade_download', 'u_arcade_favorites', 'u_arcade_ignoreflood_search', 'u_arcade_popup', 'u_arcade_pm', 'u_arcade_resolution', 'u_arcade_search', 'u_arcade_view_whoisplaying', 'u_arcade_viewstats'),
		),
		'phpbb'		=> array(
			'local'		=> array(),
			'global'	=> array('a_arcade', 'a_arcade_backup', 'a_cauth', 'a_arcade_settings', 'a_arcade_points_settings', 'a_arcade_game', 'a_arcade_delete_game', 'a_arcade_cat', 'a_arcade_delete_cat', 'a_arcade_user', 'a_arcade_utilities'),
		),
		'update'	=> array(
			'2.0.RC1'=> array(
				'arcade'	=> array(
					'local'		=> array('c_ignoreflood_download', 'c_ignoreflood_play', 'c_re_rate'),
					'global'	=> array('u_', 'u_arcade', 'u_arcade_favorites', 'u_arcade_ignoreflood_search', 'u_arcade_view_whoisplaying', 'u_arcade_viewstats'),
				),
				'phpbb'	=> array(
					'local'		=> array(),
					'global'	=> array('a_arcade', 'a_arcade_points_settings', 'a_arcade_backup'),
				),
			),
			'2.0.RC2'=> array(
				'arcade'	=> array(
					'local'		=> array('c_challenge_playing_games', 'c_challenge_start_game_warning', 'c_downloadfree'),
					'global'	=> array('u_arcade_challenge', 'u_arcade_download', 'u_arcade_popup', 'u_arcade_pm', 'u_arcade_resolution', 'u_arcade_search'),
				),
				'phpbb'	=> array(
					'local'		=> array(),
					'global'	=> array('a_arcade_user'),
				),
			),
		),
	),
	'roles' => array(
		'phpbb'		=> array(),
		'arcade'	=> array(
			array(
				'role_name'			=> 'ROLE_ARCADE_NOACCESS',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_NOACCESS',
				'role_type'			=> 'c_',
				'data'				=> array(
										'access'	=> false,
										'options'	=> array('c_'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_FULL',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_FULL',
				'role_type'			=> 'c_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('c_', 'c_list', 'c_view', 'c_play', 'c_playfree', 'c_score', 'c_rate', 'c_re_rate', 'c_comment', 'c_report', 'c_download', 'c_ignorecontrol', 'c_ignoreflood_download', 'c_ignoreflood_play', 'c_challenge_playing_games', 'c_challenge_start_game_warning', 'c_downloadfree'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_LIMITED',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_LIMITED',
				'role_type'			=> 'c_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('c_', 'c_list', 'c_view', 'c_play', 'c_score'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_PLAYONLY',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_PLAYONLY',
				'role_type'			=> 'c_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('c_', 'c_list', 'c_view', 'c_play'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_STANDARD',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_STANDARD',
				'role_type'			=> 'c_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('c_', 'c_list', 'c_view', 'c_play', 'c_score', 'c_rate', 'c_comment', 'c_report'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_STANDARD_DOWNLOADS',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_STANDARD_DOWNLOADS',
				'role_type'			=> 'c_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('c_', 'c_list', 'c_view', 'c_play', 'c_score', 'c_rate', 'c_comment', 'c_report', 'c_download'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_VIEWONLY',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_VIEWONLY',
				'role_type'			=> 'c_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('c_', 'c_list', 'c_view'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_USER_NOACCESS',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_USER_NOACCESS',
				'role_type'			=> 'u_',
				'data'				=> array(
										'access'	=> false,
										'options'	=> array('u_'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_USER_FULL',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_USER_FULL',
				'role_type'			=> 'u_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('u_', 'u_arcade', 'u_arcade_challenge', 'u_arcade_download', 'u_arcade_favorites', 'u_arcade_ignoreflood_search', 'u_arcade_popup', 'u_arcade_pm', 'u_arcade_resolution', 'u_arcade_search', 'u_arcade_view_whoisplaying', 'u_arcade_viewstats'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_USER_LIMITED',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_USER_LIMITED',
				'role_type'			=> 'u_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('u_', 'u_arcade', 'u_arcade_challenge', 'u_arcade_popup', 'u_arcade_pm', 'u_arcade_resolution'),
										),
			),
			array(
				'role_name'			=> 'ROLE_ARCADE_USER_STANDARD',
				'role_description'	=> 'ROLE_DESCRIPTION_ARCADE_USER_STANDARD',
				'role_type'			=> 'u_',
				'data'				=> array(
										'access'	=> true,
										'options'	=> array('u_', 'u_arcade', 'u_arcade_challenge', 'u_arcade_favorites', 'u_arcade_popup', 'u_arcade_pm', 'u_arcade_resolution', 'u_arcade_search', 'u_arcade_view_whoisplaying', 'u_arcade_viewstats'),
										),
			),
		),
	),
	'modules'				=> array(
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> 'arcade_main',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_MAIN_INDEX',
					'module_mode' 		=> 'main',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_CAT_ARCADE_SETTINGS',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_settings',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_SETTINGS_GENERAL',
					'module_mode' 		=> 'settings',
					'module_auth' 		=> 'acl_a_arcade_settings',
				),
				array(
					'module_basename'	=> 'arcade_settings',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_SETTINGS_GAME',
					'module_mode' 		=> 'game',
					'module_auth' 		=> 'acl_a_arcade_settings',
				),
				array(
					'module_basename'	=> 'arcade_settings',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_SETTINGS_CHALLENGE',
					'module_mode' 		=> 'challenge',
					'module_auth' 		=> 'acl_a_arcade_settings',
				),
				array(
					'module_basename'	=> 'arcade_settings',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_SETTINGS_FEATURE',
					'module_mode' 		=> 'feature',
					'module_auth' 		=> 'acl_a_arcade_settings',
				),
				array(
					'module_basename'	=> 'arcade_settings',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_SETTINGS_ARCADE_PAGE',
					'module_mode' 		=> 'apage',
					'module_auth' 		=> 'acl_a_arcade_settings',
				),
				array(
					'module_basename'	=> 'arcade_settings',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_SETTINGS_CHALLENGE_PAGE',
					'module_mode' 		=> 'cpage',
					'module_auth' 		=> 'acl_a_arcade_settings',
				),
				array(
					'module_basename'	=> 'arcade_settings',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_SETTINGS_PATH',
					'module_mode' 		=> 'path',
					'module_auth' 		=> 'acl_a_arcade_settings',
				),
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_CAT_ARCADE_MANAGE',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_manage',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_MANAGE_CATEGORIES',
					'module_mode' 		=> 'category',
					'module_auth' 		=> 'acl_a_arcade_cat'
				),
				array(
					'module_basename'	=> 'arcade_manage',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_MANAGE_GAMES',
					'module_mode' 		=> 'games',
					'module_auth' 		=> 'acl_a_arcade_game'
				),
				array(
					'module_basename'	=> 'arcade_manage',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_MANAGE_USERS',
					'module_mode' 		=> 'users',
					'module_auth' 		=> 'acl_a_arcade_user'
				),
				array(
					'module_basename'	=> 'arcade_manage',
					'module_enabled' 	=> '0',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_MANAGE_CHALLENGES',
					'module_mode' 		=> 'challenges',
					'module_auth' 		=> 'acl_a_arcade_user'
				),
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_CAT_ARCADE_GAMES_FEATURE',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_games',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_ADD_GAMES',
					'module_mode' 		=> 'add_games',
					'module_auth' 		=> 'acl_a_arcade_game'
				),
				array(
					'module_basename'	=> 'arcade_games',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UNPACK_GAMES',
					'module_mode' 		=> 'unpack_games',
					'module_auth' 		=> 'acl_a_arcade_game'
				),
				array(
					'module_basename'	=> 'arcade_games',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_BACKUP_GAMES',
					'module_mode' 		=> 'backup_games',
					'module_auth' 		=> 'acl_a_arcade_backup'
				),
				array(
					'module_basename'	=> 'arcade_games',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_DOWNLOADS_GAMES',
					'module_mode' 		=> 'downloads_games',
					'module_auth' 		=> 'acl_a_arcade_game'
				),
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_CAT_ARCADE_UTILITIES',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_ERRORS',
					'module_mode' 		=> 'errors',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_REPORTS',
					'module_mode' 		=> 'reports',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_USERS_BANNED',
					'module_mode' 		=> 'users_banned',
					'module_auth' 		=> 'acl_a_arcade_user',
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_DOWNLOAD_STATS',
					'module_mode' 		=> 'download_stats',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_GLOBAL_ANNOUNCE',
					'module_mode' 		=> 'global_announce',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_CREATE_INSTALL',
					'module_mode' 		=> 'create_install',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_USER_GUIDE',
					'module_mode' 		=> 'user_guide',
					'module_auth' 		=> ''
				),
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_CAT_ARCADE_PERMISSION_ROLES',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_permission_roles',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_CAT_ROLES',
					'module_mode' 		=> 'cat_roles',
					'module_auth' 		=> 'acl_a_cauth && acl_a_roles',
				),
				array(
					'module_basename'	=> 'arcade_permission_roles',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_USER_ROLES',
					'module_mode' 		=> 'user_roles',
					'module_auth' 		=> 'acl_a_cauth && acl_a_roles',
				),
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_CAT_ARCADE_GLOBAL_PERMISSIONS',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_USERS_PERMISSIONS',
					'module_mode' 		=> 'setting_user_global',
					'module_auth' 		=> 'acl_a_authusers && acl_a_cauth',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_GROUPS_PERMISSIONS',
					'module_mode' 		=> 'setting_group_global',
					'module_auth' 		=> 'acl_a_authgroups && acl_a_cauth',
				),
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_CAT_ARCADE_PERMISSIONS',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_PERMISSION_TRACE',
					'module_mode' 		=> 'trace',
					'module_auth' 		=> 'acl_a_viewauth',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_CATEGORY_PERMISSIONS',
					'module_mode' 		=> 'setting_category_local',
					'module_auth' 		=> 'acl_a_cauth && (acl_a_authusers || acl_a_authgroups)',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_USERS_CATEGORY_PERMISSIONS',
					'module_mode' 		=> 'setting_user_local',
					'module_auth' 		=> 'acl_a_authusers && acl_a_cauth',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_GROUPS_CATEGORY_PERMISSIONS',
					'module_mode' 		=> 'setting_group_local',
					'module_auth' 		=> 'acl_a_authgroups && acl_a_cauth',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_CATEGORY_PERMISSIONS_COPY',
					'module_mode' 		=> 'setting_category_copy',
					'module_auth' 		=> 'acl_a_cauth && acl_a_authusers && acl_a_authgroups',
				),
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_CAT_ARCADE_PERMISSION_MASKS',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_VIEW_ARCADE_USERS_PERMISSIONS',
					'module_mode' 		=> 'view_user_global',
					'module_auth' 		=> 'acl_a_viewauth',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_VIEW_ARCADE_CATEGORY_PERMISSIONS',
					'module_mode' 		=> 'view_category_local',
					'module_auth' 		=> 'acl_a_viewauth',
				),
			),
		),
		array(
			'parent_module_data'	=> array(
					'module_basename' 	=> '',
					'module_enabled'	=> '1',
					'module_display' 	=> '1',
					'parent_id' 		=> '0',
					'module_class' 		=> 'ucp',
					'module_langname' 	=> 'UCP_CAT_ARCADE',
					'module_mode' 		=> '',
					'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'ucp',
					'module_langname' 	=> 'UCP_ARCADE_SETTINGS',
					'module_mode' 		=> 'settings',
					'module_auth' 		=> ''
				),
				array(
					'module_basename'	=> 'arcade',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'ucp',
					'module_langname' 	=> 'UCP_ARCADE_POST',
					'module_mode' 		=> 'post',
					'module_auth' 		=> ''
				),
				array(
					'module_basename'	=> 'arcade',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'ucp',
					'module_langname' 	=> 'UCP_ARCADE_FAVORITES',
					'module_mode' 		=> 'favorites',
					'module_auth' 		=> ''
				),
			),
		),
	),
	'modules_remove'	=> array(
		'modules'		=> array('arcade', 'arcade_settings', 'arcade_manage', 'arcade_games', 'arcade_utilities', 'arcade_permission_roles', 'arcade_permissions'),
		'parents'		=> array('ACP_ARCADE', 'ACP_CAT_ARCADE', 'ACP_CAT_ARCADE_MANAGE', 'ACP_ARCADE_MANAGE_ARCADE', 'ACP_CAT_ARCADE_GAMES_FEATURE', 'ACP_ARCADE_MAIN_INDEX', 'ACP_ARCADE_INDEX', 'ACP_CAT_ARCADE_SETTINGS', 'ACP_CAT_ARCADE_CONFIGURATION', 'ACP_CAT_ARCADE_GAMES', 'ACP_CAT_ARCADE_UTILITIES', 'ACP_CAT_ARCADE_PERMISSION_ROLES', 'ACP_CAT_ARCADE_PERMISSIONS', 'ACP_CAT_ARCADE_PERMISSION_MASKS', 'ACP_CAT_ARCADE_GLOBAL_PERMISSIONS', 'UCP_ARCADE', 'UCP_CAT_ARCADE', 'ACP_USER_ARCADE'),
	),
	'phpbb_users_modules'	=> array(
			array(
					'module_basename'	=> 'users',
					'module_enabled'	=> '1',
					'module_display'	=> '0',
					'module_class'		=> 'acp',
					'module_langname'	=> 'ACP_USER_ARCADE',
					'module_mode'		=> 'arcade',
					'module_auth'		=> 'acl_a_user'
		),
	),
	'schema_changes'=> array(
		'add'		=> array(),
		'update'	=> array(
			'2.0.RC1' => array(
				'drop_columns'		=> array(
					USERS_TABLE				=> array('user_arcade_permissions', 'user_arcade_perm_from', 'user_arcade_pm', 'games_per_page', 'games_sort_dir', 'games_sort_order'),
					ARCADE_GAMES_TABLE		=> array('game_files'),
				),
				'add_columns'		=> array(
					ARCADE_CONFIG_TABLE		=> array('is_dynamic'	=> array('BOOL', 0)),
				),
				'add_index'			=> array(
					ARCADE_CONFIG_TABLE		=> array(
						'is_dynamic'		=> array('is_dynamic')
					),

					ARCADE_SESSIONS_TABLE	=> array(
						'game_id'			=> array('game_id'),
					),

					ARCADE_PLAYS_TABLE	=> array(
						'uid'			=> array('user_id'),
					),

					ARCADE_GAMES_TABLE	=> array(
						'highuser'		=> array('game_highuser'),
						'installdate'	=> array('game_installdate'),
						'highdate'		=> array('game_highdate'),
						'plays'			=> array('game_plays'),
						'download'		=> array('game_download_total')
					),
				),
				'change_columns'		=> array(
					ARCADE_SESSIONS_TABLE	=> array(
						'randchar1'			=> array('UINT', 0),
						'randchar2'			=> array('UINT', 0),
						'randgid1'			=> array('UINT', 0),
						'randgid2'			=> array('UINT', 0),
					),
				),
			),
			'2.0.RC2' => array(
				'drop_columns'			=> array(
					ARCADE_ERRORS_TABLE				=> array('game_type', 'submitted_game_type'),
					ARCADE_USERS_TABLE				=> array('user_arcade_pm'),
				),
				'add_columns'					=> array(
					ARCADE_SESSIONS_TABLE		=> array(
						'game_popup'			=> array('TINT:1', 0),
						'microtime'				=> array('TIMESTAMP', 0),
					),
					ARCADE_USERS_TABLE			=> array(
						'user_arcade_options'	=> array('UINT:11', 223),
					),
					ARCADE_GAMES_TABLE			=> array(
						'game_download_cost'	=> array('PDECIMAL:15', 0.00),
					),
					ARCADE_CATS_TABLE			=> array(
						'cat_download_cost'		=> array('PDECIMAL:15', 0.00),
					),
				),
				'add_index'				=> array(
					ARCADE_CATS_TABLE	=> array(
						'status'		=> array('cat_status'),
						'ctest'			=> array('cat_test'),
					),
					ARCADE_SESSIONS_TABLE	=> array(
						'phpbb_sid'			=> array('phpbb_session_id'),
					),
				),
			),
		),
		'remove'	=> array(
			'drop_columns'		=> array(
				USERS_TABLE	=> array('user_arcade_permissions', 'user_arcade_perm_from', 'user_arcade_pm', 'user_arcade_last_download', 'user_arcade_last_play', 'user_arcade_last_search', 'user_arcade_last_search_term', 'games_per_page', 'games_sort_dir', 'games_sort_order', 'user_challenge_on', 'user_challenge_pm_on', 'user_challenge_stat'),
			),
		),
	),
	'phpbb_config'	=> array(
		array('arcade_install', '1'),
	),
	'config_data'	=> array(
		array('acp_items_per_page', '10'),
		array('global_announce_enable', '0'),
		array('announce_forum', '0'),
		array('announce_game', '0'),
		array("announce_message", "[game_image]\n[b]Game Name:[/b] [game_name]\n[b]Game Description:[/b] [game_desc]\n\n[game_link]\n[game_popup_link]\n[download_link]\n[stats_link]"),
		array('announce_subject', '[GAME RELEASE] [game_name]'),
		array('arcade_disable', '0'),
		array('arcade_disable_msg', ''),
		array('arcade_flash_intro', '1'),
		array('arcade_leaders', '5'),
		array('arcade_leaders_header', '3'),
		array('arcade_resetdate', '0'),
		array('arcade_startdate', time()),
		array('auto_disable', '0'),
		array('auto_disable_end', ''),
		array('auto_disable_start', ''),
		array('backup_limit', '50'),
		array('cache_time', '4'),
		array('cat_backup_path', 'arcade/backup/'),
		array('cat_image_path', 'arcade/images/cats/'),
		array('cat_leaders', '5'),
		array('cat_least_downloaded', '5'),
		array('cat_least_popular', '5'),
		array('cat_least_played_users', '5'),
		array('cat_most_played_users', '5'),
		array('cat_longest_held_scores', '5'),
		array('cat_most_downloaded', '5'),
		array('cat_most_popular', '5'),
		array('challenge_acc_exp_date', '604800'),
		array('challenge_disable', '0'),
		array('challenge_disable_msg', ''),
		array('challenge_least_popular', '5'),
		array('challenge_latest_winners', '5'),
		array('challenge_least_played_users', '5'),
		array('challenge_most_played_users', '5'),
		array('challenge_leaders', '5'),
		array('challenge_leaders_header', '3'),
		array('challenge_links_index', '1'),
		array('challenge_links_stats', '1'),
		array('challenge_most_popular', '5'),
		array('challenge_ong_exp_date', '1209600'),
		array('challenge_bet_Minimum', '0'),
		array('challenge_bet_Maximum', '0'),
		array('challenge_bet_fix', '0'),
		array('challenge_exp_last_gc', time(), true),
		array('challenge_users_select', '1'),
		array('challenge_resetdate', time()),
		array('challenge_top_games_header', '10'),
		array('challenge_total_plays', '0', true),
		array('challenge_total_plays_time', '0', true),
		array('challenge_welcome_index', '1'),
		array('challenge_welcome_stats', '1'),
		array('cm_currency_id', '0'),
		array('copyright', $arcade_mod_config['copyright']),
		array('corrupt_score_banned', 0),
		array('display_desc', '1'),
		array('display_game_type', '1'),
		array('display_memberlist', '1'),
		array('display_viewtopic', '1'),
		array('display_game_image', '1'),
		array('display_user_avatar', '1'),
		array('display_game_popup_icon', '1'),
		array('download_anonymous_interval', '0'),
		array('download_interval', '0'),
		array('download_list', '0'),
		array('download_list_message', ''),
		array('download_list_per_page', '50'),
		array('download_on_demand', '1'),
		array('download_file_type', ''),
		array('enable_image_link', '1'),
		array('enable_user_avatar_link', '1'),
		array('facebook_like_enable', '0'),
		array('flash_version', '10.0.0.0'),
		array('founder_exempt', '0'),
		array('game_autosize', '1'),
		array('game_comment', '1'),
		array('game_cost', '0'),
		array('game_download_cost', '0'),
		array('game_height', '0'),
		array('game_path', 'arcade/games/'),
		array('game_reward', '0'),
		array('game_scores', '5'),
		array('game_width', '0'),
		array('game_zero_negative_score', '0'),
		array('games_per_page', '10'),
		array('games_sort_dir', 'd'),
		array('games_sort_order', 'd'),
		array('gamename_maxchars', 12),
		array('google_like_enable', '0'),
		array('game_desc_parse_html', '0'),
		array('gc_time', '3600'),
		array('image_path', 'arcade/images/'),
		array('jackpot_Maximum', '0'),
		array('jackpot_Minimum', '0'),
		array('latest_highscores', '5'),
		array('least_downloaded', '5'),
		array('least_played_users', '5'),
		array('least_popular', '5'),
		array('least_jackpot', '5'),
		array('least_users_playtime', '5'),
		array('like_background_color', ''),
		array('like_counter_enable', '1'),
		array('limit_play', '0'),
		array('limit_play_days', '7'),
		array('limit_play_posts', '10'),
		array('limit_play_total_posts', '10'),
		array('links_cats', '1'),
		array('links_index', '1'),
		array('links_stats', '1'),
		array('load_list', '0'),
		array('longest_held_scores', '5'),
		array('most_downloaded', '5'),
		array('most_played_users', '5'),
		array('most_popular', '5'),
		array('most_jackpot', '5'),
		array('most_users_playtime', '5'),
		array('new_games_delay', '5'),
		array('newest_games', '10'),
		array('online_time', '0'),
		array('override_user_sort', '0'),
		array('parse_bbcode', '1'),
		array('parse_links', '1'),
		array('parse_smilies', '1'),
		array('play_anonymous_interval', '0'),
		array('playfree_reward', '0'),
		array('play_interval', '0'),
		array('played_colour', ''),
		array('protect_amod', '1'),
		array('protect_ibpro', '1'),
		array('protect_phpbbarcade', '1'),
		array('protect_v3arcade', '1'),
		array('record_playing_date', time(), true),
		array('record_playing_users', '0', true),
		array('reports_open', '0'),
		array('resolution_select', '1'),
		array('score_security_level', '2'),
		array('search_anonymous_interval', '0'),
		array('search_cats', '1'),
		array('search_filter_age', '0'),
		array('search_filter_password', '0'),
		array('search_index', '1'),
		array('search_interval', '0'),
		array('search_stats', '1'),
		array('send_arcade_pm', '1'),
		array('session_last_gc', time(), true),
		array('session_length', '72000'),
		array('share_icons_enable', '0'),
		array('smilies_popup_height', 350),
		array('smilies_popup_width', 500),
		array('stat_items_per_page', '10'),
		array('total_downloads', '0', true),
		array('total_plays', '0', true),
		array('total_plays_time', '0', true),
		array('tweet_like_enable', '0'),
		array('unpack_game_path', 'arcade/install/'),
		array('use_jackpot', '0'),
		array('use_points', '0'),
		array('version', $arcade_mod_config['version']['current']),
		array('welcome_cats', '1'),
		array('welcome_index', '1'),
		array('welcome_stats', '1'),
	),
	'schema_data'	=> array(
		ACL_ARCADE_GROUPS_TABLE				=> array(
			'COLUMNS'						=> array(
			'group_id'						=> array('UINT', 0),
			'cat_id'						=> array('UINT', 0),
			'auth_option_id'				=> array('UINT', 0),
			'auth_role_id'					=> array('UINT', 0),
			'auth_setting'					=> array('TINT:2', 0),
			),
			'KEYS'							=> array(
			'g_id'							=> array('INDEX', 'group_id'),
			'ao_id'							=> array('INDEX', 'auth_option_id'),
			'ar_id'							=> array('INDEX', 'auth_role_id'),
			),
		),
		ACL_ARCADE_OPTIONS_TABLE			=> array(
			'COLUMNS'						=> array(
			'auth_option_id'				=> array('UINT', NULL, 'auto_increment'),
			'auth_option'					=> array('VCHAR:50', ''),
			'is_global'						=> array('BOOL', 0),
			'is_local'						=> array('BOOL', 0),
			'founder_only'					=> array('BOOL', 0),
			),
			'PRIMARY_KEY'					=> 'auth_option_id',
			'KEYS'							=> array(
			'au_op'							=> array('UNIQUE', 'auth_option'),
			),
		),
		ACL_ARCADE_ROLES_TABLE				=> array(
			'COLUMNS'						=> array(
			'role_id'						=> array('UINT', NULL, 'auto_increment'),
			'role_name'						=> array('VCHAR_UNI', ''),
			'role_description'				=> array('TEXT_UNI', ''),
			'role_type'						=> array('VCHAR:10', ''),
			'role_order'					=> array('USINT', 0),
			),
			'PRIMARY_KEY'					=> 'role_id',
			'KEYS'							=> array(
			'r_type'						=> array('INDEX', 'role_type'),
			'r_order'						=> array('INDEX', 'role_order'),
			),
		),
		ACL_ARCADE_ROLES_DATA_TABLE			=> array(
			'COLUMNS'						=> array(
			'role_id'						=> array('UINT', 0),
			'auth_option_id'				=> array('UINT', 0),
			'auth_setting'					=> array('TINT:2', 0),
			),
			'PRIMARY_KEY'					=> array('role_id', 'auth_option_id'),
			'KEYS'							=> array(
			'aoi'							=> array('INDEX', 'auth_option_id'),
			),
		),
		ACL_ARCADE_USERS_TABLE				=> array(
			'COLUMNS'						=> array(
			'user_id'						=> array('UINT', 0),
			'cat_id'						=> array('UINT', 0),
			'auth_option_id'				=> array('UINT', 0),
			'auth_role_id'					=> array('UINT', 0),
			'auth_setting'					=> array('TINT:2', 0),
			),
			'KEYS'							=> array(
			'user_id'						=> array('INDEX', 'user_id'),
			'autho_id'						=> array('INDEX', 'auth_option_id'),
			'authr_id'						=> array('INDEX', 'auth_role_id'),
			),
		),
		ARCADE_ACCESS_TABLE					=> array(
			'COLUMNS'						=> array(
			'cat_id'						=> array('UINT', 0),
			'user_id'						=> array('UINT', 0),
			'session_id'					=> array('CHAR:32', ''),
			),
			'PRIMARY_KEY'					=> array('cat_id', 'user_id', 'session_id'),
		),
		ARCADE_CATS_TABLE					=> array(
			'COLUMNS'						=> array(
			'cat_id'						=> array('UINT', NULL, 'auto_increment'),
			'parent_id'						=> array('UINT', 0),
			'left_id'						=> array('UINT', 0),
			'right_id'						=> array('UINT', 0),
			'cat_parents'					=> array('MTEXT', ''),
			'cat_name'						=> array('STEXT_UNI', ''),
			'cat_desc'						=> array('TEXT_UNI', ''),
			'cat_desc_bitfield'				=> array('VCHAR:255', ''),
			'cat_desc_options'				=> array('UINT:11', 7),
			'cat_desc_uid'					=> array('VCHAR:8', ''),
			'cat_link'						=> array('VCHAR_UNI', ''),
			'cat_password'					=> array('VCHAR_UNI:40', ''),
			'cat_age'						=> array('TINT:2', 0),
			'cat_style'						=> array('USINT', 0),
			'cat_display'					=> array('USINT', 0),
			'cat_image'						=> array('VCHAR', ''),
			'cat_rules'						=> array('TEXT_UNI', ''),
			'cat_rules_link'				=> array('VCHAR_UNI', ''),
			'cat_rules_bitfield'			=> array('VCHAR:255', ''),
			'cat_rules_options'				=> array('UINT:11', 7),
			'cat_rules_uid'					=> array('VCHAR:8', ''),
			'cat_games_per_page'			=> array('TINT:4', 0),
			'cat_type'						=> array('TINT:4', 0),
			'cat_test'						=> array('BOOL', 0),
			'cat_status'					=> array('TINT:4', 0),
			'cat_games'						=> array('UINT', 0),
			'cat_plays'						=> array('UINT', 0),
			'cat_download'					=> array('TINT:1', 1),
			'cat_use_jackpot'				=> array('BOOL', 0),
			'cat_cost'						=> array('PDECIMAL:15', 0.00),
			'cat_download_cost'				=> array('PDECIMAL:15', 0.00),
			'cat_reward'					=> array('PDECIMAL:15', 0.00),
			'cat_last_play_game_id'			=> array('UINT', 0),
			'cat_last_play_game_name'		=> array('VCHAR_UNI', ''),
			'cat_last_play_user_id'			=> array('UINT', 0),
			'cat_last_play_score'			=> array('PDECIMAL:25', 0.00),
			'cat_last_play_time'			=> array('TIMESTAMP', 0),
			'cat_last_game_installdate'		=> array('TIMESTAMP', 0),
			'cat_last_play_username'		=> array('VCHAR_UNI', ''),
			'cat_last_play_user_colour'		=> array('VCHAR:6', ''),
			'cat_flags'						=> array('TINT:4', 32),
			'display_subcat_list'			=> array('BOOL', 1),
			'display_on_index'				=> array('BOOL', 1),
			),
			'PRIMARY_KEY'					=> 'cat_id',
			'KEYS'							=> array(
			'lr_id'							=> array('INDEX', array('left_id', 'right_id')),
			'clg_id'						=> array('INDEX', 'cat_last_play_game_id'),
			'status'						=> array('INDEX', 'cat_status'),
			'ctest'							=> array('INDEX', 'cat_test'),
			),
		),
		ARCADE_CONFIG_TABLE					=> array(
			'COLUMNS'						=> array(
			'config_name'					=> array('VCHAR', ''),
			'config_value'					=> array('VCHAR_UNI', ''),
			'is_dynamic'					=> array('BOOL', 0),
			),
			'PRIMARY_KEY'					=> 'config_name',
			'KEYS'							=> array('is_dynamic' => array('INDEX' , 'is_dynamic')),
		),
		ARCADE_DOWNLOAD_TABLE				=> array(
			'COLUMNS'						=> array(
			'user_id'						=> array('UINT', 0),
			'game_id'						=> array('UINT', 0),
			'total'							=> array('UINT', 0),
			'download_time'					=> array('TIMESTAMP', 0),
			),
			'PRIMARY_KEY'					=> array('user_id', 'game_id'),
		),
		ARCADE_ERRORS_TABLE					=> array(
			'COLUMNS'						=> array(
			'error_id'						=> array('UINT', NULL, 'auto_increment'),
			'user_id'						=> array('UINT', 0),
			'game_id'						=> array('UINT', 0),
			'score'							=> array('PDECIMAL:25', 0.00),
			'error_date'					=> array('TIMESTAMP', 0),
			'error_type'					=> array('TINT:1', 0),
			'played_time'					=> array('INT:11', 0),
			'error_ip'						=> array('VCHAR:40', ''),
			),
			'PRIMARY_KEY'					=> 'error_id',
		),
		ARCADE_FAVS_TABLE					=> array(
			'COLUMNS'						=> array(
			'user_id'						=> array('UINT', 0),
			'game_id'						=> array('UINT', 0),
			),
			'PRIMARY_KEY'					=> array('user_id', 'game_id'),
		),
		ARCADE_GAMES_TABLE					=> array(
			'COLUMNS'						=> array(
			'game_id'						=> array('UINT', NULL, 'auto_increment'),
			'game_image'					=> array('VCHAR', ''),
			'game_desc'						=> array('TEXT', ''),
			'game_highscore'				=> array('PDECIMAL:25', 0.00),
			'game_highdate'					=> array('TIMESTAMP', 0),
			'game_highuser'					=> array('UINT', 0),
			'game_name'						=> array('VCHAR', ''),
			'game_name_clean'				=> array('VCHAR', ''),
			'game_swf'						=> array('VCHAR', ''),
			'game_scorevar'					=> array('VCHAR', ''),
			'game_type'						=> array('TINT:1', 0),
			'game_width'					=> array('UINT:5', 550),
			'game_height'					=> array('UINT:5', 380),
			'game_installdate'				=> array('TIMESTAMP', 0),
			'game_filesize'					=> array('UINT:20', 0),
			'game_scoretype'				=> array('TINT:1', 0),
			'game_order'					=> array('UINT', 0),
			'game_plays'					=> array('UINT', 0),
			'game_votetotal'				=> array('UINT', 0),
			'game_votesum'					=> array('UINT', 0),
			'game_download_total'			=> array('UINT', 0),
			'game_download'					=> array('TINT:1', 1),
			'game_cost'						=> array('PDECIMAL:15', 0.00),
			'game_download_cost'			=> array('PDECIMAL:15', 0.00),
			'game_reward'					=> array('PDECIMAL:15', 0.00),
			'game_use_jackpot'				=> array('BOOL', 0),
			'game_jackpot'					=> array('PDECIMAL:15', 0.00),
			'cat_id'						=> array('UINT', 0),
			),
			'PRIMARY_KEY'					=> 'game_id',
			'KEYS'							=> array(
													'highuser'		=> array('INDEX' , 'game_highuser'),
													'installdate'	=> array('INDEX' , 'game_installdate'),
													'highdate'		=> array('INDEX' , 'game_highdate'),
													'plays'			=> array('INDEX' , 'game_plays'),
													'download'		=> array('INDEX' , 'game_download_total')
												),
		),
		ARCADE_PLAYS_TABLE					=> array(
			'COLUMNS'						=> array(
			'game_id'						=> array('UINT', 0),
			'user_id'						=> array('UINT', 0),
			'total_time'					=> array('TIMESTAMP', 0),
			'total_plays'					=> array('UINT', 0),
			),
			'PRIMARY_KEY'					=> array('game_id', 'user_id'),
			'KEYS'							=> array(
													'uid' => array('INDEX' , 'user_id')
												),
		),
		ARCADE_RATING_TABLE					=> array(
			'COLUMNS'						=> array(
			'game_id'						=> array('UINT', 0),
			'user_id'						=> array('UINT', 0),
			'game_rating'					=> array('UINT', 0),
			'rating_date'					=> array('TIMESTAMP', 0),
			'user_ip'						=> array('VCHAR:40', ''),
			),
			'PRIMARY_KEY'					=> array('game_id', 'user_id'),
		),
		ARCADE_REPORTS_TABLE				=> array(
			'COLUMNS'						=> array(
			'report_id'						=> array('UINT', NULL, 'auto_increment'),
			'user_id'						=> array('UINT', 0),
			'game_id'						=> array('UINT', 0),
			'report_type'					=> array('TINT:1', 0),
			'report_desc'					=> array('TEXT_UNI', ''),
			'report_desc_bitfield'			=> array('VCHAR:255', ''),
			'report_desc_options'			=> array('UINT:11', 7),
			'report_desc_uid'				=> array('VCHAR:8', ''),
			'report_time'					=> array('INT:11', 0),
			'report_ip'						=> array('VCHAR:40', ''),
			'report_closed'					=> array('TINT:1', 0),
			),
			'PRIMARY_KEY'					=> 'report_id',
		),
		ARCADE_SCORES_TABLE					=> array(
			'COLUMNS'						=> array(
			'game_id'						=> array('UINT', 0),
			'user_id'						=> array('UINT', 0),
			'score'							=> array('PDECIMAL:25', 0.00),
			'comment_text'					=> array('MTEXT', ''),
			'comment_bitfield'				=> array('VCHAR:255', ''),
			'comment_options'				=> array('UINT:11', 7),
			'comment_uid'					=> array('VCHAR:8', ''),
			'score_date'					=> array('TIMESTAMP', 0),
			),
			'PRIMARY_KEY'					=> array('game_id', 'user_id'),
		),
		ARCADE_SESSIONS_TABLE				=> array(
			'COLUMNS'						=> array(
			'session_id'					=> array('CHAR:32', ''),
			'game_id'						=> array('UINT', 0),
			'user_id'						=> array('UINT', 0),
			'game_type'						=> array('TINT:1', 0),
			'game_popup'					=> array('TINT:1', 0),
			'randchar1'						=> array('UINT', 0),
			'randchar2'						=> array('UINT', 0),
			'randgid1'						=> array('UINT', 0),
			'randgid2'						=> array('UINT', 0),
			'start_time'					=> array('TIMESTAMP', 0),
			'microtime'						=> array('TIMESTAMP', 0),
			'phpbb_session_id'				=> array('CHAR:32', ''),
			),
			'PRIMARY_KEY'					=> 'session_id',
			'KEYS'							=> array(
													'game_id'	=> array('INDEX' , 'game_id'),
													'phpbb_sid'	=> array('INDEX' , 'phpbb_session_id'),
												),
		),
		ARCADE_USERS_TABLE					=> array(
			'COLUMNS'						=> array(
			'user_id'						=> array('UINT', 0),
			'user_arcade_permissions'		=> array('MTEXT', ''),
			'user_arcade_perm_from'			=> array('UINT', 0),
			'user_arcade_last_download'		=> array('TIMESTAMP', 0),
			'user_arcade_last_play'			=> array('TIMESTAMP', 0),
			'user_arcade_last_search'		=> array('TIMESTAMP', 0),
			'user_arcade_last_search_term'	=> array('VCHAR:255', ''),
			'user_arcade_options'			=> array('UINT:11', 223),
			'games_per_page'				=> array('USINT', 0),
			'games_sort_dir'				=> array('VCHAR_UNI:1', 'd'),
			'games_sort_order'				=> array('VCHAR_UNI:1', 'd'),
			),
			'PRIMARY_KEY'					=> 'user_id',
		),
		ARCADE_USERS_BANNED_TABLE			=> array(
			'COLUMNS'						=> array(
			'user_id'						=> array('UINT', 0),
			'banned_type'					=> array('TINT:1', 0),
			'banned_ip'						=> array('VCHAR:40', ''),
			'banned_date'					=> array('TIMESTAMP', 0),
			'game_id'						=> array('UINT', 0),
			'score'							=> array('PDECIMAL:25', 0.00),
			),
			'PRIMARY_KEY'					=> 'user_id',
		),
		ARCADE_ANNOUNCE_TABLE				=> array(
			'COLUMNS'						=> array(
			'user_id'						=> array('UINT', 0),
			'username'						=> array('VCHAR:255', ''),
			'user_colour'					=> array('VCHAR:6', ''),
			'announce_author'				=> array('TINT:1', 0),
			'announce_anonym'				=> array('TINT:1', 0),
			'announce_scroll'				=> array('TINT:1', 0),
			'announce_title'				=> array('VCHAR:255', ''),
			'announce_text'					=> array('MTEXT', ''),
			'announce_bitfield'				=> array('VCHAR:255', ''),
			'announce_options'				=> array('UINT:11', 7),
			'announce_uid'					=> array('VCHAR:8', ''),
			'announce_date'					=> array('TIMESTAMP', 0),
			),
			'PRIMARY_KEY'					=> 'user_id',
		),

		ARCADE_CHALLENGE_TABLE				=> array(
			'COLUMNS'						=> array(
			'challenge_id'					=> array('UINT', NULL, 'auto_increment'),
			'challenge_accept'				=> array('TINT:1', 0),
			'challenge_points'				=> array('PDECIMAL:25', 0.000),
			//'challenge_bet'				=> array('PDECIMAL:25', 0.000),
			'challenger_id'					=> array('UINT', NULL),
			'opponent_id'					=> array('UINT', NULL),
			'game_id'						=> array('UINT', NULL),
			'challenger_game_cost'			=> array('PDECIMAL:25', 0.000),
			'opponent_game_cost'			=> array('PDECIMAL:25', 0.000),
			'challenge_time'				=> array('TIMESTAMP', 0),
			//'expiration_date'				=> array('TIMESTAMP', 0),
			),
			'PRIMARY_KEY'					=> 'challenge_id',
			'KEYS'							=> array(
													'ca'	=> array('INDEX' , 'challenge_accept'),
													'cid'	=> array('INDEX' , 'challenger_id'),
													'oid'	=> array('INDEX' , 'opponent_id'),
													'gid'	=> array('INDEX' , 'game_id')
												),
		),
		ARCADE_CHALLENGE_CHAMP_TABLE		=> array(
			'COLUMNS'						=> array(
			'champ_id'						=> array('UINT', NULL, 'auto_increment'),
			'champ_challenger_id'			=> array('UINT', NULL),
			'champ_challenger_score'		=> array('PDECIMAL:25', 0.000),
			'champ_opponent_id'				=> array('UINT', NULL),
			'champ_opponent_score'			=> array('PDECIMAL:25', 0.000),
			'game_id'						=> array('UINT', NULL),
			'champ_winner'					=> array('UINT', NULL),
			'champ_challenger_time'			=> array('TIMESTAMP', 0),
			'champ_opponent_time'			=> array('TIMESTAMP', 0),
			'champ_close'					=> array('TINT:1', 0),
			'champ_end_time'				=> array('TIMESTAMP', 0),
			),
			'PRIMARY_KEY'					=> 'champ_id',
			'KEYS'							=> array(
													'ci'	=> array('INDEX' , 'champ_challenger_id'),
													'oi'	=> array('INDEX' , 'champ_opponent_id'),
													'cg'	=> array('INDEX' , 'game_id'),
													'cw'	=> array('INDEX' , 'champ_winner'),
													'cc'	=> array('INDEX' , 'champ_close')
												),
		),
	)
);

$arcade_mod_config['verify'] = array(
	'tables'			=> array(ACL_ARCADE_GROUPS_TABLE, ACL_ARCADE_OPTIONS_TABLE, ACL_ARCADE_ROLES_DATA_TABLE, ACL_ARCADE_ROLES_TABLE, ACL_ARCADE_USERS_TABLE, ARCADE_ACCESS_TABLE, ARCADE_CATS_TABLE, ARCADE_CONFIG_TABLE, ARCADE_DOWNLOAD_TABLE, ARCADE_GAMES_TABLE, ARCADE_FAVS_TABLE, ARCADE_PLAYS_TABLE, ARCADE_RATING_TABLE, ARCADE_SESSIONS_TABLE, ARCADE_SCORES_TABLE, ARCADE_ERRORS_TABLE, ARCADE_REPORTS_TABLE, ARCADE_USERS_TABLE, ARCADE_USERS_BANNED_TABLE, ARCADE_ANNOUNCE_TABLE, ARCADE_CHALLENGE_TABLE, ARCADE_CHALLENGE_CHAMP_TABLE),
	'files' 			=> array(
	'new_html_key'		=> 'v=3',
		'core'			=> array(
			'arcade.php',
			'newscore.php',
			'viewgame.php',
			'adm/style/acp_arcade_main.html',
			'adm/style/acp_arcade_games.html',
			'adm/style/acp_arcade_global_announce.html',
			'adm/style/acp_arcade_manage.html',
			'adm/style/acp_arcade_permissions.html',
			'adm/style/acp_arcade_utilities.html',
			'adm/style/acp_users_arcade.html',
			'adm/style/confirm_body_move_arcade_games.html',
			'adm/style/permission_arcade_category_copy.html',
			'arcade/arcadelib/getHiScores.php',
			'arcade/arcadelib/ibproArcadeLib.conf',
			'arcade/arcadelib/score2.swf',
			'arcade/arcadelib/index.htm',
			'arcade/backup/.htaccess',
			'arcade/backup/index.htm',
			'arcade/gamedata/index.htm',
			'arcade/games/index.htm',
			'arcade/images/1st.gif',
			'arcade/images/2nd.gif',
			'arcade/images/3rd.gif',
			'arcade/images/trophy.gif',
			'arcade/images/add_favorite.png',
			'arcade/images/automatic.png',
			'arcade/images/big.png',
			'arcade/images/facebook.gif',
			'arcade/images/logo.png',
			'arcade/images/logo_transparent.png',
			'arcade/images/new_game.gif',
			'arcade/images/noavatar.gif',
			'arcade/images/open_close.png',
			'arcade/images/remove_favorite.png',
			'arcade/images/small.png',
			'arcade/images/spacer.gif',
			'arcade/images/twitter.gif',
			'arcade/images/star.png',
			'arcade/images/popup.png',
			'arcade/images/loading1.gif',
			'arcade/images/loading2.gif',
			'arcade/images/index.htm',
			'arcade/images/cats/index.htm',
			'arcade/includes/.htaccess',
			'arcade/includes/arcade.php',
			'arcade/includes/auth.php',
			'arcade/includes/auth_admin.php',
			'arcade/includes/cache.php',
			'arcade/includes/class.php',
			'arcade/includes/class_admin.php',
			'arcade/includes/class_challenge.php',
			'arcade/includes/common.php',
			'arcade/includes/constants.php',
			'arcade/includes/default_install_file.php',
			'arcade/includes/download.php',
			'arcade/includes/functions.php',
			'arcade/includes/functions_files.php',
			'arcade/includes/games.php',
			'arcade/includes/index.htm',
			'arcade/includes/play.php',
			'arcade/includes/protect.php',
			'arcade/includes/reports.php',
			'arcade/includes/score.php',
			'arcade/includes/scoretype.php',
			'arcade/includes/session.php',
			'arcade/includes/stats.php',
			'arcade/includes/viewonline.php',
			'arcade/install/index.htm',
			'arcade/js/index.htm',
			'arcade/js/ajax.php',
			'arcade/js/arcade.js',
			'arcade/js/swfobject.js',
			'arcade/swf/arcade.swf',
			'arcade/swf/flash_player_update.swf',
			'arcade/swf/score.swf',
			'arcade/swf/.htaccess',
			'arcade/swf/index.htm',
			'arcade/index.htm',
			'games/index.htm',
			'includes/acp/acp_arcade_settings.php',
			'includes/acp/acp_arcade_main.php',
			'includes/acp/acp_arcade_games.php',
			'includes/acp/acp_arcade_manage.php',
			'includes/acp/acp_arcade_permissions.php',
			'includes/acp/acp_arcade_permission_roles.php',
			'includes/acp/acp_arcade_utilities.php',
			'includes/acp/info/acp_arcade_settings.php',
			'includes/acp/info/acp_arcade_main.php',
			'includes/acp/info/acp_arcade_games.php',
			'includes/acp/info/acp_arcade_manage.php',
			'includes/acp/info/acp_arcade_permissions.php',
			'includes/acp/info/acp_arcade_permission_roles.php',
			'includes/acp/info/acp_arcade_utilities.php',
			'includes/ucp/ucp_arcade.php',
			'includes/ucp/info/ucp_arcade.php',
		),
		'langs'			=> array(
			'en'			=> array(
			'language/en/mods/arcade.php',
			'language/en/mods/help_arcade.php',
			'language/en/mods/info_acp_arcade.php',
			'language/en/mods/info_ucp_arcade.php',
			'language/en/mods/permissions_arcade.php',
			),
			'hu'			=> array(
			'language/hu/mods/arcade.php',
			'language/hu/mods/help_arcade.php',
			'language/hu/mods/info_acp_arcade.php',
			'language/hu/mods/info_ucp_arcade.php',
			'language/hu/mods/permissions_arcade.php',
			),
			'de_x_sie'		=> array(
			'language/de_x_sie/mods/arcade.php',
			'language/de_x_sie/mods/help_arcade.php',
			'language/de_x_sie/mods/info_acp_arcade.php',
			'language/de_x_sie/mods/info_ucp_arcade.php',
			'language/de_x_sie/mods/permissions_arcade.php',
			),
		),
		'styles'			=> array(
			'prosilver'			=> array(
				'styles/prosilver/template/ucp_arcade_settings.html',
				'styles/prosilver/template/ucp_arcade_post.html',
				'styles/prosilver/template/ucp_arcade_favorites.html',
				'styles/prosilver/template/arcade/challenge_body.html',
				'styles/prosilver/template/arcade/download_body.html',
				'styles/prosilver/template/arcade/header_body.html',
				'styles/prosilver/template/arcade/index_body.html',
				'styles/prosilver/template/arcade/info_body.html',
				'styles/prosilver/template/arcade/jumpbox.html',
				'styles/prosilver/template/arcade/arcadelist_body.html',
				'styles/prosilver/template/arcade/login_cat.html',
				'styles/prosilver/template/arcade/online_body.html',
				'styles/prosilver/template/arcade/play_body.html',
				'styles/prosilver/template/arcade/popup_body.html',
				'styles/prosilver/template/arcade/reports_body.html',
				'styles/prosilver/template/arcade/score_body.html',
				'styles/prosilver/template/arcade/script_body.html',
				'styles/prosilver/template/arcade/stats.html',
				'styles/prosilver/template/arcade/stats_body.html',
				'styles/prosilver/template/arcade/footer_body.html',
				'styles/prosilver/template/arcade/global_announce.html',
				'styles/prosilver/template/arcade/message_body.html',
				'styles/prosilver/template/arcade/index.htm',
				'styles/prosilver/theme/arcade.css',
				'styles/prosilver/theme/images/icon_arcade.gif',
				'styles/prosilver/theme/images/icon_arcade_challenge.gif',
				'styles/prosilver/theme/images/arcade/star.png',
				'styles/prosilver/theme/images/arcade/add_favorite.png',
				'styles/prosilver/theme/images/arcade/remove_favorite.png',
				'styles/prosilver/theme/images/arcade/loading1.gif',
				'styles/prosilver/theme/images/arcade/loading2.gif',
				'styles/prosilver/theme/images/arcade/open_close.png',
				'styles/prosilver/theme/images/arcade/popup.png',
				'styles/prosilver/theme/images/arcade/index.htm',
				'styles/prosilver/theme/images/arcade/cats/index.htm',
			),
			'subsilver2'		=> array(
				'styles/subsilver2/template/ucp_arcade_settings.html',
				'styles/subsilver2/template/ucp_arcade_post.html',
				'styles/subsilver2/template/ucp_arcade_favorites.html',
				'styles/subsilver2/template/arcade/challenge_body.html',
				'styles/subsilver2/template/arcade/download_body.html',
				'styles/subsilver2/template/arcade/header_body.html',
				'styles/subsilver2/template/arcade/index_body.html',
				'styles/subsilver2/template/arcade/info_body.html',
				'styles/subsilver2/template/arcade/jumpbox.html',
				'styles/subsilver2/template/arcade/arcadelist_body.html',
				'styles/subsilver2/template/arcade/login_cat.html',
				'styles/subsilver2/template/arcade/online_body.html',
				'styles/subsilver2/template/arcade/play_body.html',
				'styles/subsilver2/template/arcade/popup_body.html',
				'styles/subsilver2/template/arcade/reports_body.html',
				'styles/subsilver2/template/arcade/score_body.html',
				'styles/subsilver2/template/arcade/script_body.html',
				'styles/subsilver2/template/arcade/stats.html',
				'styles/subsilver2/template/arcade/stats_body.html',
				'styles/subsilver2/template/arcade/footer_body.html',
				'styles/subsilver2/template/arcade/global_announce.html',
				'styles/subsilver2/template/arcade/message_body.html',
				'styles/subsilver2/template/arcade/index.htm',
				'styles/subsilver2/theme/arcade.css',
				'styles/subsilver2/theme/images/icon_mini_arcade.gif',
				'styles/subsilver2/theme/images/icon_mini_arcade_challenge.gif',
				'styles/subsilver2/theme/images/arcade/star.png',
				'styles/subsilver2/theme/images/arcade/add_favorite.png',
				'styles/subsilver2/theme/images/arcade/remove_favorite.png',
				'styles/subsilver2/theme/images/arcade/loading1.gif',
				'styles/subsilver2/theme/images/arcade/loading2.gif',
				'styles/subsilver2/theme/images/arcade/open_close.png',
				'styles/subsilver2/theme/images/arcade/popup.png',
				'styles/subsilver2/theme/images/arcade/index.htm',
				'styles/subsilver2/theme/images/arcade/cats/index.htm',
			),
			'prosilver Special Edition'		=> array(
				'styles/prosilver_se/template/arcade/header_body.html',
				'styles/prosilver_se/template/arcade/stats_body.html',
				'styles/prosilver_se/template/arcade/index.htm',
				'styles/prosilver_se/theme/arcade.css',
				'styles/prosilver_se/theme/images/icon_arcade.gif',
				'styles/prosilver_se/theme/images/icon_arcade_challenge.gif',
				'styles/prosilver_se/theme/images/arcade/star.png',
				'styles/prosilver_se/theme/images/arcade/add_favorite.png',
				'styles/prosilver_se/theme/images/arcade/remove_favorite.png',
				'styles/prosilver_se/theme/images/arcade/loading1.gif',
				'styles/prosilver_se/theme/images/arcade/loading2.gif',
				'styles/prosilver_se/theme/images/arcade/open_close.png',
				'styles/prosilver_se/theme/images/arcade/popup.png',
				'styles/prosilver_se/theme/images/arcade/index.htm',
				'styles/prosilver_se/theme/images/arcade/cats/index.htm',
			),
		),
	),
	'old_files'		=> array(
		'core'	=> array(
			'adm/style/acp_arcade.html',
			'arcade/images/star1.gif',
			'arcade/images/star2.gif',
			'arcade/images/favorite.gif',
			'arcade/images/remove_favorite.gif',
			'arcade/includes/ajax.php',
			'arcade/arcadelib/arcadelogo.jpg',
			'includes/auth_arcade.php',
			'includes/acp/auth_arcade.php',
			'includes/acp/acp_arcade.php',
			'includes/acp/info/acp_arcade.php',
			'includes/arcade/arcade_admin_class.php',
			'includes/arcade/arcade_cache.php',
			'includes/arcade/arcade_class.php',
			'includes/arcade/arcade_common.php',
			'includes/arcade/arcade_constants.php',
			'includes/arcade/arcade_download.php',
			'includes/arcade/arcade_games.php',
			'includes/arcade/arcade_play.php',
			'includes/arcade/arcade_protect.php',
			'includes/arcade/arcade_reports.php',
			'includes/arcade/arcade_score.php',
			'includes/arcade/arcade_scoretype.php',
			'includes/arcade/arcade_stats.php',
			'includes/arcade/arcade_viewonline.php',
			'includes/arcade/functions_files.php',
			'includes/arcade/functions_arcade.php',
			'includes/arcade/swfobject.js',
			'includes/arcade/scoretype/ibpro.php',
			'includes/arcade/scoretype/ibprov3.php',
			'includes/arcade/scoretype/v3arcade.php',

			'adm/style/acp_arcade_challenge_main.html',
			'adm/style/acp_arcade_challenge_report.html',
			'arcade/challenge_menu/index.htm',
			'arcade/challenge_menu/en/chall_clear.swf',
			'arcade/challenge_menu/en/chall_dark.swf',
			'arcade/challenge_menu/en/chall_default.swf',
			'arcade/challenge_menu/en/chall_green.swf',
			'arcade/challenge_menu/en/index.htm',
			'arcade/challenge_menu/hu/chall_clear.swf',
			'arcade/challenge_menu/hu/chall_dark.swf',
			'arcade/challenge_menu/hu/chall_default.swf',
			'arcade/challenge_menu/hu/chall_green.swf',
			'arcade/challenge_menu/hu/index.htm',
			'includes/acp/info/acp_arcade_challenge.php',
			'includes/acp/acp_arcade_challenge.php',
			'includes/challenge/cache.php',
			'includes/challenge/common.php',
			'includes/challenge/constants.php',
			'includes/challenge/functions_admin.php',
			'includes/challenge/functions_arcade.php',
			'includes/challenge/functions_arcade_admin.php',
			'includes/challenge/functions_ca.php',
			'includes/challenge/functions_challenge.php',
			'includes/challenge/index.htm',
			'includes/challenge/report.php',
			'includes/challenge/stats.php',
			'includes/challenge/viewonline.php',
			'includes/ucp/info/ucp_arcade_challenge.php',
			'includes/ucp/ucp_arcade_challenge.php',
			'language/en/mods/arcade_challenge.php',
			'language/en/mods/info_acp_arcade_challenge.php',
			'language/en/mods/info_ucp_arcade_challenge.php',
			'language/en/mods/install_ultimate_challenge.php',
			'language/en/mods/permissions_challenge.php',
			'language/hu/mods/arcade_challenge.php',
			'language/hu/mods/info_acp_arcade_challenge.php',
			'language/hu/mods/info_ucp_arcade_challenge.php',
			'language/hu/mods/install_ultimate_challenge.php',
			'language/hu/mods/permissions_challenge.php',
			'challenge.php',
		),
		'styles'			=> array(
			'prosilver'						=> array(
				'styles/prosilver/template/arcade/arcade_version_body.html',
				'styles/prosilver/template/arcade/arcade_download_body.html',
				'styles/prosilver/template/arcade/arcade_header_body.html',
				'styles/prosilver/template/arcade/arcade_index_body.html',
				'styles/prosilver/template/arcade/arcade_info_body.html',
				'styles/prosilver/template/arcade/arcade_jumpbox.html',
				'styles/prosilver/template/arcade/arcade_list_body.html',
				'styles/prosilver/template/arcade/arcade_login_cat.html',
				'styles/prosilver/template/arcade/arcade_online_body.html',
				'styles/prosilver/template/arcade/arcade_play_body.html',
				'styles/prosilver/template/arcade/arcade_reports_body.html',
				'styles/prosilver/template/arcade/arcade_score_body.html',
				'styles/prosilver/template/arcade/arcade_stats_body.html',

				'styles/prosilver/template/challenge/challenge_body.html',
				'styles/prosilver/template/challenge/challenge_footer.html',
				'styles/prosilver/template/challenge/challenge_header.html',
				'styles/prosilver/template/challenge/challenge_index.html',
				'styles/prosilver/template/challenge/challenge_message.html',
				'styles/prosilver/template/challenge/challenge_options.html',
				'styles/prosilver/template/challenge/challenge_popup.html',
				'styles/prosilver/template/challenge/challenge_report.html',
				'styles/prosilver/template/challenge/challenge_stats.html',
				'styles/prosilver/template/challenge/index.htm',
				'styles/prosilver/template/ucp_arcade_challenge.html',
				'styles/prosilver/theme/images/icon_challenge.gif',
				'styles/prosilver/theme/challenge.css',
			),
			'subsilver2'					=> array(
				'styles/subsilver2/template/arcade/arcade_version_body.html',
				'styles/subsilver2/template/arcade/arcade_download_body.html',
				'styles/subsilver2/template/arcade/arcade_header_body.html',
				'styles/subsilver2/template/arcade/arcade_index_body.html',
				'styles/subsilver2/template/arcade/arcade_info_body.html',
				'styles/subsilver2/template/arcade/arcade_jumpbox.html',
				'styles/subsilver2/template/arcade/arcade_list_body.html',
				'styles/subsilver2/template/arcade/arcade_login_cat.html',
				'styles/subsilver2/template/arcade/arcade_online_body.html',
				'styles/subsilver2/template/arcade/arcade_play_body.html',
				'styles/subsilver2/template/arcade/arcade_reports_body.html',
				'styles/subsilver2/template/arcade/arcade_score_body.html',
				'styles/subsilver2/template/arcade/arcade_stats_body.html',

				'styles/subsilver2/template/challenge/challenge_body.html',
				'styles/subsilver2/template/challenge/challenge_footer.html',
				'styles/subsilver2/template/challenge/challenge_header.html',
				'styles/subsilver2/template/challenge/challenge_index.html',
				'styles/subsilver2/template/challenge/challenge_message.html',
				'styles/subsilver2/template/challenge/challenge_options.html',
				'styles/subsilver2/template/challenge/challenge_popup.html',
				'styles/subsilver2/template/challenge/challenge_report.html',
				'styles/subsilver2/template/challenge/challenge_stats.html',
				'styles/subsilver2/template/challenge/index.htm',
				'styles/subsilver2/template/ucp_arcade_challenge.html',
				'styles/subsilver2/theme/images/icon_challenge.gif',
				'styles/subsilver2/theme/challenge.css',
			),
			'prosilver Special Edition'		=> array(
				'styles/prosilver_se/template/arcade/arcade_header_body.html',
			),
		),
	),

// files edits
	'edits'	=> array(
		'core'		=> array(

// common.php edit
			'common.php' => array(
				'include($phpbb_root_path . \'arcade/includes/functions.\' . $phpEx);'),

// index.php edit
			'index.php' => array(
				'$arcade_act	= strtolower(request_var(\'act\', \'\'));
$arcade_do	= strtolower(request_var(\'do\', \'\'));

$scoretype	= ($arcade_act == \'arcade\' && $arcade_do == \'newscore\') ? IBPRO_GAME : (($arcade_act == \'arcadelib\') ? ARCADELIB_GAME : ((strtolower(request_var(\'autocom\', \'\')) == \'arcade\') ? IBPROV3_GAME : false));

if ($scoretype)
{
	define(\'IN_PHPBB_ARCADE\', true);
	include($phpbb_root_path . \'arcade/includes/scoretype.\' . $phpEx);
}'),

// memberlist.php edit
			'memberlist.php' => array(
				'		if ($arcade_highscores = arcade_display_data(\'highscores\', array(\'memberlist\', $user_id)))
		{
			$template->assign_vars($arcade_highscores);
		}'),

// ucp.php edits
			'ucp.php' => array(
				'arcade_ghost_permissions($user_id, $user_row[\'username\'])',
				'arcade_restore_perm();'),

// viewonline.php edit
			'viewonline.php' => array(
				'		case \'arcade\':
			include($phpbb_root_path . \'arcade/includes/viewonline.\' . $phpEx);
		break;'),

// viewtopic.php edits
			'viewtopic.php' => array(
				'	if ($arcade_highscores = arcade_display_data(\'highscores\', array(\'viewtopic\', $poster_id)))
	{
		$postrow = array_merge($postrow, $arcade_highscores);
	}'),

// adm/style/acp_users.html edit
			'adm/style/acp_users.html' => array(
				'<!-- ELSEIF S_ARCADE -->

<!-- INCLUDE acp_users_arcade.html -->'),

// adm/style/admin.css edit
			'adm/style/admin.css' => array(
				'.arcade-userguide {
	font-size: 0.85em;
	padding-bottom: 5px;
	margin-bottom: 0.7em;
	line-height: 1.40em;
}

.arcade-userguide ul{
	margin-bottom: 0;
	padding-bottom: 0;
}

.arcade-userguide li{
	font-size: 1em;
}'),

// includes/auth.php edit
			'includes/auth.php' => array(
				'		arcade_acl_clear_prefetch($user_id);'),

// includes/constants.php edit
			'includes/constants.php' => array(
				'include($phpbb_root_path . \'arcade/includes/constants.\' . $phpEx);'),

// includes/functions.php edit
			'includes/functions.php' => array(
			'	if (!defined(\'USE_ARCADE_MENU\'))
	{
		arcade_display_data(\'menu\');
	}'),

// includes/functions_privmsgs.php edits
			'includes/functions_privmsgs.php' => array(
				'	global $arcade, $arcade_notifypm;',
				'		if (isset($arcade) && isset($arcade_notifypm))
		{
			$arcade->notifypm_check($row[\'user_id\'], $row[\'user_notify_pm\']);
		}'),

// includes/functions_user.php edits
			'includes/functions_user.php' => array(
				'	$cache->destroy(\'sql\', ARCADE_CHALLENGE_CHAMP_TABLE);',
				'	arcade_user_add($user_id);',
				'	arcade_delete_user($user_id);',
				'		arcade_update_user_colour($user_id_ary, $sql_ary[\'user_colour\']);'),

// includes/acp/acp_users.php edit
			'includes/acp/acp_users.php' => array(
				'			case \'arcade\':
				global $arcade, $auth_arcade, $arcade_cache, $arcade_config;

				if (!isset($arcade))
				{
					include($phpbb_root_path . \'arcade/includes/common.\' . $phpEx);
				}

				if ($arcade->user_set($user_row))
				{
					add_log(\'admin\', \'LOG_ARCADE_USER_SET_UPDATE\', $user_row[\'username\']);
					trigger_error($user->lang[\'USER_OVERVIEW_UPDATED\'] . adm_back_link($this->u_action . \'&amp;u=\' . $user_id));
				}
			break;'),

// includes/acp/info/acp_users.php edit
			'includes/acp/info/acp_users.php' => array(
				'				\'arcade\'		=> array(\'title\' => \'ACP_USER_ARCADE\', \'auth\' => \'acl_a_user\', \'display\' => false, \'cat\' => array(\'ACP_CAT_USERS\')),'),

// includes/ucp/ucp_profile.php edit
			'includes/ucp/ucp_profile.php' => array(
				'							arcade_cache_purge();'),

// includes/acp/acp_styles.php edit
			'includes/acp/acp_styles.php' => array(
				'				$sql = \'UPDATE \' . ARCADE_CATS_TABLE . "
					SET cat_style = $new_id
					WHERE cat_style = $style_id";
				$db->sql_query($sql);
				$cache->destroy(\'sql\', ARCADE_CATS_TABLE);
				$cache->destroy(\'_arcade_cats\');'),
		),

// langs files edits
		'langs'		=> array(
			'en'	=> array(),
			'hu'	=> array(),
			'de_x_sie'	=> array(),
		),
// styles files edits
		'styles'		=> array(
			'prosilver'		=> array(

// styles/prosilver/template/memberlist_view.html edit
				'styles/prosilver/template/memberlist_view.html' => array(
					'			<!-- IF S_HAS_ARCADE_DISPLAY -->
				<dt>{L_ARCADE_HIGHSCORES}:</dt> <dd>{ARCADE_TOTAL_HIGHSCORES}<!-- IF S_ARCADE_STATS --> | <strong><a href="{U_ARCADE_STATS}">{L_ARCADE_VIEW_USERS_STATS}</a></strong><!-- ENDIF --></dd>
				<dt>{L_ARCADE_CHALLENGE_WINS}:</dt> <dd>{TOTAL_CHALLENGE_WINS}<!-- IF S_CHALLENGE_STATS --> | <strong><a href="{U_CHALLENGE_STATS}">{L_ARCADE_CHALLENGE_VIEW_USERS_STATS}</a></strong><!-- ENDIF --></dd>
			<!-- ENDIF -->'),

// styles/prosilver/template/overall_header.html edits
				'styles/prosilver/template/overall_header.html' => array(
					'{ARCADE_META}',
					'<!-- INCLUDE arcade/script_body.html -->',
					'				<!-- IF S_DISPLAY_ARCADE -->
					<li class="icon-arcade"><a href="{U_ARCADE}" title="{L_ARCADE_EXPLAIN}">{L_ARCADE}</a></li>
					<!-- IF S_DISPLAY_ARCADE_CHALLENGE -->
						<li class="icon-arcade-challenge"><a href="{U_ARCADE_CHALLENGE}" title="{L_ARCADE_CHALLENGE_EXPLAIN}">{L_ARCADE_CHALLENGE}</a></li>
					<!-- ENDIF -->
				<!-- ENDIF -->',
					'<!-- INCLUDE arcade/info_body.html -->'),

// styles/prosilver/template/simple_header.html edit
				'styles/prosilver/template/simple_header.html' => array(
					'<!-- INCLUDE arcade/script_body.html -->'),

// styles/prosilver/template/viewtopic_body.html edit
				'styles/prosilver/template/viewtopic_body.html' => array(
					'		<!-- IF postrow.S_HAS_ARCADE_DISPLAY -->
			<dd><strong>{L_ARCADE_HIGHSCORES}:</strong> <!-- IF postrow.S_ARCADE_STATS --><a href="{postrow.U_ARCADE_STATS}">{postrow.ARCADE_TOTAL_HIGHSCORES}</a><!-- ELSE -->{postrow.ARCADE_TOTAL_HIGHSCORES}<!-- ENDIF --></dd>
			<dd><strong>{L_ARCADE_CHALLENGE_WINS}:</strong> <!-- IF postrow.S_CHALLENGE_STATS --><a href="{postrow.U_CHALLENGE_STATS}">{postrow.TOTAL_CHALLENGE_WINS}</a><!-- ELSE -->{postrow.TOTAL_CHALLENGE_WINS}<!-- ENDIF --></dd>
		<!-- ENDIF -->'),

// styles/prosilver/theme/bidi.css edit
				'styles/prosilver/theme/bidi.css' => array(
					'.rtl .icon-arcade, .rtl .icon-arcade-challenge,'),

// styles/prosilver/theme/buttons.css edit
				'styles/prosilver/theme/buttons.css' => array(
					'.icon-arcade, .icon-arcade-challenge,'),

// styles/prosilver/theme/colours.css edit
				'styles/prosilver/theme/colours.css' => array(
					'.icon-arcade					{ background-image: url("{T_THEME_PATH}/images/icon_arcade.gif"); }
.icon-arcade-challenge			{ background-image: url("{T_THEME_PATH}/images/icon_arcade_challenge.gif"); }'),
			),

			'subsilver2'	=> array(

// styles/subsilver2/template/memberlist_view.html edit
				'styles/subsilver2/template/memberlist_view.html' => array(
					'			<!-- IF S_HAS_ARCADE_DISPLAY -->
			<tr>
				<td class="gen" align="{S_CONTENT_FLOW_END}" valign="top" nowrap="nowrap">{L_ARCADE_HIGHSCORES}: </td>
				<td><b class="gen">{ARCADE_TOTAL_HIGHSCORES}</b><!-- IF S_ARCADE_STATS --><span class="genmed"><br /><a href="{U_ARCADE_STATS}">[ {L_ARCADE_VIEW_USERS_STATS} ]</a></span><!-- ENDIF --></td>
			</tr>
			<tr>
				<td class="gen" align="{S_CONTENT_FLOW_END}" valign="top" nowrap="nowrap">{L_ARCADE_CHALLENGE_WINS}: </td>
				<td><b class="gen">{TOTAL_CHALLENGE_WINS}</b><!-- IF S_CHALLENGE_STATS --><span class="genmed"><br /><a href="{U_CHALLENGE_STATS}">[ {L_ARCADE_CHALLENGE_VIEW_USERS_STATS} ]</a></span><!-- ENDIF --></td>
			</tr>
			<!-- ENDIF -->'),

// styles/subsilver2/template/overall_header.html edits
				'styles/subsilver2/template/overall_header.html' => array(
					'{ARCADE_META}',
					'<!-- INCLUDE arcade/script_body.html -->',
					'				<!-- IF S_DISPLAY_ARCADE -->
					<a href="{U_ARCADE}"><img src="{T_THEME_PATH}/images/icon_mini_arcade.gif" width="12" height="13" alt="*" /> {L_ARCADE}</a>&nbsp; &nbsp;
					<!-- IF S_DISPLAY_ARCADE_CHALLENGE -->
						<a href="{U_ARCADE_CHALLENGE}"><img src="{T_THEME_PATH}/images/icon_mini_arcade_challenge.gif" width="12" height="13" alt="*" /> {L_ARCADE_CHALLENGE}</a>&nbsp; &nbsp;
					<!-- ENDIF -->
				<!-- ENDIF -->',
					'<!-- INCLUDE arcade/info_body.html -->'),

// styles/subsilver2/template/simple_header.html edit
				'styles/subsilver2/template/simple_header.html' => array(
					'<!-- INCLUDE arcade/script_body.html -->'),

// styles/subsilver2/template/viewtopic_body.html edit
				'styles/subsilver2/template/viewtopic_body.html' => array(
					'					<!-- IF postrow.S_HAS_ARCADE_DISPLAY -->
						<br /><b>{L_ARCADE_HIGHSCORES}:</b> <!-- IF postrow.S_ARCADE_STATS --><a href="{postrow.U_ARCADE_STATS}">{postrow.ARCADE_TOTAL_HIGHSCORES}</a><!-- ELSE -->{postrow.ARCADE_TOTAL_HIGHSCORES}<!-- ENDIF -->
						<br /><b>{L_ARCADE_CHALLENGE_WINS}:</b> <!-- IF postrow.S_CHALLENGE_STATS --><a href="{postrow.U_CHALLENGE_STATS}">{postrow.TOTAL_CHALLENGE_WINS}</a><!-- ELSE -->{postrow.TOTAL_CHALLENGE_WINS}<!-- ENDIF -->
					<!-- ENDIF -->'),
			),

			'prosilver Special Edition'	=> array(

// styles/prosilver_se/template/overall_header.html edits
				'styles/prosilver_se/template/overall_header.html' => array(
					'{ARCADE_META}',
					'<!-- INCLUDE arcade/script_body.html -->',
					'						<!-- IF S_DISPLAY_ARCADE -->
							<li class="icon-arcade"><a href="{U_ARCADE}" title="{L_ARCADE_EXPLAIN}">{L_ARCADE}</a></li>
							<!-- IF S_DISPLAY_ARCADE_CHALLENGE -->
								<li class="icon-arcade-challenge"><a href="{U_ARCADE_CHALLENGE}" title="{L_ARCADE_CHALLENGE_EXPLAIN}">{L_ARCADE_CHALLENGE}</a></li>
							<!-- ENDIF -->
						<!-- ENDIF -->',
					'<!-- INCLUDE arcade/info_body.html -->'),

// styles/prosilver_se/template/simple_header.html edit
				'styles/prosilver_se/template/simple_header.html' => array(
					'<!-- INCLUDE arcade/script_body.html -->'),

// styles/prosilver_se/theme/bidi.css edit
				'styles/prosilver_se/theme/bidi.css' => array(
					'.rtl .icon-arcade, .rtl .icon-arcade-challenge,'),

// styles/prosilver_se/theme/buttons.css edit
				'styles/prosilver_se/theme/buttons.css' => array(
					'.icon-arcade, .icon-arcade-challenge,'),

// styles/prosilver_se/theme/colours.css edit
				'styles/prosilver_se/theme/colours.css' => array(
					'.icon-arcade					{ background-image: url("{T_THEME_PATH}/images/icon_arcade.gif"); }
.icon-arcade-challenge			{ background-image: url("{T_THEME_PATH}/images/icon_arcade_challenge.gif"); }'),
			),
		),
	),
	'modules'		=> array(
		'acp' => array(
			'users'						=> array('arcade'),
			'arcade_utilities' 			=> array('errors', 'reports', 'users_banned', 'download_stats', 'global_announce', 'create_install', 'user_guide'),
			'arcade_games'				=> array('add_games', 'unpack_games', 'backup_games', 'downloads_games'),
			'arcade_settings'			=> array('settings', 'game', 'challenge', 'feature', 'apage', 'cpage', 'path'),
			'arcade_main'				=> array('main'),
			'arcade_manage'				=> array('category', 'games', 'users', 'challenges'),
			'arcade_permission_roles'	=> array('cat_roles', 'user_roles'),
			'arcade_permissions'		=> array('trace', 'setting_user_global', 'setting_group_global', 'setting_category_local', 'setting_user_local', 'setting_group_local', 'setting_category_copy', 'view_user_global', 'view_category_local'),
		),
		'ucp' => array(
			'arcade' => array('settings', 'post', 'favorites'),
		),
	),
	'alter_db' 		=> array(
		'current'	=> array(),
		'old'		=> array(
			USERS_TABLE						=> array('user_arcade_permissions', 'user_arcade_perm_from', 'user_arcade_pm', 'games_per_page', 'games_sort_dir', 'games_sort_order', 'user_challenge_on', 'user_challenge_pm_on', 'user_challenge_stat'),
			ARCADE_GAMES_TABLE				=> array('game_files'),
			ARCADE_USERS_TABLE				=> array('user_arcade_pm'),
			ARCADE_CHALLENGE_CHAMP_TABLE	=> array('champ_points'),
			ARCADE_ERRORS_TABLE				=> array('game_type', 'submitted_game_type'),
		),
	),
);

?>