<?php
/**
*
* acp_permissions_arcade  (phpBB Arcade Permission Set) [German]
*
* @package language
* @version $Id: permissions_arcade.php 1974 2012-03-13 15:48:18Z tuxman $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine
// Some characters you may want to copy&paste: ’ » “ ” …

/**
*	MODDERS PLEASE NOTE
*	
*	You are able to put your permission sets into a separate file too by
*	prefixing the new file with permissions_ and putting it into the acp
*	language folder.
*
*	An example of how the file could look like:
*
*	<code>
*
*	if (empty($lang) || !is_array($lang))
*	{
*		$lang = array();
*	}
*
*	// Adding new category
*	$lang['permission_cat']['bugs'] = 'Bugs';
*
*	// Adding new permission set
*	$lang['permission_type']['bug_'] = 'Bug Permissions';
*
*	// Adding the permissions
*	$lang = array_merge($lang, array(
*		'acl_bug_view'		=> array('lang' => 'Can view bug reports', 'cat' => 'bugs'),
*		'acl_bug_post'		=> array('lang' => 'Can post bugs', 'cat' => 'post'), // Using a phpBB category here
*	));
*
*	</code>
*/

// Define categories and permission types
$lang['permission_cat']['arcade']	= 'Spielhalle';
$lang['permission_type']['c_']		= 'Lokale Kategorienbefugnisse';

// Admin Permissions
$lang = array_merge($lang, array(
	'acl_a_arcade'							=> array('lang' => 'Kann Spielhalle zurücksetzen'							, 'cat' => 'arcade'),
	'acl_a_arcade_backup'					=> array('lang' => 'Kann Spielhallenkategorien sichern.'					, 'cat' => 'arcade'),
	'acl_a_arcade_cat'						=> array('lang' => 'Kann Kategorien hinzufügen/ändern'						, 'cat' => 'arcade'),
	'acl_a_arcade_delete_cat'				=> array('lang' => 'Kann Kategorien löschen'								, 'cat' => 'arcade'),
	'acl_a_arcade_delete_game'				=> array('lang' => 'Kann Spiele löschen'									, 'cat' => 'arcade'),
	'acl_a_arcade_game'						=> array('lang' => 'Kann Spiele hinzufügen/ändern'							, 'cat' => 'arcade'),
	'acl_a_arcade_points_settings'			=> array('lang' => 'Kann Punkteeinstellungen ändern'						, 'cat' => 'arcade'),
	'acl_a_arcade_utilities'				=> array('lang' => 'Kann Werkzeuge nutzen'									, 'cat' => 'arcade'),
	'acl_a_arcade_user'						=> array('lang' => 'Kann Benutzer verwalten'								, 'cat' => 'arcade'),
	'acl_a_arcade_settings'					=> array('lang' => 'Kann Spielhalleneinstellungen verwalten'				, 'cat' => 'arcade'),
	'acl_a_cauth'							=> array('lang' => 'Kann Befugnisklasse ändern'								, 'cat' => 'arcade'),
));

// User Permissions
$lang = array_merge($lang, array(
	'acl_u_arcade'							=> array('lang' => 'Kann die Spielhalle benutzen'							, 'cat' => 'arcade'),
	'acl_u_arcade_challenge'				=> array('lang' => 'Kann sich duellieren'									, 'cat' => 'arcade'),
	'acl_u_arcade_download'					=> array('lang' => 'Kann Spiele herunterladen'								, 'cat' => 'arcade'),
	'acl_u_arcade_favorites'				=> array('lang' => 'Kann Favoriten hinzufügen/ändern'						, 'cat' => 'arcade'),
	'acl_u_arcade_ignoreflood_search'		=> array('lang' => 'Kann die Suchbeschränkungen umgehen'					, 'cat' => 'arcade'),
	'acl_u_arcade_popup'					=> array('lang' => 'Kann Spiele in einem neuen Fenster spielen'				, 'cat' => 'arcade'),
	'acl_u_arcade_pm'						=> array('lang' => 'Kann bei Verlust einer Trophäe eine private Nachricht erhalten', 'cat' => 'arcade'),
	'acl_u_arcade_resolution'				=> array('lang' => 'Kann Spielauflösung ändern'								, 'cat' => 'arcade'),
	'acl_u_arcade_search'					=> array('lang' => 'Kann in der Spielhalle suchen'							, 'cat' => 'arcade'),
	'acl_u_arcade_view_whoisplaying'		=> array('lang' => 'Kann sehen, wer gerade spielt'							, 'cat' => 'arcade'),
	'acl_u_arcade_viewstats'				=> array('lang' => 'Kann Spielestatistik ansehen'							, 'cat' => 'arcade'),
));

// Category Permissions
$lang = array_merge($lang, array(
	'acl_c_challenge_playing_games'			=> array('lang' => 'Kann bei ausstehendem Wettbewerb andere Spiele spielen'	, 'cat' => 'arcade'),
	'acl_c_challenge_start_game_warning'	=> array('lang' => 'Kann bei Spielstart die Warnung wegen eines ausstehenden Wettbewerbs ignorieren.', 'cat' => 'arcade'),
	'acl_c_comment'							=> array('lang' => 'Kann Spiele kommentieren'								, 'cat' => 'arcade'),
	'acl_c_download'						=> array('lang' => 'Kann Spiele herunterladen'								, 'cat' => 'arcade'),
	'acl_c_ignorecontrol'					=> array('lang' => 'Kann Spielkontrolle umgehen'							, 'cat' => 'arcade'),
	'acl_c_ignoreflood_download'			=> array('lang' => 'Kann Downloadbeschränkungen umgehen'					, 'cat' => 'arcade'),
	'acl_c_ignoreflood_play'				=> array('lang' => 'Kann Spielbeschränkungen umgehen'						, 'cat' => 'arcade'),
	'acl_c_list'							=> array('lang' => 'Kann Kategorie auflisten'								, 'cat' => 'arcade'),
	'acl_c_play'							=> array('lang' => 'Kann Spiele spielen'									, 'cat' => 'arcade'),
	'acl_c_playfree'						=> array('lang' => 'Kann Spiele kostenlos spielen'							, 'cat' => 'arcade'),
	'acl_c_downloadfree'					=> array('lang' => 'Kann Spiele kostenlos herunterladen'					, 'cat' => 'arcade'),
	'acl_c_re_rate'							=> array('lang' => 'Kann eigene Bewertungen ändern'							, 'cat' => 'arcade'),
	'acl_c_rate'							=> array('lang' => 'Kann Spiele bewerten'									, 'cat' => 'arcade'),
	'acl_c_report'							=> array('lang' => 'Kann Spiele melden'										, 'cat' => 'arcade'),
	'acl_c_score'							=> array('lang' => 'Kann Punkte übermitteln'								, 'cat' => 'arcade'),
	'acl_c_view'							=> array('lang' => 'Kann Kategorie ansehen'									, 'cat' => 'arcade'),
));

?>