<?php
/**
*
* acp permissions_arcade  (phpBB Arcade Permission Set) [Hungary]
*
* @package language
* @version $Id: permissions_arcade.php 2003 2012-03-15 23:16:42Z killbill $
* @copyright (c) 2008-2012 http://www.phpbbarcade.com
* @copyright (c) 2011-2012 http://jatek-vilag.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine
// Some characters you may want to copy&paste: ’ » “ ” …

/**
*	MODDERS PLEASE NOTE
*	
*	You are able to put your permission sets into a separate file too by
*	prefixing the new file with permissions_ and putting it into the acp
*	language folder.
*
*	An example of how the file could look like:
*
*	<code>
*
*	if (empty($lang) || !is_array($lang))
*	{
*		$lang = array();
*	}
*
*	// Adding new category
*	$lang['permission_cat']['bugs'] = 'Bugs';
*
*	// Adding new permission set
*	$lang['permission_type']['bug_'] = 'Bug Permissions';
*
*	// Adding the permissions
*	$lang = array_merge($lang, array(
*		'acl_bug_view'		=> array('lang' => 'Can view bug reports', 'cat' => 'bugs'),
*		'acl_bug_post'		=> array('lang' => 'Can post bugs', 'cat' => 'post'), // Using a phpBB category here
*	));
*
*	</code>
*/

// Define categories and permission types
$lang['permission_cat']['arcade']	= 'Játékterem';
$lang['permission_type']['c_']		= 'Játékterem helyi kategória jogosultságok';

// Admin Permissions
$lang = array_merge($lang, array(
	'acl_a_arcade'							=> array('lang' => 'Kezelheti az újraindításokat'							, 'cat' => 'arcade'),
	'acl_a_arcade_backup'					=> array('lang' => 'Készíthet biztonsági mentést a kategóriákról'			, 'cat' => 'arcade'),
	'acl_a_arcade_cat'						=> array('lang' => 'Kategóriát hozzáadhat illetve szerkesztheti'			, 'cat' => 'arcade'),
	'acl_a_arcade_delete_cat'				=> array('lang' => 'Kategóriákat törölheti'									, 'cat' => 'arcade'),
	'acl_a_arcade_delete_game'				=> array('lang' => 'Játékokat törölheti'									, 'cat' => 'arcade'),
	'acl_a_arcade_game'						=> array('lang' => 'Játékokat hozzáadhat illetve szerkesztheti'				, 'cat' => 'arcade'),
	'acl_a_arcade_points_settings'			=> array('lang' => 'Pontrendszer beállításokat módosíthatja'				, 'cat' => 'arcade'),
	'acl_a_arcade_utilities'				=> array('lang' => 'Használhatja a segéd funkciókat'						, 'cat' => 'arcade'),
	'acl_a_arcade_user'						=> array('lang' => 'Felhasználókat kezelheti'								, 'cat' => 'arcade'),
	'acl_a_arcade_settings'					=> array('lang' => 'Beállításokat módosíthatja'								, 'cat' => 'arcade'),
	'acl_a_cauth'							=> array('lang' => 'Jogosultságok beállításait módosíthatja'				, 'cat' => 'arcade'),
));

// User Permissions
$lang = array_merge($lang, array(
	'acl_u_arcade'							=> array('lang' => 'Használhatja a játéktermet'								, 'cat' => 'arcade'),
	'acl_u_arcade_challenge'				=> array('lang' => 'Használhatja a kihívást'								, 'cat' => 'arcade'),
	'acl_u_arcade_download'					=> array('lang' => 'Játékokat letöltheti'									, 'cat' => 'arcade'),
	'acl_u_arcade_favorites'				=> array('lang' => 'Használhatja a kedvenc funkciót'						, 'cat' => 'arcade'),
	'acl_u_arcade_ignoreflood_search'		=> array('lang' => 'Figyelmen kívül hagyhatja a keresési idő határt'		, 'cat' => 'arcade'),
	'acl_u_arcade_popup'					=> array('lang' => 'A játékokat játszhatja új ablakban'						, 'cat' => 'arcade'),
	'acl_u_arcade_pm'						=> array('lang' => 'Kaphat privát üzenetet trófea elvesztése esetén'		, 'cat' => 'arcade'),
	'acl_u_arcade_resolution'				=> array('lang' => 'Megváltoztathatja a játék felbontását'					, 'cat' => 'arcade'),
	'acl_u_arcade_search'					=> array('lang' => 'Használhatja a keresést'								, 'cat' => 'arcade'),
	'acl_u_arcade_view_whoisplaying'		=> array('lang' => 'Láthatja, hogy ép ki mivel játszik'						, 'cat' => 'arcade'),
	'acl_u_arcade_viewstats'				=> array('lang' => 'Megtekintheti a statisztikai adatokat'					, 'cat' => 'arcade'),
));

// Category Permissions
$lang = array_merge($lang, array(
	'acl_c_challenge_playing_games'			=> array('lang' => 'Játszhat játékokat, ha van folyamatban lévő kihívása'	, 'cat' => 'arcade'),
	'acl_c_challenge_start_game_warning'	=> array('lang' => 'Figyelmen kívül hagyhatja játék indításánál a figyelmeztetést, ha érkezett számára új kihívás', 'cat' => 'arcade'),
	'acl_c_comment'							=> array('lang' => 'Kommentálhatja a játékokat'								, 'cat' => 'arcade'),
	'acl_c_download'						=> array('lang' => 'Letöltheti a játékokat'									, 'cat' => 'arcade'),
	'acl_c_ignorecontrol'					=> array('lang' => 'Figyelmen kívül hagyhatja a hozzászólás korlátozást'	, 'cat' => 'arcade'),
	'acl_c_ignoreflood_download'			=> array('lang' => 'Figyelmen kívül hagyhatja a letöltési idő határt'		, 'cat' => 'arcade'),
	'acl_c_ignoreflood_play'				=> array('lang' => 'Figyelmen kívül hagyhatja a játszási idő határt'		, 'cat' => 'arcade'),
	'acl_c_list'							=> array('lang' => 'Kategóriákat láthatja'									, 'cat' => 'arcade'),
	'acl_c_play'							=> array('lang' => 'Játszhat a játékokkal'									, 'cat' => 'arcade'),
	'acl_c_playfree'						=> array('lang' => 'Játszhat ingyen a játékokkal'							, 'cat' => 'arcade'),
	'acl_c_downloadfree'					=> array('lang' => 'Letöltheti ingyen a játékokat'							, 'cat' => 'arcade'),
	'acl_c_re_rate'							=> array('lang' => 'Újra értékelheti a játékokat'							, 'cat' => 'arcade'),
	'acl_c_rate'							=> array('lang' => 'Értékelheti a játékokat'								, 'cat' => 'arcade'),
	'acl_c_report'							=> array('lang' => 'Használhatja a hibabejelentést'							, 'cat' => 'arcade'),
	'acl_c_score'							=> array('lang' => 'Az elért pontszámait elmentheti'						, 'cat' => 'arcade'),
	'acl_c_view'							=> array('lang' => 'Kategóriákban lévő játékokat láthatja'					, 'cat' => 'arcade'),
));

?>